-- $Id: levels.lua 1806 2015-10-22 01:46:05Z dsb $
-- ToME - Tales of Middle-Earth
-- Copyright (C) 2015 Scott Bigham
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Scott Bigham "Zizzo"
-- dsb-tome@killerbbunnies.org

newAchievement {
  id = 'CLEAR_DEATHWATCH',
  name = [[Death Wasn't Watching Too Closely]],
  show = 'name',
  desc = [[Killed the orc captains in Deathwatch and claimed their prize armor and weapon]],
  mode = 'player',
  can_gain = function(data, who, pickup)
    if not pickup or not pickup.define_as then return false end
    data[pickup.define_as] = true
    return data.LAGDUF_THE_SNAGA and
	   data.GRISHNAKH_THE_HILL_ORC and
	   data.GOLFIMBUL_THE_HILL_ORC_CHIEF and
	   data.THALKETTOTH and
	   data.OF_MAEDHROS and
	   data.CAMMITHRIM
  end,
}

newAchievement {
  id = 'CLEAR_ORC_TOWN',
  name = [[This Town Ain't Big Enough For the Both of Us]],
  show = 'name',
  desc = [[Slew Bolg in his orc fortress and claimed the Stone of Lore]],
  mode = 'player',
  can_gain = function(data, who, pickup)
    if not pickup or not pickup.define_as then return false end
    data[pickup.define_as] = true
    return data.BOLG_SON_OF_AZOG and data.OF_LORE
  end,
}

newAchievement {
  id = 'CLEAR_MACHINE',
  name = [[Ghost in the Machine]],
  show = 'name',
  desc = [[Retrieved the Boots of the Machine from the factory where they were built]],
  mode = 'player',
  can_gain = function(data, who, pickup)
    if not pickup or not pickup.define_as then return false end
    data[pickup.define_as] = true
    return data.OF_THE_MACHINE
  end,
}

newAchievement {
  id = 'CLEAR_GALLEON',
  name = [[Ice Breaker]],
  show = 'name',
  desc = [[Retrieved the Mage Staff of Forochel from an abandoned galleon in the Helcaraxë]],
  mode = 'player',
  can_gain = function(data, who, pickup)
    if not pickup or not pickup.define_as then return false end
    data[pickup.define_as] = true
    return data.OF_FOROCHEL
  end,
}

newAchievement {
  id = 'CLEAR_CRYPT',
  name = [[Tomb Raider]],
  show = 'name',
  desc = [[Slew Thuringwethil in the Crypt and retrieved Lúthien's cloak]],
  mode = 'player',
  can_gain = function(data, who, pickup)
    if not pickup or not pickup.define_as then return false end
    data[pickup.define_as] = true
    return data.THURINGWETHIL_THE_VAMPIRE_MESSENGER and data.OF_LUTHIEN
  end,
}

newAchievement {
  id = 'CLEAR_DIM_GATES',
  name = [[Ring of Fire]],
  show = 'name',
  desc = [[Retrieved Narya from the Dim Gates]],
  mode = 'player',
  can_gain = function(data, who, pickup)
    if not pickup or not pickup.define_as then return false end
    data[pickup.define_as] = true
    return data.OF_POWER_NARYA
  end,
}

newAchievement {
  id = 'CLEAR_NAMELESS',
  name = [[Been Through the Dungeon on a Level With No Name]],
  show = 'name',
  desc = [[Retrieved the Dragon Scale Mail 'Razorback' from a nameless level]],
  mode = 'player',
  can_gain = function(data, who, pickup)
    if not pickup or not pickup.define_as then return false end
    data[pickup.define_as] = true
    return data.RAZORBACK
  end,
}
