-- $Id: quests.lua 1896 2015-11-18 00:00:05Z dsb $
-- ToME - Tales of Middle-Earth
-- Copyright (C) 2012 Scott Bigham
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Scott Bigham "Zizzo"
-- dsb-tome@killerbbunnies.org

newAchievement {
  id = 'GONDOLIN_INVASION',
  name = 'Invasion Repelled',
  show = 'none',
  desc = [[Killed Maeglin before he could lead Morgoth's armies to the secret entrance to Gondolin.]],
}

newAchievement {
  id = 'KILL_MORGOTH',
  name = 'All Hail the Savior!',
  show = 'none',
  huge = true,
  desc = [[Slew Morgoth and saved Arda from darkness.]],
}

newAchievement {
  id = 'KILL_MORGOTH_EVIL',
  name = 'All Hail the Tyrant!',
  show = 'none',
  huge = true,
  desc = [[Slew Morgoth and took his place, covering Arda in darkness.]],
}

newAchievement {
  id = 'POISON_WATER',
  name = 'Pure Water',
  show = 'name',
  desc = [[Dispersed the poison from the Waters of Nimrodel and saved the Mallorns of Lothlorien.]],
}

newAchievement {
  id = 'LAST_ALLIANCE',
  name = 'Bridging the Void',
  show = 'name',
  desc = [[Established a permanent void jumpgate between Minas Anor and Gondolin, allowing the Last Alliance to exist.]],
}

newAchievement {
  id = 'ONE_RING',
  name = 'In the Fires of Mount Doom',
  show = 'none',
  huge = true,
  desc = [[Cast the One Ring into the fires of Mount Doom, destroying it and weakening Sauron.]],
}

newAchievement {
  id = 'ONE_RING_ALT',
  name = 'Always in the Last Place You Look',
  show = 'none',
  huge = true,
  desc = [[Got the One Ring from an alternate Ring-bearer.]],
}

newAchievement {
  id = 'ONE_RING_WEAR',
  name = 'The Ring is Mine!',
  show = 'none',
  huge = true,
  desc = [[Wore the One Ring and fell under its corrupting influence.]],
}

newAchievement {
  id = 'NAZGUL_KILL',
  name = 'Nine for Mortal Men Doomed to Die',
  show = 'none',
  huge = true,
  desc = [[Permanently killed all nine Nazgûl.]],
  mode = 'player',
  can_gain = function(data, who, nazgul)
    if not nazgul or not nazgul.define_as then return false end
    data[nazgul.define_as] = true
    return table.count(data) == 9
  end,
  track = function(self)
    return tstring { tostring(table.count(self)) , " / 9" }
  end
}

newAchievement {
  id = 'NARSIL',
  name = 'The Sword That Was Broken',
  show = 'name',
  desc = [[Found the lost sword Narsil and returned it to Aragorn to be reforged.]],
}

newAchievement {
  id = 'HOBBIT_MAZE',
  name = 'Rescuer of the Lost',
  show = 'name',
  desc = [[Rescued Merton Proudfoot from the depths of the Maze.]],
}

newAchievement {
  id = 'UVATHA_BREE',
  name = 'An Ominous Horseman',
  show = 'name',
  desc = [[Saved Bree from the dreadful Nazgûl Uvatha the Horseman.]]
}

newAchievement {
  id = 'RELIC_PIECE',
  name = 'A Piece of the Past',
  show = 'full',
  desc = [[Recovered a piece of a lost holy relic for your Vala.]],
  desc_undone = [[Complete a quest for your Vala.]],
}

newAchievement {
  id = 'RELIC_ERU',
  name = 'Holy Relic (Eru)',
  show = 'full',
  desc = [[Recovered all five pieces of the lost relic of Eru Ilúvatar.]],
  desc_undone = [[Recover a lost relic of Eru Ilúvatar.]],
}

newAchievement {
  id = 'RELIC_MANWE',
  name = 'Holy Relic (Manwë)',
  show = 'full',
  desc = [[Recovered all five pieces of the lost relic of Manwë Súlimo.]],
  desc_undone = [[Recover a lost relic of Manwë Súlimo.]],
}

newAchievement {
  id = 'RELIC_TULKAS',
  name = 'Holy Relic (Tulkas)',
  show = 'full',
  desc = [[Recovered all five pieces of the lost relic of Tulkas.]],
  desc_undone = [[Recover a lost relic of Tulkas.]],
}

newAchievement {
  id = 'RELIC_YAVANNA',
  name = 'Holy Relic (Yavanna)',
  show = 'full',
  desc = [[Recovered all five pieces of the lost relic of Yavanna Kementári.]],
  desc_undone = [[Recover a lost relic of Yavanna Kementári.]],
}

newAchievement {
  id = 'RELIC_MELKOR',
  name = 'Holy Relic (Melkor)',
  show = 'full',
  desc = [[Recovered all five pieces of the lost relic of Melkor Bauglir.]],
  desc_undone = [[Recover a lost relic of Melkor Bauglir.]],
}

newAchievement {
  id = 'NIRNAETH',
  name = 'Tears Unnumbered',
  show = 'none',
  desc = [[Cleared a path through Morgoth's troll armies in Nírnaeth Arnoediad, allowing Gondolin's armies to retreat safely.]],
}

newAchievement {
  id = 'NIRNAETH_KILL',
  name = 'Tears Numbered',
  show = 'none',
  desc = [[Slew most of Morgoth's troll armies in Nírnaeth Arnoediad, allowing Gondolin's armies to retreat safely.]],
}

newAchievement {
  id = 'NIRNAETH_SLAUGHTER',
  name = 'Tears Abated',
  show = 'none',
  desc = [[Completely wiped out Morgoth's troll armies in Nírnaeth Arnoediad, allowing Gondolin's armies to retreat safely.]],
}

newAchievement {
  id = 'KHAZAD_DUM_HOUSE',
  name = '...Dude.  Holy Crap.',
  show = 'name',
  desc = [[Cleared an abandoned mine in Khazad-dûm of the nasty creatures that lurked there, and claimed it as your home.]],
}

newAchievement {
  id = 'KHAZAD_DUM_TOWN',
  name = 'In the Shadow of Khazad-dûm',
  show = 'name',
  desc = [[Found the hidden Dwarven city of Khazad-dûm.]],
}
