-- $Id: attack_types.lua 1479 2015-07-08 01:09:16Z dsb $
-- ToME - Tales of Middle-Earth
-- Copyright (C) 2012 Scott Bigham
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Scott Bigham "Zizzo"
-- dsb-tome@killerbbunnies.org

-- Monster attack types extracted from T2's melee1.c

newAttackType {
  id = 'HIT',
  short_desc = 'hit',
  msg = " hits %s",
}

newAttackType {
  id = 'TOUCH',
  short_desc = 'touch',
  msg = " touches %s",
}

newAttackType {
  id = 'PUNCH',
  short_desc = 'punch',
  msg = " punches %s",
}

newAttackType {
  id = 'KICK',
  short_desc = 'kick',
  msg = " kicks %s",
}

newAttackType {
  id = 'CLAW',
  short_desc = 'claw',
  msg = " claws %s",
}

newAttackType {
  id = 'BITE',
  short_desc = 'bite',
  msg = " bites %s",
}

newAttackType {
  id = 'STING',
  short_desc = 'sting',
  msg = " stings %s",
}

newAttackType {
  id = 'XXX1',
  short_desc = 'xxx1',
  msg = " XXX1's %s",
}

newAttackType {
  id = 'BUTT',
  short_desc = 'butt',
  msg = " butts %s",
}

newAttackType {
  id = 'CRUSH',
  short_desc = 'crush',
  msg = " crushes %s",
}

newAttackType {
  id = 'ENGULF',
  short_desc = 'engulf',
  msg = " engulfs %s",
}

newAttackType {
  id = 'CHARGE',
  short_desc = 'charge',
  msg = " charges %s",
}

newAttackType {
  id = 'CRAWL',
  short_desc = 'crawl on target',
  msg = " crawls on %s",
  silent_miss = true,
}

newAttackType {
  id = 'DROOL',
  short_desc = 'drool',
  msg = " drools on %s",
  silent_miss = true,
  no_retal = true,
}

newAttackType {
  id = 'SPIT',
  short_desc = 'spit',
  msg = " spits on %s",
  silent_miss = true,
  no_retal = true,
}

newAttackType {
  id = 'EXPLODE',
  short_desc = 'explode',
  msg = " explodes",
  silent_miss = true,
}

newAttackType {
  id = 'GAZE',
  short_desc = 'gaze',
  msg = " gazes at %s",
  silent_miss = true,
  no_retal = true,
}

newAttackType {
  id = 'WAIL',
  short_desc = 'wail',
  msg = " wails at %s",
  silent_miss = true,
  no_retal = true,
}

newAttackType {
  id = 'SPORE',
  short_desc = 'release spores',
  msg = " releases spores at %s",
  silent_miss = true,
  no_retal = true,
}

newAttackType {
  id = 'XXX4',
  short_desc = 'xxx4',
  msg = " projects XXX4's at %s",
  silent_miss = true,
  no_retal = true,
}

newAttackType {
  id = 'BEG',
  short_desc = 'beg',
  msg = " begs %s for money",
  silent_miss = true,
  no_retal = true,
}

newAttackType {
  id = 'INSULT',
  short_desc = 'insult',
  msg = " insults %s",
  silent_miss = true,
  no_retal = true,
}

newAttackType {
  id = 'MOAN',
  short_desc = 'moan',
  msg = " moans at %s",
  silent_miss = true,
  no_retal = true,
}

newAttackType {
  id = 'SHOW',
  short_desc = 'sing',
  msg = " sings to %s",
  silent_miss = true,
  no_retal = true,
}
