-- $Id: melinda-proudfoot.lua 1053 2014-09-17 03:09:17Z dsb $
-- ToME - Tales of Middle-Earth
-- Copyright © 2012-2014 Scott Bigham
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Scott Bigham "Zizzo"
-- dsb-tome@killerbbunnies.org

local q = game.player:hasQuest('merton-proudfoot')

newChat {
  id = 'welcome',
  text = [[Excuse me, brave adventurer, could you help an old lady?]],
  answers = {
    { 'What do you need?', jump='merton' },
    { "Could.  Won't. [leave]" },
  },
}

newChat {
  id = 'merton',
  text = [[It's my boy Merton.  He got it into his fool head he's going to be an adventurer (meaning no disrespect to yourself, of course) and gone off exploring, and I haven't heard from him in days.]],
  answers = {
    { 'Where was he last seen?', jump='maze' },
    { 'Sucks to be him. [leave]' },
  },
}

newChat {
  id = 'maze',
  text = [[He said he was headed for that maze place south of town; that's where all the young adventurous types usually go.  I #{italic}#told#{normal}# him he ought to take more recall scrolls with him, but he never pays his elders any heed when he gets all het up.]],
  answers = {
    {
      [[I'll try to find him.]],
      action = function(npc, player)
	player:grantQuest('merton-proudfoot')
      end,
    },
  },
}

newChat {
  id = 'welcome_quest',
  text = [[Oh, hello, @playername@.  Any luck finding Merton?]],
  answers = {
    { [[I'm still looking for him.]] },
  },
}

newChat {
  id = 'give_rod_tip',
  text = [[Oh, bless you, @playername@!  My Merton's home, safe and sound, and he tells me you saved him.  Here, let me give you this.  I was going to give it to Merton, but he went off and bought one of his own, so maybe it'll do you some good.]],
  answers = {
    {
      'Thank you.',
      action = function(npc, player)
	-- TODO give player Rod Tip of Recall.
	player:setQuestStatus('merton-proudfoot', engine.Quest.DONE)
	-- TODO remove Melinda from map
      end,
  },
}

return not q and 'welcome' or q:isCompleted() and 'give_rod_tip' or 'welcome_quest'
