-- $Id: merton-proudfoot.lua 1053 2014-09-17 03:09:17Z dsb $
-- ToME - Tales of Middle-Earth
-- Copyright © 2012-2014 Scott Bigham
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Scott Bigham "Zizzo"
-- dsb-tome@killerbbunnies.org

newChat {
  id = 'welcome',
  text = [[Ah!  Please don't hurt me!]],
  answers = {
    [[I'm not going to hurt you.  Are you Merton Proudfoot?]],
    jump = 'no_recall',
  },
}

newChat {
  id = 'no_recall',
  text = [[Yes, how did you... oh, of course, someone in the town must have missed me, thank goodness!  I'm afraid I'm stuck here; my leg's broken, and those dratted mages burned the last of my Word of Recall scrolls.]],
  answers = {
    {
      [[#{italic}#(slaps forehead)#{normal}# I should have thought of that.  Stay here, I'll be right back.]],
      cond = function(npc, player)
	return not player:findInAllInventories('Scroll of Word of Recall')
      end,
    },
    {
      [[Here, you can have one of mine.]],
      cond = function(npc, player)
	return player:findInAllInventories('Scroll of Word of Recall')
      end,
      action = function(npc, player)
	-- TODO take ?oWoR from player.
      end,
      jump = 'recall',
    }
  },
}

newChat {
  id = 'recall',
  text = [[Oh, thank you!  #LIGHT_GREEN#*Merton reads the scroll and disappears.*#WHITE#]],
  answers = {
    {
      [[Good luck, kid.]],
      action = function(npc, player)
	player:setQuestStatus('merton-proudfoot', engine.Quest.COMPLETED)
	-- TODO remove Merton
      end,
    },
  },
}

return 'welcome'
