-- $Id: quest-thrain-finish.lua 1986 2015-12-20 02:10:15Z dsb $
-- ToME - Tales of Middle-Earth
-- Copyright (C) 2012 Scott Bigham
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Scott Bigham "Zizzo"
-- dsb-tome@killerbbunnies.org

newChat {
  id = 'begin',
  text = [[#LIGHT_GREEN#From inside his prison, Thráin speaks:#LAST#
Ah, at last someone has come for me.  But... I fear it is too late for me.  Heed my words:  beware the Necromancer, for he is in fact Sauron, the Dark Lord!  He stole the Ring of Durin from me and tortured me... arrgh... please make him pay!]],
  answers = {
    {
      'Fear not, brave king, I will avenge you.',
      action = function(npc, player, dlg)
	-- Remove Thrain.
	local Map = require 'mod.class.Map'
	local spot = game.level:pickSpot{ type='thrain-quest', subtype='thrain' }
	local thrain = game.level.map(spot.x, spot.y, Map.ACTOR)
	game.level.map:remove(spot.x, spot.y, Map.ACTOR)
	game.level:removeEntity(thrain)
	-- Place the Dragon Helm of Thrain.
	local o = obj_util.create_randart('DRAGON_HELM')
	o.artifact_name = 'of Thráin'
	o:setFoundHere {
	  type = 'mon_drop',
	  mon_name = thrain:getName(),
	}
	game.zone:addEntity(game.level, o, 'object', spot.x, spot.y)
	-- Finished the quest.
	player:setQuestStatus('thrain', engine.Quest.DONE)
      end,
    }
  },
}

return 'begin'
