-- $Id: factions.lua 1686 2015-10-07 00:27:11Z dsb $
-- ToME - Tales of Middle-Earth
-- Copyright (C) 2012 Scott Bigham
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Scott Bigham "Zizzo"
-- dsb-tome@killerbbunnies.org

local Faction = require 'engine.Faction'

Faction:add {
  name = 'Pets and Companions',
  short_name = 'pets',
  reaction = {
    players = 100,
    eru_manwe = 0,
    yavanna = 0,
    friendlies = 100,
    neutrals = 0,
    quest_givers = 100,
    enemies = -100,
  },
}

Faction:add {
  name = 'Eru/Manwë Followers',
  short_name = 'eru_manwe',
  reaction = {
    players = 0,
    pets = 0,
    yavanna = 100,
    friendlies = 100,
    neutrals = 0,
    quest_givers = 100,
    enemies = -100,
  },
}

Faction:add {
  name = 'Yavanna Followers',
  short_name = 'yavanna',
  reaction = {
    players = 0,
    pets = 0,
    eru_manwe = 100,
    friendlies = 100,
    neutrals = 0,
    quest_givers = 100,
    enemies = -100,
  },
}

Faction:add {
  name = 'Friendly NPCs',
  short_name = 'friendlies',
  reaction = {
    players = 100,
    pets = 100,
    eru_manwe = 100,
    yavanna = 100,
    neutrals = 0,
    quest_givers = 100,
    enemies = -100,
  },
}

Faction:add {
  name = 'Neutral NPCs',
  short_name = 'neutrals',
  reaction = {
    players = 0,
    pets = 0,
    eru_manwe = 0,
    yavanna = 0,
    friendlies = 0,
    quest_givers = 0,
    enemies = 0,
  }
}

Faction:add {
  name = 'Quest givers and rescuees',
  short_name = 'quest_givers',
  reaction = {
    players = 100,
    pets = 100,
    eru_manwe = 100,
    yavanna = 100,
    friendlies = 100,
    neutrals = 0,
    enemies = 0,
  }
}

Faction:setInitialReaction('players', 'pets', 100)
Faction:setInitialReaction('players', 'eru_manwe', 0)
Faction:setInitialReaction('players', 'yavanna', 0)
Faction:setInitialReaction('players', 'friendlies', 100)
Faction:setInitialReaction('players', 'neutrals', 0)
Faction:setInitialReaction('players', 'quest_givers', 0)

Faction:setInitialReaction('enemies', 'pets', -100)
Faction:setInitialReaction('enemies', 'eru_manwe', -100)
Faction:setInitialReaction('enemies', 'yavanna', -100)
Faction:setInitialReaction('enemies', 'friendlies', -100)
Faction:setInitialReaction('enemies', 'neutrals', 0)
Faction:setInitialReaction('enemies', 'quest_givers', 0)
