-- $Id: egos.lua 1799 2015-10-19 03:56:39Z dsb $
-- ToME - Tales of Middle-Earth
-- Copyright  2012-2015 Scott Bigham
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Scott Bigham "Zizzo"
-- dsb-tome@killerbbunnies.org

-- -----------------------------------------------------------------------
-- WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING
-- -----------------------------------------------------------------------
-- This file was generated automatically by the 'gen_mon_ego' Perl script.
-- DO NOT MODIFY THIS FILE DIRECTLY, as any changes will be lost the next
-- time the file is generated (with the possible exception of lines between
-- 'BEGIN VERBATIM' and 'END VERBATIM' markers, if supported by the script).
-- -----------------------------------------------------------------------
-- WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING
-- -----------------------------------------------------------------------

-- NPC egos generated from T2's re_info.txt

local AttackType = require 'mod.class.AttackType'
local Talents = require 'engine.interface.ActorTalents'

newEntity {
  define_as = 'SKELETON',
  name = [[Skeleton]],
  rarity = 13,
  prefix = true,
  required = {
    drop_corpse = { skeleton=true },
  },
  forbidden = {
    symbols = { ['A']=true, ['E']=true, ['Z']=true, ['g']=true },
    flags = { NONLIVING=true, UNDEAD=true },
  },
  mod = {
    display = { set='s' },
    corpse_weight = { pct=30 },
    life = { 1, 1 },
    ac = 5,
    level = 5,
    exp_worth = { pct=95 },
    alertness = -5,
  },
  add = {
    drop_corpse = { skeleton=true },
    resist_dam = {
      [DamageType.COLD] = true,
      [DamageType.CONFUSION] = true,
      [DamageType.FEAR] = true,
      [DamageType.OLD_SLEEP] = true,
      [DamageType.POISON] = true,
    },
    flags = {
      COLD_BLOOD = true,
      EMPTY_MIND = true,
      EVIL = true,
      STUPID = true,
      UNDEAD = true,
    },
  },
  remove = {
    random_move = 75,
    drop_corpse = { corpse=true },
    drop_flags = { good=true, great=true },
    flags = {
      ESCORT = true,
      ESCORTS = true,
      FRIEND = true,
      FRIENDS = true,
      GOOD = true,
      MORTAL = true,
      SMART = true,
    },
  },
  talents = {
    unlearn_existing = true,
  },
}

newEntity {
  define_as = 'ZOMBIE',
  name = [[Zombie]],
  rarity = 14,
  prefix = true,
  required = {
    drop_corpse = { corpse=true },
  },
  forbidden = {
    symbols = { ['A']=true, ['E']=true, ['Z']=true, ['g']=true },
    flags = { NONLIVING=true, UNDEAD=true },
  },
  mod = {
    display = { set='z' },
    corpse_weight = { pct=70 },
    life = { {pct=110}, 0 },
    ac = 10,
    level = 10,
    speed = { pct=95 },
    vision = { pct=90 },
    alertness = -5,
  },
  add = {
    drop_corpse = { corpse=true },
    resist_dam = {
      [DamageType.COLD] = true,
      [DamageType.CONFUSION] = true,
      [DamageType.FEAR] = true,
      [DamageType.OLD_SLEEP] = true,
      [DamageType.POISON] = true,
    },
    flags = {
      COLD_BLOOD = true,
      EMPTY_MIND = true,
      EVIL = true,
      STUPID = true,
      UNDEAD = true,
    },
  },
  remove = {
    random_move = 75,
    drop_corpse = { skeleton=true },
    drop_flags = { good=true, great=true },
    flags = {
      ESCORT = true,
      ESCORTS = true,
      FRIEND = true,
      FRIENDS = true,
      GOOD = true,
      MORTAL = true,
      SMART = true,
    },
  },
  talents = {
    unlearn_existing = true,
  },
}

newEntity {
  define_as = 'LICH',
  name = [[Lich]],
  rarity = 22,
  prefix = true,
  required = {
    symbols = { ['O']=true, ['P']=true, ['h']=true, ['p']=true },
    drop_corpse = { skeleton=true },
    flags = { SMART=true },
  },
  forbidden = {
    symbols = { ['A']=true, ['E']=true, ['Z']=true, ['g']=true },
    flags = { NONLIVING=true, UNDEAD=true },
  },
  mod = {
    display = { set='L' },
    life = { 0, 1 },
    ac = 20,
    level = 30,
    exp_worth = { pct=200 },
    vision = 10,
    alertness = -10,
    attacks = {
      { type=DamageType.LOSE_DEX, method=AttackType.TOUCH },
      { type=DamageType.LOSE_DEX, method=AttackType.TOUCH },
      { type=DamageType.UN_POWER, method=AttackType.TOUCH },
      { type=DamageType.EXP_40, method=AttackType.TOUCH },
    },
  },
  add = {
    resist_dam = {
      [DamageType.COLD] = true,
      [DamageType.CONFUSION] = true,
      [DamageType.FEAR] = true,
      [DamageType.OLD_SLEEP] = true,
      [DamageType.POISON] = true,
    },
    flags = {
      COLD_BLOOD = true,
      EVIL = true,
      SMART = true,
      UNDEAD = true,
    },
  },
  remove = {
    random_move = 75,
    drop_flags = { great=true },
    flags = {
      ESCORT = true,
      ESCORTS = true,
      FRIEND = true,
      FRIENDS = true,
      GOOD = true,
      MORTAL = true,
    },
  },
  talents = {
    talent_in = 4,
    add = {
      [Talents.T_NPC_BLINK] = 1,
      [Talents.T_NPC_TELE_TO] = 1,
      [Talents.T_NPC_TELE_AWAY] = 1,
      [Talents.T_NPC_BRAIN_SMASH] = 1,
      [Talents.T_NPC_DRAIN_MANA] = 1,
      [Talents.T_NPC_CAUSE_3] = 1,
      [Talents.T_NPC_BLIND] = 1,
      [Talents.T_NPC_HOLD] = 1,
      [Talents.T_NPC_SLOW] = 1,
      [Talents.T_NPC_SCARE] = 1,
    },
  },
}

newEntity {
  define_as = 'SPECTRAL',
  name = [[Spectral]],
  rarity = 20,
  prefix = true,
  required = {
    drop_corpse = { corpse=true },
  },
  forbidden = {
    symbols = { ['A']=true, ['E']=true, ['Z']=true, ['g']=true },
    flags = { NONLIVING=true, UNDEAD=true },
  },
  mod = {
    display = { set='G' },
    corpse_weight = { pct=10 },
    life = { {pct=80}, 0 },
    ac = 20,
    level = 20,
    exp_worth = { pct=110 },
    speed = 10,
    vision = 10,
    alertness = -5,
    attacks = {
      { type=DamageType.EXP_20 },
      { type=DamageType.EXP_20 },
    },
  },
  add = {
    resist_dam = {
      [DamageType.COLD] = true,
      [DamageType.CONFUSION] = true,
      [DamageType.FEAR] = true,
      [DamageType.OLD_SLEEP] = true,
      [DamageType.POISON] = true,
    },
    flags = {
      COLD_BLOOD = true,
      EVIL = true,
      PASS_WALL = true,
      UNDEAD = true,
    },
  },
  remove = {
    random_move = 50,
    drop_flags = { great=true },
    flags = {
      EMPTY_MIND = true,
      ESCORT = true,
      ESCORTS = true,
      FRIEND = true,
      FRIENDS = true,
      GOOD = true,
      MORTAL = true,
    },
  },
  talents = {
    unlearn_existing = true,
    talent_in = 5,
    add = {
      [Talents.T_NPC_BLIND] = 1,
      [Talents.T_NPC_HOLD] = 1,
      [Talents.T_NPC_SCARE] = 1,
    },
  },
}

newEntity {
  define_as = 'CAPTAIN',
  name = [[Captain]],
  rarity = 4,
  suffix = true,
  required = {
    symbols = { ['k']=true, ['o']=true, ['y']=true },
    flags = { BASEANGBAND=true },
  },
  mod = {
    color = { set=colors.C_v },
    corpse_weight = { pct=120 },
    life = { {pct=150}, 0, force_max=true },
    ac = { pct=120 },
    level = 5,
    exp_worth = { pct=150 },
    speed = 5,
    vision = 5,
    alertness = -2,
    attacks = {
      { dam={ 0, 1 } },
      { dam={ 0, 1 } },
      { dam={ 0, 1 } },
      { dam={ 0, 1 } },
    },
  },
  add = {
    drop_tags = { '1d2' },
    flags = {
      FRIENDS = true,
      SMART = true,
    },
  },
}

newEntity {
  define_as = 'CHIEFTAIN',
  name = [[Chieftain]],
  rarity = 4,
  suffix = true,
  required = {
    symbols = { ['O']=true, ['P']=true, ['T']=true },
    flags = { BASEANGBAND=true },
  },
  mod = {
    corpse_weight = { pct=120 },
    life = { {pct=200}, 0, force_max=true },
    ac = { pct=120 },
    level = 5,
    exp_worth = { pct=200 },
    speed = 10,
    vision = 10,
    alertness = -3,
    attacks = {
      { dam={ 1, 2 } },
      { dam={ 1, 2 } },
      { dam={ 1, 2 } },
      { dam={ 1, 2 } },
    },
  },
  add = {
    drop_tags = { '1d2' },
    flags = {
      FRIENDS = true,
      SMART = true,
    },
  },
}

newEntity {
  define_as = 'SHAMAN',
  name = [[Shaman]],
  rarity = 1,
  suffix = true,
  required = {
    symbols = { ['k']=true, ['n']=true, ['o']=true },
    flags = { BASEANGBAND=true },
  },
  mod = {
    color = { set=colors.C_r },
    corpse_weight = { pct=90 },
    life = { {pct=90}, 0, force_max=true },
    ac = { pct=90 },
    level = 2,
    exp_worth = { pct=120 },
    vision = 10,
  },
  add = {
    drop_tags = { '1d2' },
    flags = {
      SMART = true,
    },
  },
  remove = {
    flags = {
      FRIENDS = true,
    },
  },
  talents = {
    talent_in = 6,
    add = {
      [Talents.T_NPC_MISSILE] = 1,
      [Talents.T_NPC_CAUSE_1] = 1,
      [Talents.T_NPC_CONF] = 1,
      [Talents.T_NPC_BLINK] = 1,
    },
  },
}

newEntity {
  define_as = 'PRIEST',
  name = [[Priest]],
  rarity = 2,
  suffix = true,
  required = {
    symbols = { ['O']=true, ['P']=true, ['T']=true },
    flags = { BASEANGBAND=true },
  },
  mod = {
    color = { set=colors.C_G },
    corpse_weight = { pct=90 },
    life = { {pct=90}, 0, force_max=true },
    ac = { pct=90 },
    level = 3,
    exp_worth = { pct=120 },
    vision = 10,
  },
  add = {
    drop_tags = { '1d2' },
    flags = {
      FRIENDS = true,
      SMART = true,
    },
  },
  talents = {
    talent_in = 6,
    add = {
      [Talents.T_NPC_CAUSE_2] = 1,
      [Talents.T_NPC_MISSILE] = 1,
      [Talents.T_NPC_DARKNESS] = 1,
      [Talents.T_NPC_CONF] = 1,
      [Talents.T_NPC_SCARE] = 1,
      [Talents.T_NPC_BLINK] = 1,
    },
  },
}

newEntity {
  define_as = 'MAGE',
  name = [[Mage]],
  rarity = 4,
  suffix = true,
  required = {
    symbols = { ['O']=true },
    flags = { BASEANGBAND=true },
  },
  mod = {
    color = { set=colors.C_r },
    corpse_weight = { pct=120 },
    life = { {pct=150}, 0, force_max=true },
    ac = { pct=120 },
    level = 5,
    exp_worth = { pct=150 },
    vision = 10,
    attacks = {
      {},
      {},
      { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={ {set=2}, {set=8} } },
      { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={ {set=2}, {set=8} } },
    },
  },
  add = {
    drop_tags = { '1d2' },
    flags = {
      SMART = true,
    },
  },
  remove = {
    flags = {
      FRIENDS = true,
    },
  },
  talents = {
    talent_in = 6,
    add = {
      [Talents.T_NPC_BA_COLD] = 1,
      [Talents.T_NPC_BO_FIRE] = 1,
      [Talents.T_NPC_TRAPS] = 1,
      [Talents.T_NPC_HEAL] = 1,
      [Talents.T_NPC_HOLD] = 1,
      [Talents.T_NPC_S_MONSTER] = 1,
      [Talents.T_NPC_TPORT] = 1,
    },
  },
}

newEntity {
  define_as = 'ARCHER',
  name = [[Archer]],
  rarity = 1,
  suffix = true,
  required = {
    symbols = { ['O']=true, ['k']=true, ['o']=true, ['y']=true },
    flags = { BASEANGBAND=true },
  },
  mod = {
    color = { set=colors.C_W },
    level = 1,
    exp_worth = { pct=110 },
  },
  talents = {
    talent_in = 4,
    add = {
      [Talents.T_NPC_ARROW_2] = 1,
    },
  },
}

newEntity {
  define_as = 'ROGUE',
  name = [[Rogue]],
  rarity = 2,
  suffix = true,
  required = {
    symbols = { ['k']=true, ['o']=true, ['y']=true },
  },
  mod = {
    color = { set=colors.C_b },
    corpse_weight = { pct=90 },
    ac = 10,
    level = 1,
    speed = 2,
    alertness = -30,
    attacks = {
      { type=DamageType.EAT_GOLD },
    },
  },
}

newEntity {
  define_as = 'ELVEN',
  name = [[Elven]],
  rarity = 15,
  prefix = true,
  required = {
    flags = { WILD_TOWN=true },
  },
  forbidden = {
    flags = { ANIMAL=true },
  },
  mod = {
    speed = 2,
  },
}

newEntity {
  define_as = 'DWARVEN',
  name = [[Dwarven]],
  rarity = 15,
  prefix = true,
  required = {
    flags = { WILD_TOWN=true },
  },
  forbidden = {
    flags = { ANIMAL=true },
  },
  mod = {
    speed = 2,
  },
}
