-- $Id$
-- ToME - Tales of Middle-Earth
-- Copyright © 2012-2016 Scott Bigham
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Scott Bigham "Zizzo"
-- dsb-tome@killerbbunnies.org

-- -----------------------------------------------------------------------
-- WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING
-- -----------------------------------------------------------------------
-- This file was generated automatically by the 'gen_obj' Perl script.
-- DO NOT MODIFY THIS FILE DIRECTLY, as any changes will be lost the next
-- time the file is generated (with the possible exception of lines between
-- 'BEGIN VERBATIM' and 'END VERBATIM' markers, if supported by the script).
-- -----------------------------------------------------------------------
-- WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING
-- -----------------------------------------------------------------------

-- Object entities generated from T2's k_info.txt

newEntity {
  base = 'AMULET_BASE',
  define_as = 'TORIS_MEJISTOS_BASE',
  name = 'TORIS_MEJISTOS_BASE',
  display_name = '& Blue Stone~',
  sval = 18,
  color = colors.C_B,
  image = 'object/amulet_placeholder.png',
  level = 60,
  cost = 90000,
  insta_art = true,
  special_gene = true,
}

newEntity {
  base = 'AMULET_BASE',
  define_as = 'AMULET_BRILLIANCE',
  name = 'AMULET_BRILLIANCE',
  display_name = 'Brilliance',
  desc = 'This talisman grants a sharper wit, greater insight and brightness to light dark places.',
  sval = 6,
  color = colors.C_d,
  image = 'object/amulet_placeholder.png',
  level = 50,
  cost = 1000,
  lite = 1,
  stat_flags = { INT=true, WIS=true },
  flags = { HIDE_TYPE=true },
  allocation = { { level=50, rarity=4 } },
  -- BEGIN VERBATIM
  resolvers.generic(function(e)
    local Object = require 'mod.class.Object'
    local RF = Object.resolve_flags
    e.pval = 1 + obj_util.m_bonus(5, RF.level)
    obj_util.check_cursed(e, {'pval'})
    return nil	-- Delete the origin field
  end),
  -- END VERBATIM
}

newEntity {
  base = 'AMULET_BASE',
  define_as = 'AMULET_CHARISMA',
  name = 'AMULET_CHARISMA',
  display_name = 'Charisma',
  desc = 'This amulet grants beauty beyond mere looks.',
  sval = 7,
  color = colors.C_d,
  image = 'object/amulet_placeholder.png',
  level = 30,
  cost = 500,
  stat_flags = { CHA=true },
  flags = { HIDE_TYPE=true },
  obvious_flags = { stat_flags = { CHA=true } },
  allocation = { { level=30, rarity=1 } },
  -- BEGIN VERBATIM
  resolvers.generic(function(e)
    local Object = require 'mod.class.Object'
    local RF = Object.resolve_flags
    e.pval = 1 + obj_util.m_bonus(5, RF.level)
    obj_util.check_cursed(e, {'pval'})
    return nil	-- Delete the origin field
  end),
  -- END VERBATIM
}

newEntity {
  base = 'AMULET_BASE',
  define_as = 'AMULET_SEARCHING',
  name = 'AMULET_SEARCHING',
  display_name = 'Searching',
  desc = 'This amulet grants keen sight, finding things that are hidden.',
  sval = 5,
  color = colors.C_d,
  image = 'object/amulet_placeholder.png',
  level = 15,
  cost = 600,
  pval_flags = { skill_searching=true, skill_perception=true },
  flags = { HIDE_TYPE=true },
  obvious_flags = { pval_flags = { skill_searching=true } },
  allocation = { { level=15, rarity=1 } },
  -- BEGIN VERBATIM
  resolvers.generic(function(e)
    local Object = require 'mod.class.Object'
    local RF = Object.resolve_flags
    e.pval = rng.range(1, 5) + obj_util.m_bonus(5, RF.level)
    obj_util.check_cursed(e, {'pval'})
    return nil	-- Delete the origin field
  end),
  -- END VERBATIM
}

newEntity {
  base = 'AMULET_BASE',
  define_as = 'AMULET_TELEPORTATION',
  name = 'AMULET_TELEPORTATION',
  display_name = 'Teleportation',
  desc = 'This amulet nastily throws you all over the place.',
  sval = 1,
  color = colors.C_d,
  image = 'object/amulet_placeholder.png',
  level = 10,
  cost = 250,
  convey_flags = { TELEPORT=true },
  flags = { CURSED=true, EASY_KNOW=true },
  obvious_flags = { convey_flags = { TELEPORT=true } },
  allocation = { { level=10, rarity=1 } },
}

newEntity {
  base = 'AMULET_BASE',
  define_as = 'AMULET_SLOW_DIGESTION',
  name = 'AMULET_SLOW_DIGESTION',
  display_name = 'Slow Digestion',
  desc = 'This talisman will make you hungry less quickly when worn.',
  sval = 3,
  color = colors.C_d,
  image = 'object/amulet_placeholder.png',
  level = 15,
  cost = 200,
  convey_flags = { SLOW_DIGEST=true },
  flags = { EASY_KNOW=true },
  obvious_flags = { convey_flags = { SLOW_DIGEST=true } },
  allocation = { { level=15, rarity=1 } },
}

newEntity {
  base = 'AMULET_BASE',
  define_as = 'AMULET_ACID_RESISTANCE',
  name = 'AMULET_ACID_RESISTANCE',
  display_name = 'Acid Resistance',
  desc = 'This magical talisman will make the corroding forces of acid less threatening to your health.',
  sval = 4,
  color = colors.C_d,
  image = 'object/amulet_placeholder.png',
  level = 10,
  cost = 250,
  convey_resist_dam = { [DamageType.ACID]=true },
  flags = { EASY_KNOW=true },
  ignore_dam = { [DamageType.ACID]=true },
  obvious_flags = { convey_resist_dam = { [DamageType.ACID]=true } },
  allocation = { { level=10, rarity=1 } },
}

newEntity {
  base = 'AMULET_BASE',
  define_as = 'AMULET_ADORNMENT',
  name = 'AMULET_ADORNMENT',
  display_name = 'Adornment',
  desc = 'This amulet is not magical. It just looks good.',
  sval = 2,
  color = colors.C_d,
  image = 'object/amulet_placeholder.png',
  level = 10,
  cost = 20,
  flags = { EASY_KNOW=true },
  allocation = { { level=10, rarity=1 } },
}

newEntity {
  base = 'AMULET_BASE',
  define_as = 'AMULET_THE_MAGI',
  name = 'AMULET_THE_MAGI',
  display_name = 'the Magi',
  desc = 'This rare amulet is highly desirable for mages, as it makes its wearer smarter, more attentive and impervious to magics which would make their own magic-use impossible.',
  sval = 8,
  color = colors.C_d,
  image = 'object/amulet_placeholder.png',
  level = 70,
  cost = 30000,
  combat = { 0, 0 }, to_h = -4, to_d = -4,
  convey_resist_dam = { [DamageType.BLIND]=true, [DamageType.CONFUSION]=true },
  convey_flags = { SUST_INT=true, FREE_ACT=true },
  stat_flags = { INT=true },
  pval_flags = { skill_searching=true, skill_perception=true },
  flags = { SPELL_CONTAIN=true, WIELD_CAST=true },
  ignore_dam = { [DamageType.ACID]=true, [DamageType.ELEC]=true, [DamageType.FIRE]=true, [DamageType.COLD]=true },
  allocation = { { level=70, rarity=8 } },
  -- BEGIN VERBATIM
  rating = 25,
  resolvers.generic(function(e)
    local Object = require 'mod.class.Object'
    local RF = Object.resolve_flags
    e.pval = 1 + obj_util.m_bonus(3, RF.level)
    if rng.chance(3) then e.convey_flags.SLOW_DIGEST = true end
    return nil	-- Delete the origin field
  end),
  resolvers.precog_mention(),
  -- END VERBATIM
}

newEntity {
  base = 'AMULET_BASE',
  define_as = 'AMULET_DOOM',
  name = 'AMULET_DOOM',
  display_name = 'Doom',
  desc = 'This wicked amulet will drain all your abilities, turning you into a mere shadow of yourself. It is exceedingly hard to get rid of.',
  sval = 0,
  color = colors.C_d,
  image = 'object/amulet_placeholder.png',
  level = 50,
  cost = 0,
  stat_flags = { STR=true, INT=true, WIS=true, DEX=true, CON=true, CHA=true },
  flags = { CURSED=true, HIDE_TYPE=true, AUTO_CURSE=true, CURSE_NO_DROP=true },
  allocation = { { level=50, rarity=1 } },
  -- BEGIN VERBATIM
  resolvers.generic(function(e)
    local Object = require 'mod.class.Object'
    local RF = Object.resolve_flags
    -- TODO Flag as cursed, independent of RF.power
    e.pval = -rng.range(1, 5) - obj_util.m_bonus(5, RF.level)
    e.to_a = -rng.range(1, 5) - obj_util.m_bonus(5, RF.level)
  end),
  -- END VERBATIM
}

newEntity {
  base = 'AMULET_BASE',
  define_as = 'AMULET_SPELL',
  name = 'AMULET_SPELL',
  display_name = 'Spell',
  desc = 'This amulet is a container for spells. Those that are skilled in copying spells can inscribe a spell into it.',
  sval = 27,
  color = colors.C_d,
  image = 'object/amulet_placeholder.png',
  level = 10,
  cost = 1000,
  flags = { SPELL_CONTAIN=true, WIELD_CAST=true },
  obvious_flags = { flags = { SPELL_CONTAIN=true } },
  allocation = { { level=10, rarity=1 } },
}

newEntity {
  base = 'AMULET_BASE',
  define_as = 'AMULET_LIGHTNING_RESISTANCE',
  name = 'AMULET_LIGHTNING_RESISTANCE',
  display_name = 'Lightning Resistance',
  desc = 'This amulet will protect you from electrical discharges and storms.',
  sval = 29,
  color = colors.C_d,
  image = 'object/amulet_placeholder.png',
  level = 10,
  cost = 250,
  convey_resist_dam = { [DamageType.ELEC]=true },
  flags = { EASY_KNOW=true },
  ignore_dam = { [DamageType.ELEC]=true },
  obvious_flags = { convey_resist_dam = { [DamageType.ELEC]=true } },
  allocation = { { level=10, rarity=1 } },
}

newEntity {
  base = 'AMULET_BASE',
  define_as = 'AMULET_WISDOM',
  name = 'AMULET_WISDOM',
  display_name = 'Wisdom',
  desc = 'This magical amulet will magically make you wiser, and fend off attacks that would reduce your wisdom. Beware: if cursed, the amulet will do the opposite.',
  sval = 28,
  color = colors.C_d,
  image = 'object/amulet_placeholder.png',
  level = 30,
  cost = 500,
  convey_flags = { SUST_WIS=true },
  stat_flags = { WIS=true },
  flags = { HIDE_TYPE=true },
  obvious_flags = { stat_flags = { WIS=true } },
  allocation = { { level=30, rarity=1 } },
  -- BEGIN VERBATIM
  resolvers.generic(function(e)
    local Object = require 'mod.class.Object'
    local RF = Object.resolve_flags
    e.pval = 1 + obj_util.m_bonus(5, RF.level)
    obj_util.check_cursed(e, {'pval'})
    return nil	-- Delete the origin field
  end),
  -- END VERBATIM
}

newEntity {
  base = 'AMULET_BASE',
  define_as = 'AMULET_REGENERATION',
  name = 'AMULET_REGENERATION',
  display_name = 'Regeneration',
  desc = [[Wearing this amulet will trigger your body's regenerational processes quicker and make them proceed faster.]],
  sval = 30,
  color = colors.C_d,
  image = 'object/amulet_placeholder.png',
  level = 30,
  cost = 600,
  convey_flags = { REGENERATE=true },
  flags = { EASY_KNOW=true },
  obvious_flags = { convey_flags = { REGENERATE=true } },
  allocation = { { level=30, rarity=3 } },
}

newEntity {
  base = 'AMULET_BASE',
  define_as = 'AMULET_INFRAVISION',
  name = 'AMULET_INFRAVISION',
  display_name = 'Infravision',
  desc = 'This amulet will increase your ability to sense warm-blooded creatures in your vicinity. Beware: if cursed, it will do just the opposite.',
  sval = 26,
  color = colors.C_d,
  image = 'object/amulet_placeholder.png',
  level = 10,
  cost = 200,
  pval_flags = { infravision=true },
  flags = { HIDE_TYPE=true },
  obvious_flags = { pval_flags = { infravision=true } },
  allocation = { { level=10, rarity=1 } },
  -- BEGIN VERBATIM
  resolvers.generic(function(e)
    local Object = require 'mod.class.Object'
    local RF = Object.resolve_flags
    e.pval = 1 + obj_util.m_bonus(5, RF.level)
    obj_util.check_cursed(e, {'pval'})
    return nil	-- Delete the origin field
  end),
  -- END VERBATIM
}

newEntity {
  base = 'AMULET_BASE',
  define_as = 'AMULET_DEVOTION',
  name = 'AMULET_DEVOTION',
  display_name = 'Devotion',
  desc = 'This blessed amulet will protect your wisdom and charms from diminishing, often adding to them as well. It also grants some extra protective magics by the grace of the Valar.',
  sval = 25,
  color = colors.C_d,
  image = 'object/amulet_placeholder.png',
  level = 70,
  cost = 30000,
  lite = 1,
  convey_resist_dam = { [DamageType.DARK]=true, [DamageType.LITE]=true, [DamageType.FIRE]=true },
  convey_flags = { SUST_WIS=true, SUST_CHA=true, HOLD_LIFE=true },
  stat_flags = { WIS=true, CHA=true },
  flags = { HIDE_TYPE=true },
  allocation = { { level=70, rarity=8 } },
  -- BEGIN VERBATIM
  resolvers.generic(function(e)
    local Object = require 'mod.class.Object'
    local RF = Object.resolve_flags
    e.pval = 1 + obj_util.m_bonus(3, RF.level)
    return nil	-- Delete the origin field
  end),
  -- END VERBATIM
}

newEntity {
  base = 'AMULET_BASE',
  define_as = 'AMULET_WEAPONMASTERY',
  name = 'AMULET_WEAPONMASTERY',
  display_name = 'Weaponmastery',
  desc = 'The ultimate amulet for a warrior, it will grant protection in the face of some evil magics, protect your strength and health, also increasing them. Beware: if cursed, the amulet will sap your strength and health instead.',
  sval = 24,
  color = colors.C_d,
  image = 'object/amulet_placeholder.png',
  level = 70,
  cost = 30000,
  convey_resist_dam = { [DamageType.FEAR]=true, [DamageType.DISENCHANT]=true },
  convey_flags = { SUST_STR=true, SUST_CON=true, FREE_ACT=true },
  stat_flags = { STR=true, CON=true },
  flags = { HIDE_TYPE=true },
  allocation = { { level=70, rarity=8 } },
  -- BEGIN VERBATIM
  resolvers.generic(function(e)
    local Object = require 'mod.class.Object'
    local RF = Object.resolve_flags
    e.pval = 1 + obj_util.m_bonus(2, RF.level)
    e.to_a = 1 + obj_util.m_bonus(4, RF.level)
    e.to_h = 1 + obj_util.m_bonus(5, RF.level)
    e.to_d = 1 + obj_util.m_bonus(5, RF.level)
    return nil	-- Delete the origin field
  end),
  -- END VERBATIM
}

newEntity {
  base = 'AMULET_BASE',
  define_as = 'AMULET_TRICKERY',
  name = 'AMULET_TRICKERY',
  display_name = 'Trickery',
  desc = 'The ultimate amulet for a rogue or assassin, it protects the wearer against some evil magics, granting improvements in the abilities vital to these adventurers. Beware: if cursed, the amulet will do just the opposite.',
  sval = 23,
  color = colors.C_d,
  image = 'object/amulet_placeholder.png',
  level = 70,
  cost = 30000,
  convey_resist_dam = { [DamageType.NEXUS]=true, [DamageType.POISON]=true },
  convey_flags = { SUST_DEX=true },
  stat_flags = { DEX=true },
  pval_flags = { skill_stealth=true, speed=true, infravision=true },
  flags = { HIDE_TYPE=true },
  allocation = { { level=70, rarity=8 } },
  -- BEGIN VERBATIM
  resolvers.generic(function(e)
    local Object = require 'mod.class.Object'
    local RF = Object.resolve_flags
    e.pval = 1 + obj_util.m_bonus(3, RF.level)
    return nil	-- Delete the origin field
  end),
  -- END VERBATIM
}

newEntity {
  base = 'AMULET_BASE',
  define_as = 'AMULET_TELEPATHY',
  name = 'AMULET_TELEPATHY',
  display_name = 'Telepathy',
  desc = 'This rare and powerful amulet lays bare the minds of monsters before the wearer.',
  sval = 22,
  color = colors.C_d,
  image = 'object/amulet_placeholder.png',
  level = 50,
  cost = 25000,
  esp_flags = { ALL=true },
  ignore_dam = { [DamageType.ACID]=true, [DamageType.ELEC]=true, [DamageType.FIRE]=true, [DamageType.COLD]=true },
  obvious_flags = { esp_flags = { ALL=true } },
  allocation = { { level=50, rarity=6 } },
}

newEntity {
  base = 'AMULET_BASE',
  define_as = 'AMULET_SUSTENANCE',
  name = 'AMULET_SUSTENANCE',
  display_name = 'Sustenance',
  desc = 'This blessed amulet will make the wearer impervious to evil magics that would sap innate abilities. It also slows down the digestive system, making food less necessary on long journeys.',
  sval = 21,
  color = colors.C_d,
  image = 'object/amulet_placeholder.png',
  level = 60,
  cost = 20000,
  convey_flags = { SUST_STR=true, SUST_INT=true, SUST_WIS=true, SUST_DEX=true, SUST_CON=true, SUST_CHA=true, HOLD_LIFE=true, SLOW_DIGEST=true },
  flags = { EASY_KNOW=true },
  ignore_dam = { [DamageType.ACID]=true, [DamageType.ELEC]=true, [DamageType.FIRE]=true, [DamageType.COLD]=true },
  allocation = { { level=60, rarity=4 } },
}

newEntity {
  base = 'AMULET_BASE',
  define_as = 'ELESSAR_BASE',
  name = 'ELESSAR_BASE',
  display_name = '& Elfstone~',
  sval = 19,
  color = colors.C_g,
  image = 'object/amulet_placeholder.png',
  level = 60,
  cost = 50000,
  insta_art = true,
}

newEntity {
  base = 'AMULET_BASE',
  define_as = 'EVENSTAR_BASE',
  name = 'EVENSTAR_BASE',
  display_name = '& Jewel~',
  sval = 20,
  color = colors.C_w,
  image = 'object/amulet_placeholder.png',
  level = 50,
  cost = 35000,
  insta_art = true,
}

newEntity {
  base = 'AMULET_BASE',
  define_as = 'CARLAMMAS_BASE',
  name = 'CARLAMMAS_BASE',
  display_name = '& Amulet~',
  sval = 10,
  color = colors.C_d,
  image = 'object/amulet_placeholder.png',
  level = 50,
  cost = 60000,
  insta_art = true,
}

newEntity {
  base = 'AMULET_BASE',
  define_as = 'INGWE_BASE',
  name = 'INGWE_BASE',
  display_name = '& Amulet~',
  sval = 11,
  color = colors.C_d,
  image = 'object/amulet_placeholder.png',
  level = 60,
  cost = 90000,
  insta_art = true,
}

newEntity {
  base = 'AMULET_BASE',
  define_as = 'NAUGLAMIR_BASE',
  name = 'NAUGLAMIR_BASE',
  display_name = '& Necklace~',
  sval = 12,
  color = colors.C_d,
  image = 'object/amulet_placeholder.png',
  level = 70,
  cost = 75000,
  insta_art = true,
}

newEntity {
  base = 'AMULET_BASE',
  define_as = 'AMULET_REFLECTION',
  name = 'AMULET_REFLECTION',
  display_name = 'Reflection',
  desc = 'This wondrous amulet will magically make the wearer reflect arrows and bolts launched by adversaries.',
  sval = 9,
  color = colors.C_d,
  image = 'object/amulet_placeholder.png',
  level = 60,
  cost = 30000,
  convey_flags = { REFLECT=true },
  flags = { EASY_KNOW=true },
  ignore_dam = { [DamageType.ACID]=true, [DamageType.ELEC]=true, [DamageType.FIRE]=true, [DamageType.COLD]=true },
  obvious_flags = { convey_flags = { REFLECT=true } },
  allocation = { { level=60, rarity=4 } },
}

newEntity {
  base = 'AMULET_BASE',
  define_as = 'AMULET_ANTI_MAGIC',
  name = 'AMULET_ANTI_MAGIC',
  display_name = 'Anti-Magic',
  desc = 'This amulet wards off magic of any kind, good or bad.',
  sval = 13,
  color = colors.C_d,
  image = 'object/amulet_placeholder.png',
  level = 40,
  cost = 30000,
  convey_flags = { NO_MAGIC=true },
  ignore_dam = { [DamageType.ACID]=true, [DamageType.ELEC]=true, [DamageType.FIRE]=true, [DamageType.COLD]=true },
  obvious_flags = { convey_flags = { NO_MAGIC=true } },
  allocation = { { level=40, rarity=4 } },
  -- BEGIN VERBATIM
  resolvers.generic(function(e)
    obj_util.check_cursed(e)
  end),
  -- END VERBATIM
}

newEntity {
  base = 'AMULET_BASE',
  define_as = 'AMULET_ANTI_TELEPORTATION',
  name = 'AMULET_ANTI_TELEPORTATION',
  display_name = 'Anti-Teleportation',
  desc = 'This amulet will prevent the space-time continuum from being disrupted around the wearer.',
  sval = 14,
  color = colors.C_d,
  image = 'object/amulet_placeholder.png',
  level = 30,
  cost = 15000,
  convey_flags = { NO_TELE=true },
  ignore_dam = { [DamageType.ACID]=true, [DamageType.ELEC]=true, [DamageType.FIRE]=true, [DamageType.COLD]=true },
  obvious_flags = { convey_flags = { NO_TELE=true } },
  allocation = { { level=30, rarity=4 } },
  -- BEGIN VERBATIM
  resolvers.generic(function(e)
    obj_util.check_cursed(e)
  end),
  -- END VERBATIM
}

newEntity {
  base = 'AMULET_BASE',
  define_as = 'AMULET_RESISTANCE',
  name = 'AMULET_RESISTANCE',
  display_name = 'Resistance',
  desc = 'This amulet will make the wearer resist the elements.',
  sval = 15,
  color = colors.C_d,
  image = 'object/amulet_placeholder.png',
  level = 50,
  cost = 25000,
  convey_resist_dam = { [DamageType.ACID]=true, [DamageType.ELEC]=true, [DamageType.FIRE]=true, [DamageType.COLD]=true },
  ignore_dam = { [DamageType.ACID]=true, [DamageType.ELEC]=true, [DamageType.FIRE]=true, [DamageType.COLD]=true },
  obvious_flags = { convey_resist_dam = { [DamageType.ACID]=true, [DamageType.ELEC]=true, [DamageType.FIRE]=true, [DamageType.COLD]=true } },
  allocation = { { level=50, rarity=4 } },
  -- BEGIN VERBATIM
  resolvers.generic(function(e)
    local Object = require 'mod.class.Object'
    local DamageType = require 'engine.DamageType'
    if rng.chance(3) then obj_util.random_resistance(e, rng.range(5, 38)) end
    if rng.chance(5) then e.convey_resist_dam[DamageType.POISON] = true end
  end),
  -- END VERBATIM
}

newEntity {
  base = 'AMULET_BASE',
  define_as = 'AMULET_NOTHING',
  name = 'AMULET_NOTHING',
  display_name = 'Nothing',
  sval = 16,
  color = colors.C_d,
  image = 'object/amulet_placeholder.png',
  level = 10,
  cost = 20,
  combat = { 1, 1 },
  allocation = { { level=10, rarity=1 } },
}

newEntity {
  base = 'AMULET_BASE',
  define_as = 'AMULET_THE_SERPENTS',
  name = 'AMULET_THE_SERPENTS',
  display_name = 'the Serpents',
  desc = [[A petrified serpent's tongue, hung on a thin chain to be clasped around your neck. It makes you like unto snakes, able to wriggle out of tight corners, impervious to poisons and poisonous yourself.]],
  sval = 17,
  color = colors.C_G,
  image = 'object/amulet_placeholder.png',
  level = 25,
  cost = 10000,
  convey_resist_dam = { [DamageType.POISON]=true },
  stat_flags = { DEX=true },
  allocation = { { level=25, rarity=1 } },
  -- Placeholder until we define this.
  use_simple = {
    use = function(self, who, inven, floor, item)
      game.log('[Sorry, not implemented (BA_POIS_4)]')
    end,
    name = [[do something unimplemented (BA_POIS_4)]],
  },
  cant_use_if = { not_wielded=true },
  -- BEGIN VERBATIM
  resolvers.generic(function(e)
    local Object = require 'mod.class.Object'
    local RF = Object.resolve_flags
    e.pval = 1 + obj_util.m_bonus(5, RF.level)
    e.to_a = 1 + obj_util.m_bonus(6, RF.level)
    obj_util.check_cursed(e, {'pval'})
    return nil	-- Delete the origin field
  end),
  -- END VERBATIM
}
-- 31 total items
-- color:  colors.C_B=1; colors.C_G=1; colors.C_d=27; colors.C_g=1; colors.C_w=1
-- level:  10=7; 15=2; 25=1; 30=4; 40=1; 50=6; 60=5; 70=5
-- cost:  0=1; 1000=2; 10000=1; 15000=1; 20=2; 200=2; 20000=1; 250=3; 25000=2; 30000=6; 35000=1; 500=2; 50000=1; 600=2; 60000=1; 75000=1; 90000=2
