-- $Id$
-- ToME - Tales of Middle-Earth
-- Copyright © 2012-2016 Scott Bigham
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Scott Bigham "Zizzo"
-- dsb-tome@killerbbunnies.org

-- -----------------------------------------------------------------------
-- WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING
-- -----------------------------------------------------------------------
-- This file was generated automatically by the 'gen_obj' Perl script.
-- DO NOT MODIFY THIS FILE DIRECTLY, as any changes will be lost the next
-- time the file is generated (with the possible exception of lines between
-- 'BEGIN VERBATIM' and 'END VERBATIM' markers, if supported by the script).
-- -----------------------------------------------------------------------
-- WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING
-- -----------------------------------------------------------------------

-- Object entities generated from T2's k_info.txt

-- BEGIN VERBATIM
local ActorTalents = require 'engine.interface.ActorTalents'
-- END VERBATIM

newEntity {
  define_as = 'IRON_SPIKE',
  name = 'IRON_SPIKE',
  display_name = '& Iron Spike~',
  desc = 'A small spur of iron. Ramming one between a door and its frame might jam it.',
  type = 'misc',
  subtype = 'spike',
  tval = 5,
  sval = 0,
  display = '~',
  color = colors.C_W,
  image = 'object/iron_spike.png',
  level = 1,
  extra = 0,
  weight = 1,
  encumber = 1,
  cost = 1,
  combat = { 1, 1 },
  flags = { EASY_KNOW=true },
  allocation = { { level=1, rarity=1 } },
  stacking = true,
  -- BEGIN VERBATIM
  category = 'tools',
  -- END VERBATIM
}

newEntity {
  define_as = 'FLASK_OF_OIL',
  name = 'FLASK_OF_OIL',
  display_name = '& Flask~ of oil',
  desc = 'A small clay container, filled with thick oil. The oil is flammable and can be used as lantern fuel.',
  type = 'misc',
  subtype = 'oil',
  tval = 77,
  sval = 0,
  display = '!',
  color = colors.C_y,
  image = 'object/flask_of_oil.png',
  level = 1,
  extra = 0,
  weight = 1,
  encumber = 1,
  cost = 3,
  combat = { 2, 6 },
  flags = { EASY_KNOW=true },
  oil = 7500,
  allocation = { { level=1, rarity=1 } },
  stacking = true,
  -- BEGIN VERBATIM
  category = 'tools',
  can_refuel = function(self, fuel) return fuel == 'oil' end,
  -- END VERBATIM
}

newEntity {
  define_as = 'EMPTY_BOTTLE',
  name = 'EMPTY_BOTTLE',
  display_name = '& Empty Bottle~',
  desc = [[A small glass bottle. It's empty.]],
  type = 'misc',
  subtype = 'bottle',
  tval = 2,
  sval = 1,
  display = '!',
  color = colors.C_w,
  image = 'object/empty_bottle.png',
  level = 0,
  extra = 0,
  weight = 0.2,
  encumber = 0.2,
  cost = 1,
  combat = { 1, 1 },
  flags = { EASY_KNOW=true },
  allocation = { { level=0, rarity=1 } },
  stacking = true,
  -- BEGIN VERBATIM
  category = 'junk',
  destroyed_by = {
    [DamageType.ACID] = true,
    [DamageType.COLD] = true,
  },
  -- END VERBATIM
}

newEntity {
  base = 'WEAPON_BASE',
  define_as = 'MAGE_STAFF',
  name = 'MAGE_STAFF',
  display_name = '& Mage Staff~',
  desc = 'It looks like a simple walking stick, plain and nondescript. In the hands of a spellcaster, it can be a deadly weapon.',
  subtype = 'magestaff',
  tval = 6,
  sval = 1,
  display = '\\',
  color = colors.C_B,
  image = 'object/mage_staff.png',
  level = 5,
  extra = 0,
  weight = 1.2,
  encumber = 1.2,
  cost = 300,
  combat = { 1, 4 },
  flags = { SHOW_MODS=true, COULD2H=true, SPELL_CONTAIN=true, WIELD_CAST=true },
  obvious_flags = { flags = { COULD2H=true } },
  allocation = {
    { level=5, rarity=1 },
    { level=20, rarity=1 },
    { level=50, rarity=1 },
    { level=80, rarity=1 },
  },
  -- BEGIN VERBATIM
  category = 'magic',
  -- Slight Hack(TM):  A fake flag to be referenced in Actor:energyForTalent().
  convey_flags = { fast_spellcast=true },
  -- END VERBATIM
}

newEntity {
  define_as = 'SYMBIOTE',
  name = 'SYMBIOTE',
  display_name = '& ~',
  type = 'misc',
  subtype = 'symbiote',
  slot = 'SYMBIOTE',
  tval = 99,
  sval = 1,
  display = '~',
  color = colors.C_y,
  image = 'object/symbiote.png',
  level = 127,
  extra = 200,
  weight = 6,
  encumber = 6,
  cost = 0,
  combat = { 0, 0 },
  flags = { EASY_KNOW=true },
  allocation = { { level=127, rarity=255 } },
  -- BEGIN VERBATIM
  category = 'junk',
  resolvers.symbiote(),
  name_cb = function(self, name, t)
    if t.unresolved then return 'Symbiote' end
    local name = self.symbiote:getName{ indef_art=true, cite_given_name=true }
    return name or '& broken symbiote'
  end,
  desc_post = function(self, t)
    t = t or {}
    if self.symbiote and not t.chardump then
      return '\n' .. self.symbiote:getDesc()
    end
    return nil
  end,
  on_wear = function(self, who, i_id)
    -- Don't forget to call the "parent" on_wear().
    require('mod.class.Object').on_wear(self, who, i_id)
    if self.symbiote and not self.symbiote.dead then
      -- Information the symbiote will need, and the original values of
      -- symbiote information that we're about to change.
      self.symbiote.symbiosis = {
	host = who,
	worn = self,
	worn_inv_id = i_id,
	orig_ai = self.symbiote.ai,
	orig_on_die = self.symbiote.on_die,
      }
      -- Spectacularly Dodgy Hack(TM):  Pretend the symbiote is where its
      -- host is for AI purposes.
      self.symbiote.x, self.symbiote.y = who.x, who.y
      -- Change the symbiote's behavior accordingly.
      self.symbiote.ai = 'tome2_worn_symbiote'
      -- If the symbiote dies, unwield and discard this object.
      self.symbiote.on_die = function(symb, killer, death_note)
	local who, obj, i_id = symb.symbiosis.host, symb.symbiosis.worn, symb.symbiosis.worn_inv_id
	-- Grab this before on_takeoff() clobbers it.
	local orig_on_die = symb.symbiosis.orig_on_die
	game.logPlayer(who, '#RED#%s sacrifices %s protecting you!#LAST#', symb:getName():capitalize(), symb:pronoun('reflexive'))
	local item = who:itemPosition(who:getInven(i_id), obj, true)
	if item then
	  who:removeObject(i_id, item)
	  obj:removed()
	end
	-- I suppose we should pass through to this...
	if orig_on_die then orig_on_die(symb, killer, death_note) end
      end
      -- Vaguely Annoying Hack(TM):  Since the symbiote isn't on the level,
      -- it needs a canAct() method so it can go in the game entities list.
      self.symbiote.canAct = function(symb) return true end
      -- Put the symbiote in the game Entity list so it can :act().
      if not game:hasEntity(self.symbiote) then
	game:addEntity(self.symbiote)
      end
    end
  end,
  on_takeoff = function(self, who, i_id)
    if self.symbiote then
      -- Take the symbiote back out of the game Entity list.
      if game:hasEntity(self.symbiote) then
	game:removeEntity(self.symbiote)
      end
      -- Clear various stuff and restore saved symbiote state.
      self.symbiote.canAct = nil
      if not self.symbiote.dead then
	self.symbiote.ai = self.symbiote.symbiosis.orig_ai
	self.symbiote.on_die = self.symbiote.symbiosis.orig_on_die
	self.symbiote.symbiosis = nil
      end
    end
  end,
  worn_callbacks = {
    on_melee_attack = function(who, self, target, n_hits, n_attacks)
      -- Do a set of the symbiote's melee attacks, unless we're doing them
      -- "live".
      if self.symbiote and not self.symbiote.dead and not config.settings.tome2.live_symbiote then
	self.symbiote:attackTarget(target)
      end
    end,
    on_move = function(who, self, moved, forced, x, y, ox, oy)
      -- Spectacularly Dodgy Hack(TM), redux:  Keep the symbiote's pseudo-
      -- "position" synced to its host actual position.
      if self.symbiote and not self.symbiote.dead then
	self.symbiote.x, self.symbiote.y = x, y
      end
    end,
    on_take_hit_pre = function(who, self, src, p, wpn)
      -- Symbiote might take the damage for us.
      if p.damage <= 0 then return end
      local sym = self.symbiote
      if not sym or sym.dead then return end
      local rsrc = src.resolveSource and src:resolveSource() or src
      if rsrc == sym then return end
      if not who.getSkillLevel then return end
      if rng.percent(5 + who:getSkillLevel('SYMBIOSIS')) then
	game.logPlayer(who, '#YELLOW#%s takes the damage instead of you.#LAST#', sym:getName():capitalize())
	sym:takeHit(p.damage, src)
	p.damage = 0
      end
    end,
  },
  on_use_item_dialog = function(self, actor, inven, item, floor, menu)
    if self.symbiote and not self.symbiote.dead then
      menu[#menu+1] = {
	name = 'Change symbiote name',
	callback = function(a, o, inven, item, floor, on_use)
	  local GetText = require 'engine.dialogs.GetText'
	  local sym = o.symbiote
	  if sym and not sym.dead then game.player:playerSetPetName(sym) end
	  on_use(inven, floor, item, o, true)
	end
      }
    end
  end,
  -- END VERBATIM
}

newEntity {
  define_as = 'RANDOM_ARTIFACT',
  name = 'RANDOM_ARTIFACT',
  display_name = 'Random Artifact',
  type = 'misc',
  subtype = 'junkart',
  tval = 102,
  sval = 0,
  display = '~',
  color = colors.C_o,
  image = 'object/random_artifact.png',
  level = 1,
  extra = 0,
  weight = 5,
  encumber = 5,
  cost = 0,
  insta_art = true,
  flags = { ACTIVATE=true, ACTIVATE_NO_WIELD=true },
  allocation = {
    { level=1, rarity=1 },
    { level=10, rarity=1 },
    { level=20, rarity=1 },
    { level=30, rarity=1 },
  },
  -- BEGIN VERBATIM
  name_cb = function(self, name, t)
    if self.identified and self.max_power then
      name = name .. (' (%d/%d)'):format(self.power, self.max_power)
    end
    return name
  end,
  category = 'magic',
  resolvers.junkart(),
  -- END VERBATIM
}

newEntity {
  base = 'STACK_BY_MON_BASE',
  define_as = 'EGG',
  name = 'EGG',
  display_name = 'Egg',
  type = 'misc',
  subtype = 'egg',
  tval = 10,
  sval = 1,
  display = ',',
  color = colors.C_W,
  image = 'object/egg.png',
  level = 5,
  extra = 0,
  weight = 3,
  encumber = 3,
  cost = 100,
  combat = { 1, 1 },
  flags = { ACTIVATE=true, ACTIVATE_NO_WIELD=true, EASY_KNOW=true },
  allocation = {
    { level=5, rarity=1 },
    { level=15, rarity=1 },
    { level=25, rarity=1 },
    { level=35, rarity=1 },
  },
  -- BEGIN VERBATIM
  category = 'junk',
  destroyed_by = {
    [DamageType.ACID] = true,
    [DamageType.ELEC] = true,
    [DamageType.FIRE] = true,
    [DamageType.COLD] = true,
  },
  price_mod = function(self, value)
    -- Higher price for higher-level monster.
    local m = self.mon_id and game.zone.npc_list[self.mon_id]
    if m then value = value + (m.level or 0) * 100 end
    return value
  end,
  mon_id = resolvers.monster_id(function(e) return not e.unique and e.flags.CAN_FLY end,
				{ fallback='BLUE_FIREBIRD', wgt_div=100 })
  -- END VERBATIM
}

newEntity {
  base = 'TOOL_BASE',
  define_as = 'CLIMBING_SET',
  name = 'CLIMBING_SET',
  display_name = '& Climbing Set~',
  desc = [[A bunch of screws and hooks, a small pick and a very long rope. As long as a wall or rock face isn't really high, this collection of tools should help you across it.]],
  subtype = 'misc',
  tval = 12,
  sval = 0,
  display = '`',
  color = colors.C_B,
  image = 'object/climbing_set.png',
  level = 40,
  extra = 0,
  weight = 0.2,
  encumber = 0.2,
  cost = 50000,
  convey_flags = { CLIMB=true },
  obvious_flags = { convey_flags = { CLIMB=true } },
  allocation = { { level=40, rarity=3 } },
  stacking = true,
}

newEntity {
  base = 'SWORD_BASE',
  define_as = 'DEMONBLADE',
  name = 'DEMONBLADE',
  display_name = '& Demonblade~',
  desc = 'This blade has been taken from the corpse of a demon. Some demonic energy is still coursing through it, helping you slay other demons.',
  sval = 55,
  display = '|',
  color = colors.C_R,
  image = 'object/demonblade.png',
  level = 10,
  weight = 15,
  encumber = 15,
  cost = 500,
  combat = { 4, 6 },
  slay_flags = { DEMON=true },
  flags = { SHOW_MODS=true, WIELD_CAST=true },
  allocation = { { level=10, rarity=1 } },
  is_demongear = true,
  -- BEGIN VERBATIM
  worn_talents = {
    ActorTalents.T_DEMON_BLADE,
    ActorTalents.T_DEMON_MADNESS,
    ActorTalents.T_DEMON_FIELD,
  },
  category = 'magic',
  -- END VERBATIM
}

newEntity {
  base = 'SHIELD_BASE',
  define_as = 'DEMONSHIELD',
  name = 'DEMONSHIELD',
  display_name = '& Demonshield~',
  desc = 'This shield has been taken from the corpse of a demon. Some demonic energy is still coursing through it, giving life to any that wield it.',
  sval = 56,
  display = ']',
  color = colors.C_R,
  image = 'object/demonshield.png',
  level = 15,
  weight = 7,
  encumber = 7,
  cost = 500,
  armor = 5,
  convey_flags = { REGENERATE=true },
  flags = { WIELD_CAST=true },
  allocation = { { level=15, rarity=1 } },
  is_demongear = true,
  -- BEGIN VERBATIM
  worn_talents = {
    ActorTalents.T_DOOM_SHIELD,
    ActorTalents.T_DEMON_CLOAK,
    ActorTalents.T_UNHOLY_WORD,
  },
  category = 'magic',
  -- END VERBATIM
}

newEntity {
  base = 'HELM_BASE',
  define_as = 'DEMONHORN',
  name = 'DEMONHORN',
  display_name = '& Demonhorn~',
  desc = 'This horn is about six feet long.  Just looking at it makes you nervous.',
  sval = 57,
  display = '[',
  color = colors.C_R,
  image = 'object/demonhorn.png',
  level = 20,
  weight = 3,
  encumber = 3,
  cost = 500,
  armor = 2,
  lite = 2,
  flags = { WIELD_CAST=true },
  allocation = { { level=20, rarity=1 } },
  is_demongear = true,
  -- BEGIN VERBATIM
  worn_talents = {
    ActorTalents.T_SUMMON_DEMON,
    ActorTalents.T_DISCHARGE_MINION,
    ActorTalents.T_CONTROL_DEMON,
  },
  category = 'magic',
  -- END VERBATIM
}

newEntity {
  base = 'STACK_BY_MON_BASE',
  define_as = 'PARTIAL_TOTEM',
  name = 'PARTIAL_TOTEM',
  display_name = 'Partial Totem',
  desc = 'An item which a Summoner can use to animate a copy of a creature that only exists by the will of its master.',
  type = 'misc',
  subtype = 'totem',
  tval = 54,
  sval = 1,
  display = '"',
  color = colors.C_v,
  image = 'object/partial_totem.png',
  level = 10,
  extra = 10,
  weight = 1,
  encumber = 1,
  cost = 120,
  combat = { 1, 1 },
  special_gene = true,
  allocation = { { level=10, rarity=200 } },
}

newEntity {
  base = 'STACK_BY_MON_BASE',
  define_as = 'TRUE_TOTEM',
  name = 'TRUE_TOTEM',
  display_name = 'True Totem',
  desc = 'An item which a Summoner can use to revive a true copy of a creature.',
  type = 'misc',
  subtype = 'totem',
  tval = 54,
  sval = 2,
  display = '"',
  color = colors.C_v,
  image = 'object/true_totem.png',
  level = 10,
  extra = 10,
  weight = 1,
  encumber = 1,
  cost = 120,
  combat = { 1, 1 },
  special_gene = true,
  allocation = { { level=10, rarity=200 } },
}
-- 13 total items
-- type:  misc=8
-- subtype:  bottle=1; egg=1; junkart=1; magestaff=1; misc=1; oil=1; spike=1; symbiote=1; totem=2
-- slot:  SYMBIOTE=1
-- display:  !=2; "=2; ,=1; [=1; \\=1; ]=1; `=1; |=1; ~=3
-- color:  colors.C_B=2; colors.C_R=3; colors.C_W=2; colors.C_o=1; colors.C_v=2; colors.C_w=1; colors.C_y=2
-- level:  0=1; 1=3; 10=3; 127=1; 15=1; 20=1; 40=1; 5=2
-- extra:  0=7; 10=2; 200=1
-- weight:  10=4; 12=1; 150=1; 2=2; 30=2; 50=1; 60=1; 70=1
-- cost:  0=2; 1=2; 100=1; 120=2; 3=1; 300=1; 500=3; 50000=1
-- armor:  2=1; 5=1
-- oil:  7500=1
-- stacking:  true=4
-- is_demongear:  true=3
