-- $Id: rings.lua 2667 2016-12-01 00:45:50Z dsb $
-- ToME - Tales of Middle-Earth
-- Copyright © 2012-2016 Scott Bigham
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Scott Bigham "Zizzo"
-- dsb-tome@killerbbunnies.org

-- -----------------------------------------------------------------------
-- WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING
-- -----------------------------------------------------------------------
-- This file was generated automatically by the 'gen_obj' Perl script.
-- DO NOT MODIFY THIS FILE DIRECTLY, as any changes will be lost the next
-- time the file is generated (with the possible exception of lines between
-- 'BEGIN VERBATIM' and 'END VERBATIM' markers, if supported by the script).
-- -----------------------------------------------------------------------
-- WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING
-- -----------------------------------------------------------------------

-- Object entities generated from T2's k_info.txt

newEntity {
  base = 'RING_BASE',
  define_as = 'RING_STRENGTH',
  name = 'RING_STRENGTH',
  display_name = 'Strength',
  desc = 'This bauble magically improves your strength.',
  sval = 24,
  color = colors.C_d,
  image = 'object/ring_placeholder.png',
  level = 30,
  extra = 0,
  cost = 500,
  stat_flags = { STR=true },
  flags = { HIDE_TYPE=true },
  obvious_flags = { stat_flags = { STR=true } },
  allocation = { { level=30, rarity=1 } },
  -- BEGIN VERBATIM
  resolvers.generic(function(e)
    local Object = require 'mod.class.Object'
    local RF = Object.resolve_flags
    e.pval = 1 + obj_util.m_bonus(5, RF.level)
    obj_util.check_cursed(e, {'pval'})
    return nil	-- Delete the origin field
  end),
  -- END VERBATIM
}

newEntity {
  base = 'RING_BASE',
  define_as = 'RING_DEXTERITY',
  name = 'RING_DEXTERITY',
  display_name = 'Dexterity',
  desc = 'This piece of jewellery magically improves your agility.',
  sval = 26,
  color = colors.C_d,
  image = 'object/ring_placeholder.png',
  level = 30,
  extra = 0,
  cost = 500,
  stat_flags = { DEX=true },
  flags = { HIDE_TYPE=true },
  obvious_flags = { stat_flags = { DEX=true } },
  allocation = { { level=30, rarity=1 } },
  -- BEGIN VERBATIM
  resolvers.generic(function(e)
    local Object = require 'mod.class.Object'
    local RF = Object.resolve_flags
    e.pval = 1 + obj_util.m_bonus(5, RF.level)
    obj_util.check_cursed(e, {'pval'})
    return nil	-- Delete the origin field
  end),
  -- END VERBATIM
}

newEntity {
  base = 'RING_BASE',
  define_as = 'RING_CONSTITUTION',
  name = 'RING_CONSTITUTION',
  display_name = 'Constitution',
  desc = 'This ring magically grants you health, improving your constitution.',
  sval = 27,
  color = colors.C_d,
  image = 'object/ring_placeholder.png',
  level = 30,
  extra = 0,
  cost = 500,
  stat_flags = { CON=true },
  flags = { HIDE_TYPE=true },
  obvious_flags = { stat_flags = { CON=true } },
  allocation = { { level=30, rarity=1 } },
  -- BEGIN VERBATIM
  resolvers.generic(function(e)
    local Object = require 'mod.class.Object'
    local RF = Object.resolve_flags
    e.pval = 1 + obj_util.m_bonus(5, RF.level)
    obj_util.check_cursed(e, {'pval'})
    return nil	-- Delete the origin field
  end),
  -- END VERBATIM
}

newEntity {
  base = 'RING_BASE',
  define_as = 'RING_INTELLIGENCE',
  name = 'RING_INTELLIGENCE',
  display_name = 'Intelligence',
  desc = 'This magical piece of jewellery makes you smarter.',
  sval = 25,
  color = colors.C_d,
  image = 'object/ring_placeholder.png',
  level = 30,
  extra = 0,
  cost = 500,
  stat_flags = { INT=true },
  flags = { HIDE_TYPE=true },
  obvious_flags = { stat_flags = { INT=true } },
  allocation = { { level=30, rarity=1 } },
  -- BEGIN VERBATIM
  resolvers.generic(function(e)
    local Object = require 'mod.class.Object'
    local RF = Object.resolve_flags
    e.pval = 1 + obj_util.m_bonus(5, RF.level)
    obj_util.check_cursed(e, {'pval'})
    return nil	-- Delete the origin field
  end),
  -- END VERBATIM
}

newEntity {
  base = 'RING_BASE',
  define_as = 'RING_SPEED',
  name = 'RING_SPEED',
  display_name = 'Speed',
  desc = 'This wonderful ring grants you additional energy, allowing you to act faster.',
  sval = 31,
  color = colors.C_d,
  image = 'object/ring_placeholder.png',
  level = 75,
  extra = 0,
  cost = 100000,
  pval_flags = { speed=true },
  flags = { HIDE_TYPE=true },
  obvious_flags = { pval_flags = { speed=true } },
  allocation = { { level=75, rarity=1 } },
  -- BEGIN VERBATIM
  rating = 25,
  resolvers.generic(function(e)
    local Object = require 'mod.class.Object'
    local RF = Object.resolve_flags
    e.pval = rng.range(1, 5) + obj_util.m_bonus(5, RF.level)
    -- Super-charge the ring
    while rng.percent(50) do e.pval = e.pval + 1 end
    obj_util.check_cursed(e, {'pval'})
    return nil	-- Delete the origin field
  end),
  resolvers.precog_mention(),
  -- END VERBATIM
}

newEntity {
  base = 'RING_BASE',
  define_as = 'RING_SEARCHING',
  name = 'RING_SEARCHING',
  display_name = 'Searching',
  desc = 'This ring magically improves your attention, so you can detect hidden things better.',
  sval = 23,
  color = colors.C_d,
  image = 'object/ring_placeholder.png',
  level = 5,
  extra = 0,
  cost = 250,
  pval_flags = { skill_searching=true, skill_perception=true },
  flags = { HIDE_TYPE=true },
  obvious_flags = { pval_flags = { skill_searching=true } },
  allocation = { { level=5, rarity=1 } },
  -- BEGIN VERBATIM
  resolvers.generic(function(e)
    local Object = require 'mod.class.Object'
    local RF = Object.resolve_flags
    e.pval = 1 + obj_util.m_bonus(5, RF.level)
    obj_util.check_cursed(e, {'pval'})
    return nil	-- Delete the origin field
  end),
  -- END VERBATIM
}

newEntity {
  base = 'RING_BASE',
  define_as = 'RING_TELEPORTATION',
  name = 'RING_TELEPORTATION',
  display_name = 'Teleportation',
  desc = 'This ring will uncontrollably send you to different places at its whim. You can use its power once at your will, but it will destroy the ring.',
  sval = 4,
  color = colors.C_d,
  image = 'object/ring_placeholder.png',
  level = 5,
  extra = 0,
  cost = 250,
  convey_flags = { TELEPORT=true },
  flags = { CURSED=true, EASY_KNOW=true },
  obvious_flags = { convey_flags = { TELEPORT=true } },
  allocation = { { level=5, rarity=1 } },
  -- Placeholder until we define this.
  use_simple = {
    use = function(self, who, inven, floor, item)
      game.log('[Sorry, not implemented (DEST_TELE)]')
    end,
    name = [[do something unimplemented (DEST_TELE)]],
  },
  cant_use_if = { not_wielded=true },
}

newEntity {
  base = 'RING_BASE',
  define_as = 'RING_SLOW_DIGESTION',
  name = 'RING_SLOW_DIGESTION',
  display_name = 'Slow Digestion',
  desc = 'This magical bauble grants you some sustenance, allowing you to subsist on less food.',
  sval = 6,
  color = colors.C_d,
  image = 'object/ring_placeholder.png',
  level = 5,
  extra = 0,
  cost = 250,
  convey_flags = { SLOW_DIGEST=true },
  flags = { EASY_KNOW=true },
  obvious_flags = { convey_flags = { SLOW_DIGEST=true } },
  allocation = { { level=5, rarity=1 } },
}

newEntity {
  base = 'RING_BASE',
  define_as = 'RING_FIRE_RESISTANCE',
  name = 'RING_FIRE_RESISTANCE',
  display_name = 'Fire Resistance',
  desc = 'This piece of jewellery grants you some protection from the burning heat of fire.',
  sval = 8,
  color = colors.C_d,
  image = 'object/ring_placeholder.png',
  level = 10,
  extra = 0,
  cost = 250,
  convey_resist_dam = { [DamageType.FIRE]=true },
  flags = { EASY_KNOW=true },
  ignore_dam = { [DamageType.FIRE]=true },
  obvious_flags = { convey_resist_dam = { [DamageType.FIRE]=true } },
  allocation = { { level=10, rarity=1 } },
}

newEntity {
  base = 'RING_BASE',
  define_as = 'RING_COLD_RESISTANCE',
  name = 'RING_COLD_RESISTANCE',
  display_name = 'Cold Resistance',
  desc = 'This piece of jewellery grants you some protection from the chilling forces of cold.',
  sval = 9,
  color = colors.C_d,
  image = 'object/ring_placeholder.png',
  level = 10,
  extra = 0,
  cost = 250,
  convey_resist_dam = { [DamageType.COLD]=true },
  flags = { EASY_KNOW=true },
  ignore_dam = { [DamageType.COLD]=true },
  obvious_flags = { convey_resist_dam = { [DamageType.COLD]=true } },
  allocation = { { level=10, rarity=1 } },
}

newEntity {
  base = 'RING_BASE',
  define_as = 'RING_LEVITATION',
  name = 'RING_LEVITATION',
  display_name = 'Levitation',
  desc = 'When you put on this ring, you will be able to float just above the floor. It prevents you from drowning, and all your falls will be painless.',
  sval = 7,
  color = colors.C_d,
  image = 'object/ring_placeholder.png',
  level = 5,
  extra = 0,
  cost = 200,
  convey_flags = { FEATHER=true },
  flags = { EASY_KNOW=true },
  obvious_flags = { convey_flags = { FEATHER=true } },
  allocation = { { level=5, rarity=1 } },
}

newEntity {
  base = 'RING_BASE',
  define_as = 'RING_POISON_RESISTANCE',
  name = 'RING_POISON_RESISTANCE',
  display_name = 'Poison Resistance',
  desc = [[This magical ring grants protection from poison. It is rumoured that in deep dungeons monsters can kill you at once if you don't have poison resistance.]],
  sval = 20,
  color = colors.C_d,
  image = 'object/ring_placeholder.png',
  level = 60,
  extra = 0,
  cost = 16000,
  convey_resist_dam = { [DamageType.POISON]=true },
  flags = { EASY_KNOW=true },
  obvious_flags = { convey_resist_dam = { [DamageType.POISON]=true } },
  allocation = { { level=60, rarity=2 } },
}

newEntity {
  base = 'RING_BASE',
  define_as = 'RING_FREE_ACTION',
  name = 'RING_FREE_ACTION',
  display_name = 'Free Action',
  desc = 'This magical bauble prevents you from being held. Some monsters will paralyse you and then kill you if you lack free action.',
  sval = 21,
  color = colors.C_d,
  image = 'object/ring_placeholder.png',
  level = 20,
  extra = 0,
  cost = 1500,
  convey_flags = { FREE_ACT=true },
  flags = { EASY_KNOW=true },
  obvious_flags = { convey_flags = { FREE_ACT=true } },
  allocation = { { level=20, rarity=1 } },
}

newEntity {
  base = 'RING_BASE',
  define_as = 'RING_WEAKNESS',
  name = 'RING_WEAKNESS',
  display_name = 'Weakness',
  desc = 'This accursed ring will sap your strength, rendering you much weaker as long as you wear it.',
  sval = 2,
  color = colors.C_d,
  image = 'object/ring_placeholder.png',
  level = 5,
  extra = 0,
  cost = 0,
  stat_flags = { STR=true },
  flags = { CURSED=true, HIDE_TYPE=true },
  obvious_flags = { stat_flags = { STR=true } },
  allocation = { { level=5, rarity=1 } },
  -- BEGIN VERBATIM
  resolvers.generic(function(e)
    local Object = require 'mod.class.Object'
    local RF = Object.resolve_flags
    -- TODO flag as cursed
    e.pval = -1 - obj_util.m_bonus(5, RF.level)
    return nil	-- Delete the origin field
  end),
  -- END VERBATIM
}

newEntity {
  base = 'RING_BASE',
  define_as = 'RING_FLAMES',
  name = 'RING_FLAMES',
  display_name = 'Flames',
  desc = 'This fiery circlet grants you protection, makes fire less dangerous and even allows you to call forth a ball of flame.',
  sval = 18,
  color = colors.C_d,
  image = 'object/ring_placeholder.png',
  level = 50,
  extra = 0,
  cost = 3000,
  combat = { 0, 0 },
  to_a = 15,
  convey_resist_dam = { [DamageType.FIRE]=true },
  ignore_dam = { [DamageType.FIRE]=true },
  obvious_flags = { convey_resist_dam = { [DamageType.FIRE]=true } },
  allocation = { { level=50, rarity=1 } },
  -- Placeholder until we define this.
  use_simple = {
    use = function(self, who, inven, floor, item)
      game.log('[Sorry, not implemented (BA_FIRE_4)]')
    end,
    name = [[do something unimplemented (BA_FIRE_4)]],
  },
  cant_use_if = { not_wielded=true },
  -- BEGIN VERBATIM
  resolvers.generic(function(e)
    local Object = require 'mod.class.Object'
    local RF = Object.resolve_flags
    e.to_a = rng.range(6, 10) + obj_util.m_bonus(10, RF.level)
    return nil	-- Delete the origin field
  end),
  -- END VERBATIM
}

newEntity {
  base = 'RING_BASE',
  define_as = 'RING_ACID',
  name = 'RING_ACID',
  display_name = 'Acid',
  desc = 'This magical ring is imbued with spells of devouring acid, granting protection against such assaults and the ability to shoot acid at your foes.',
  sval = 17,
  color = colors.C_d,
  image = 'object/ring_placeholder.png',
  level = 50,
  extra = 0,
  cost = 3000,
  combat = { 0, 0 },
  to_a = 15,
  convey_resist_dam = { [DamageType.ACID]=true },
  ignore_dam = { [DamageType.ACID]=true },
  obvious_flags = { convey_resist_dam = { [DamageType.ACID]=true } },
  allocation = { { level=50, rarity=1 } },
  -- Placeholder until we define this.
  use_simple = {
    use = function(self, who, inven, floor, item)
      game.log('[Sorry, not implemented (BA_ACID_4)]')
    end,
    name = [[do something unimplemented (BA_ACID_4)]],
  },
  cant_use_if = { not_wielded=true },
  -- BEGIN VERBATIM
  resolvers.generic(function(e)
    local Object = require 'mod.class.Object'
    local RF = Object.resolve_flags
    e.to_a = rng.range(6, 10) + obj_util.m_bonus(10, RF.level)
    return nil	-- Delete the origin field
  end),
  -- END VERBATIM
}

newEntity {
  base = 'RING_BASE',
  define_as = 'RING_ICE',
  name = 'RING_ICE',
  display_name = 'Ice',
  desc = 'This ring is imbued with supernatural cold, which makes you less vulnerable to such effects and occasionally allows you to throw balls of ice at your foes.',
  sval = 19,
  color = colors.C_d,
  image = 'object/ring_placeholder.png',
  level = 50,
  extra = 0,
  cost = 3000,
  combat = { 0, 0 },
  to_a = 15,
  convey_resist_dam = { [DamageType.COLD]=true },
  ignore_dam = { [DamageType.COLD]=true },
  obvious_flags = { convey_resist_dam = { [DamageType.COLD]=true } },
  allocation = { { level=50, rarity=1 } },
  -- Placeholder until we define this.
  use_simple = {
    use = function(self, who, inven, floor, item)
      game.log('[Sorry, not implemented (BA_COLD_4)]')
    end,
    name = [[do something unimplemented (BA_COLD_4)]],
  },
  cant_use_if = { not_wielded=true },
  -- BEGIN VERBATIM
  resolvers.generic(function(e)
    local Object = require 'mod.class.Object'
    local RF = Object.resolve_flags
    e.to_a = rng.range(6, 10) + obj_util.m_bonus(10, RF.level)
    return nil	-- Delete the origin field
  end),
  -- END VERBATIM
}

newEntity {
  base = 'RING_BASE',
  define_as = 'RING_WOE',
  name = 'RING_WOE',
  display_name = 'Woe',
  desc = 'This accursed ring will turn you into a bumbling fool and, in addition, magically transports you to places you never wanted to see. It can recurse itself if you leave it on too long.',
  sval = 0,
  color = colors.C_d,
  image = 'object/ring_placeholder.png',
  level = 50,
  extra = 0,
  cost = 0,
  convey_flags = { TELEPORT=true },
  stat_flags = { WIS=true, CHA=true },
  flags = { CURSED=true, HIDE_TYPE=true, AUTO_CURSE=true },
  allocation = { { level=50, rarity=1 } },
  -- BEGIN VERBATIM
  resolvers.generic(function(e)
    local Object = require 'mod.class.Object'
    local RF = Object.resolve_flags
    -- TODO flag as cursed
    e.to_a = -5 - obj_util.m_bonus(10, RF.level)
    e.pval = -1 - obj_util.m_bonus(5, RF.level)
    return nil	-- Delete the origin field
  end),
  -- END VERBATIM
}

newEntity {
  base = 'RING_BASE',
  define_as = 'RING_STUPIDITY',
  name = 'RING_STUPIDITY',
  display_name = 'Stupidity',
  desc = 'This wicked ring feeds off your intellect, magically making you stupid.',
  sval = 3,
  color = colors.C_d,
  image = 'object/ring_placeholder.png',
  level = 5,
  extra = 0,
  cost = 0,
  stat_flags = { INT=true },
  flags = { CURSED=true, HIDE_TYPE=true },
  obvious_flags = { stat_flags = { INT=true } },
  allocation = { { level=5, rarity=1 } },
  -- BEGIN VERBATIM
  resolvers.generic(function(e)
    local Object = require 'mod.class.Object'
    local RF = Object.resolve_flags
    -- TODO flag as cursed
    e.pval = -1 - obj_util.m_bonus(5, RF.level)
    return nil	-- Delete the origin field
  end),
  -- END VERBATIM
}

newEntity {
  base = 'RING_BASE',
  define_as = 'RING_DAMAGE',
  name = 'RING_DAMAGE',
  display_name = 'Damage',
  desc = 'This ring makes your hands magically strong in combat, allowing you to inflict greater pain with your hand-to-hand attacks.',
  sval = 29,
  color = colors.C_d,
  image = 'object/ring_placeholder.png',
  level = 20,
  extra = 0,
  cost = 500,
  flags = { HIDE_TYPE=true },
  allocation = { { level=20, rarity=1 } },
  -- BEGIN VERBATIM
  resolvers.generic(function(e)
    local Object = require 'mod.class.Object'
    local RF = Object.resolve_flags
    e.to_d = rng.range(6, 13) + obj_util.m_bonus(10, RF.level)
    obj_util.check_cursed(e, {'to_d'})
    return nil	-- Delete the origin field
  end),
  -- END VERBATIM
}

newEntity {
  base = 'RING_BASE',
  define_as = 'RING_ACCURACY',
  name = 'RING_ACCURACY',
  display_name = 'Accuracy',
  desc = 'This ring magically improves your control in combat, allowing you to hit more often.',
  sval = 28,
  color = colors.C_d,
  image = 'object/ring_placeholder.png',
  level = 20,
  extra = 0,
  cost = 500,
  flags = { HIDE_TYPE=true },
  allocation = { { level=20, rarity=1 } },
  -- BEGIN VERBATIM
  resolvers.generic(function(e)
    local Object = require 'mod.class.Object'
    local RF = Object.resolve_flags
    e.to_h = rng.range(6, 13) + obj_util.m_bonus(10, RF.level)
    obj_util.check_cursed(e, {'to_h'})
    return nil	-- Delete the origin field
  end),
  -- END VERBATIM
}

newEntity {
  base = 'RING_BASE',
  define_as = 'RING_PROTECTION',
  name = 'RING_PROTECTION',
  display_name = 'Protection',
  desc = 'This ring creates a magical aura around you, protecting you against the blows of your enemies.',
  sval = 16,
  color = colors.C_d,
  image = 'object/ring_placeholder.png',
  level = 10,
  extra = 0,
  cost = 500,
  allocation = { { level=10, rarity=1 } },
  -- BEGIN VERBATIM
  resolvers.generic(function(e)
    local Object = require 'mod.class.Object'
    local RF = Object.resolve_flags
    e.to_a = rng.range(6, 13) + obj_util.m_bonus(10, RF.level)
    obj_util.check_cursed(e, {'to_a'})
    return nil	-- Delete the origin field
  end),
  -- END VERBATIM
}

newEntity {
  base = 'RING_BASE',
  define_as = 'RING_AGGRAVATE_MONSTER',
  name = 'RING_AGGRAVATE_MONSTER',
  display_name = 'Aggravate Monster',
  desc = [[This faithless ring will draw opponents' attention towards its hapless owner.]],
  sval = 1,
  color = colors.C_d,
  image = 'object/ring_placeholder.png',
  level = 5,
  extra = 0,
  cost = 0,
  convey_flags = { AGGRAVATE=true },
  flags = { CURSED=true, EASY_KNOW=true, AUTO_CURSE=true },
  obvious_flags = { convey_flags = { AGGRAVATE=true } },
  allocation = { { level=5, rarity=1 } },
}

newEntity {
  base = 'RING_BASE',
  define_as = 'RING_SEE_INVISIBLE',
  name = 'RING_SEE_INVISIBLE',
  display_name = 'See Invisible',
  desc = 'This magical piece of jewellery allows your eyes to perceive beings otherwise unseen.',
  sval = 22,
  color = colors.C_d,
  image = 'object/ring_placeholder.png',
  level = 30,
  extra = 0,
  cost = 340,
  convey_flags = { SEE_INVIS=true },
  flags = { EASY_KNOW=true },
  obvious_flags = { convey_flags = { SEE_INVIS=true } },
  allocation = { { level=30, rarity=1 } },
}

newEntity {
  base = 'RING_BASE',
  define_as = 'RING_SUSTAIN_STRENGTH',
  name = 'RING_SUSTAIN_STRENGTH',
  display_name = 'Sustain Strength',
  desc = 'This magical bauble protects your physical force against attacks attempting to drain it.',
  sval = 10,
  color = colors.C_d,
  image = 'object/ring_placeholder.png',
  level = 20,
  extra = 0,
  cost = 400,
  convey_flags = { SUST_STR=true },
  flags = { EASY_KNOW=true },
  obvious_flags = { convey_flags = { SUST_STR=true } },
  allocation = { { level=20, rarity=1 } },
}

newEntity {
  base = 'RING_BASE',
  define_as = 'RING_SUSTAIN_INTELLIGENCE',
  name = 'RING_SUSTAIN_INTELLIGENCE',
  display_name = 'Sustain Intelligence',
  desc = 'This magical ring protects your intellect against attempts to lower it.',
  sval = 11,
  color = colors.C_d,
  image = 'object/ring_placeholder.png',
  level = 20,
  extra = 0,
  cost = 400,
  convey_flags = { SUST_INT=true },
  flags = { EASY_KNOW=true },
  obvious_flags = { convey_flags = { SUST_INT=true } },
  allocation = { { level=20, rarity=1 } },
}

newEntity {
  base = 'RING_BASE',
  define_as = 'RING_SUSTAIN_WISDOM',
  name = 'RING_SUSTAIN_WISDOM',
  display_name = 'Sustain Wisdom',
  desc = 'This magical ring protects you from attempts to make you more foolish.',
  sval = 12,
  color = colors.C_d,
  image = 'object/ring_placeholder.png',
  level = 20,
  extra = 0,
  cost = 400,
  convey_flags = { SUST_WIS=true },
  flags = { EASY_KNOW=true },
  obvious_flags = { convey_flags = { SUST_WIS=true } },
  allocation = { { level=20, rarity=1 } },
}

newEntity {
  base = 'RING_BASE',
  define_as = 'RING_SUSTAIN_CONSTITUTION',
  name = 'RING_SUSTAIN_CONSTITUTION',
  display_name = 'Sustain Constitution',
  desc = 'This magical ring protects your health, making it impossible for your opponents to lower it.',
  sval = 13,
  color = colors.C_d,
  image = 'object/ring_placeholder.png',
  level = 20,
  extra = 0,
  cost = 400,
  convey_flags = { SUST_CON=true },
  flags = { EASY_KNOW=true },
  obvious_flags = { convey_flags = { SUST_CON=true } },
  allocation = { { level=20, rarity=1 } },
}

newEntity {
  base = 'RING_BASE',
  define_as = 'RING_SUSTAIN_DEXTERITY',
  name = 'RING_SUSTAIN_DEXTERITY',
  display_name = 'Sustain Dexterity',
  desc = 'This magical ring protects your nerves, so that you will never become clumsy.',
  sval = 14,
  color = colors.C_d,
  image = 'object/ring_placeholder.png',
  level = 20,
  extra = 0,
  cost = 400,
  convey_flags = { SUST_DEX=true },
  flags = { EASY_KNOW=true },
  obvious_flags = { convey_flags = { SUST_DEX=true } },
  allocation = { { level=20, rarity=1 } },
}

newEntity {
  base = 'RING_BASE',
  define_as = 'RING_SUSTAIN_CHARISMA',
  name = 'RING_SUSTAIN_CHARISMA',
  display_name = 'Sustain Charisma',
  desc = 'This ring magically protects your beauty and charm from attempts to make you ugly.',
  sval = 15,
  color = colors.C_d,
  image = 'object/ring_placeholder.png',
  level = 20,
  extra = 0,
  cost = 400,
  convey_flags = { SUST_CHA=true },
  flags = { EASY_KNOW=true },
  obvious_flags = { convey_flags = { SUST_CHA=true } },
  allocation = { { level=20, rarity=1 } },
}

newEntity {
  base = 'RING_BASE',
  define_as = 'RING_SLAYING',
  name = 'RING_SLAYING',
  display_name = 'Slaying',
  desc = 'This ring magically improves your fighting prowess, allowing to hit more often and harder.',
  sval = 30,
  color = colors.C_d,
  image = 'object/ring_placeholder.png',
  level = 40,
  extra = 0,
  cost = 1000,
  flags = { SHOW_MODS=true },
  allocation = { { level=40, rarity=1 } },
  -- BEGIN VERBATIM
  resolvers.generic(function(e)
    local Object = require 'mod.class.Object'
    local RF = Object.resolve_flags
    e.to_d = rng.range(1, 7) + obj_util.m_bonus(10, RF.level)
    e.to_h = rng.range(1, 7) + obj_util.m_bonus(10, RF.level)
    obj_util.check_cursed(e, {'to_h', 'to_d'})
    return nil	-- Delete the origin field
  end),
  -- END VERBATIM
}

newEntity {
  base = 'RING_BASE',
  define_as = 'RING_SPELL',
  name = 'RING_SPELL',
  display_name = 'Spell',
  desc = 'This ring is a container for spells. Those that are skilled in copying spells can inscribe a spell into it.',
  sval = 58,
  color = colors.C_d,
  image = 'object/ring_placeholder.png',
  level = 10,
  extra = 0,
  cost = 1000,
  flags = { SPELL_CONTAIN=true, WIELD_CAST=true },
  obvious_flags = { flags = { SPELL_CONTAIN=true } },
  allocation = { { level=10, rarity=1 } },
}

newEntity {
  base = 'RING_BASE',
  define_as = 'RING_FEAR_RESISTANCE',
  name = 'RING_FEAR_RESISTANCE',
  display_name = 'Fear Resistance',
  desc = 'This ring grants courage, so that you can never become afraid.',
  sval = 38,
  color = colors.C_d,
  image = 'object/ring_placeholder.png',
  level = 10,
  extra = 0,
  cost = 300,
  convey_resist_dam = { [DamageType.FEAR]=true },
  flags = { EASY_KNOW=true },
  obvious_flags = { convey_resist_dam = { [DamageType.FEAR]=true } },
  allocation = { { level=10, rarity=2 } },
}

newEntity {
  base = 'RING_BASE',
  define_as = 'RING_LIGHT_AND_DARKNESS_RESISTANCE',
  name = 'RING_LIGHT_AND_DARKNESS_RESISTANCE',
  display_name = 'Light and Darkness Resistance',
  desc = 'This ring protects against fluctuations of the light.',
  sval = 39,
  color = colors.C_d,
  image = 'object/ring_placeholder.png',
  level = 30,
  extra = 0,
  cost = 3000,
  convey_resist_dam = { [DamageType.LITE]=true, [DamageType.DARK]=true },
  flags = { EASY_KNOW=true },
  obvious_flags = { convey_resist_dam = { [DamageType.LITE]=true, [DamageType.DARK]=true } },
  allocation = { { level=30, rarity=2 } },
}

newEntity {
  base = 'RING_BASE',
  define_as = 'RING_NETHER_RESISTANCE',
  name = 'RING_NETHER_RESISTANCE',
  display_name = 'Nether Resistance',
  desc = 'This blessed ring improves your life force, protecting you from the draining forces of nether and other attempts to suck your lifeblood.',
  sval = 40,
  color = colors.C_d,
  image = 'object/ring_placeholder.png',
  level = 34,
  extra = 0,
  cost = 14500,
  convey_resist_dam = { [DamageType.NETHER]=true },
  convey_flags = { HOLD_LIFE=true },
  flags = { EASY_KNOW=true },
  obvious_flags = { convey_resist_dam = { [DamageType.NETHER]=true } },
  allocation = { { level=34, rarity=2 } },
}

newEntity {
  base = 'RING_BASE',
  define_as = 'RING_NEXUS_RESISTANCE',
  name = 'RING_NEXUS_RESISTANCE',
  display_name = 'Nexus Resistance',
  desc = 'This ring of stability protects you from the warping forces of nexus.',
  sval = 41,
  color = colors.C_d,
  image = 'object/ring_placeholder.png',
  level = 24,
  extra = 0,
  cost = 3000,
  convey_resist_dam = { [DamageType.NEXUS]=true },
  flags = { EASY_KNOW=true },
  obvious_flags = { convey_resist_dam = { [DamageType.NEXUS]=true } },
  allocation = { { level=24, rarity=2 } },
}

newEntity {
  base = 'RING_BASE',
  define_as = 'RING_SOUND_RESISTANCE',
  name = 'RING_SOUND_RESISTANCE',
  display_name = 'Sound Resistance',
  desc = 'This ring projects an aura of quiet around you, protecting you from loud noise.',
  sval = 42,
  color = colors.C_d,
  image = 'object/ring_placeholder.png',
  level = 26,
  extra = 0,
  cost = 3000,
  convey_resist_dam = { [DamageType.SOUND]=true },
  flags = { EASY_KNOW=true },
  obvious_flags = { convey_resist_dam = { [DamageType.SOUND]=true } },
  allocation = { { level=26, rarity=2 } },
}

newEntity {
  base = 'RING_BASE',
  define_as = 'RING_CONFUSION_RESISTANCE',
  name = 'RING_CONFUSION_RESISTANCE',
  display_name = 'Confusion Resistance',
  desc = 'This ring stabilises your mind, protecting you from all kinds of befuddlement.',
  sval = 43,
  color = colors.C_d,
  image = 'object/ring_placeholder.png',
  level = 22,
  extra = 0,
  cost = 3000,
  convey_resist_dam = { [DamageType.CONFUSION]=true },
  flags = { EASY_KNOW=true },
  obvious_flags = { convey_resist_dam = { [DamageType.CONFUSION]=true } },
  allocation = { { level=22, rarity=2 } },
}

newEntity {
  base = 'RING_BASE',
  define_as = 'RING_SHARD_RESISTANCE',
  name = 'RING_SHARD_RESISTANCE',
  display_name = 'Shard Resistance',
  desc = 'This piece of jewellery magically toughens your skin, protecting you from flying shrapnel.',
  sval = 44,
  color = colors.C_d,
  image = 'object/ring_placeholder.png',
  level = 25,
  extra = 0,
  cost = 3000,
  convey_resist_dam = { [DamageType.SHARDS]=true },
  flags = { EASY_KNOW=true },
  obvious_flags = { convey_resist_dam = { [DamageType.SHARDS]=true } },
  allocation = { { level=25, rarity=2 } },
}

newEntity {
  base = 'RING_BASE',
  define_as = 'RING_DISENCHANTMENT_RESISTANCE',
  name = 'RING_DISENCHANTMENT_RESISTANCE',
  display_name = 'Disenchantment Resistance',
  desc = 'This rare ring of preservation protects your equipment from attempts to sap its magic, also causing you to suffer less pain from such attacks.',
  sval = 45,
  color = colors.C_d,
  image = 'object/ring_placeholder.png',
  level = 90,
  extra = 0,
  cost = 15000,
  convey_resist_dam = { [DamageType.DISENCHANT]=true },
  flags = { EASY_KNOW=true },
  obvious_flags = { convey_resist_dam = { [DamageType.DISENCHANT]=true } },
  allocation = { { level=90, rarity=10 } },
}

newEntity {
  base = 'RING_BASE',
  define_as = 'RING_CHAOS_RESISTANCE',
  name = 'RING_CHAOS_RESISTANCE',
  display_name = 'Chaos Resistance',
  desc = 'This ring protects you from the horribly warping forces of chaos.',
  sval = 46,
  color = colors.C_d,
  image = 'object/ring_placeholder.png',
  level = 50,
  extra = 0,
  cost = 13000,
  convey_resist_dam = { [DamageType.CHAOS]=true, [DamageType.CONFUSION]=true },
  flags = { EASY_KNOW=true },
  obvious_flags = { convey_resist_dam = { [DamageType.CHAOS]=true } },
  allocation = { { level=50, rarity=2 } },
}

newEntity {
  base = 'RING_BASE',
  define_as = 'RING_BLINDNESS_RESISTANCE',
  name = 'RING_BLINDNESS_RESISTANCE',
  display_name = 'Blindness Resistance',
  desc = 'This ring magically preserves your eyesight, making you impervious to any attempt to blind you.',
  sval = 47,
  color = colors.C_d,
  image = 'object/ring_placeholder.png',
  level = 60,
  extra = 0,
  cost = 7500,
  convey_resist_dam = { [DamageType.BLIND]=true },
  flags = { EASY_KNOW=true },
  obvious_flags = { convey_resist_dam = { [DamageType.BLIND]=true } },
  allocation = { { level=60, rarity=2 } },
}

newEntity {
  base = 'RING_BASE',
  define_as = 'RING_LORDLY_PROTECTION',
  name = 'RING_LORDLY_PROTECTION',
  display_name = 'Lordly Protection',
  desc = 'This blessed ring will protect you from disenchantment, poison, attempts to drain your life force and holding magic.',
  sval = 48,
  color = colors.C_d,
  image = 'object/ring_placeholder.png',
  level = 100,
  extra = 0,
  cost = 100000,
  convey_resist_dam = { [DamageType.DISENCHANT]=true, [DamageType.POISON]=true },
  convey_flags = { HOLD_LIFE=true, FREE_ACT=true },
  obvious_flags = {
    convey_resist_dam = { [DamageType.DISENCHANT]=true, [DamageType.POISON]=true },
    convey_flags = { HOLD_LIFE=true, FREE_ACT=true }
  },
  allocation = { { level=100, rarity=5 } },
  -- BEGIN VERBATIM
  rating = 5,
  resolvers.generic(function(e)
    local Object = require 'mod.class.Object'
    local RF = Object.resolve_flags
    repeat obj_util.random_resistance(e, rng.range(19, 38)) until not rng.chance(4)
    e.to_a = 10 + rng.range(1, 5) + obj_util.m_bonus(10, RF.level)
    return nil	-- Delete the origin field
  end),
  -- END VERBATIM
}

newEntity {
  base = 'RING_BASE',
  define_as = 'RING_EXTRA_ATTACKS',
  name = 'RING_EXTRA_ATTACKS',
  display_name = 'Extra Attacks',
  desc = 'This powerful ring of fighters greatly enhances your fighting speed, allowing you to attack more often in a round of combat.',
  sval = 49,
  color = colors.C_d,
  image = 'object/ring_placeholder.png',
  level = 50,
  extra = 0,
  cost = 100000,
  pval_flags = { extra_blows=true },
  obvious_flags = { pval_flags = { extra_blows=true } },
  allocation = { { level=50, rarity=2 } },
  -- BEGIN VERBATIM
  resolvers.generic(function(e)
    local Object = require 'mod.class.Object'
    local RF = Object.resolve_flags
    e.pval = math.max(1, obj_util.m_bonus(3, RF.level))
    obj_util.check_cursed(e, {'pval'})
    return nil	-- Delete the origin field
  end),
  -- END VERBATIM
}

newEntity {
  base = 'RING_BASE',
  define_as = 'DURIN_BASE',
  name = 'DURIN_BASE',
  display_name = '& Ring~',
  sval = 57,
  color = colors.C_d,
  image = 'object/ring_placeholder.png',
  level = 70,
  extra = 0,
  cost = 65000,
  insta_art = true,
  special_gene = true,
}

newEntity {
  base = 'RING_BASE',
  define_as = 'BARAHIR_BASE',
  name = 'BARAHIR_BASE',
  display_name = '& Ring~',
  sval = 32,
  color = colors.C_d,
  image = 'object/ring_placeholder.png',
  level = 50,
  extra = 0,
  cost = 65000,
  insta_art = true,
}

newEntity {
  base = 'RING_BASE',
  define_as = 'TULKAS_BASE',
  name = 'TULKAS_BASE',
  display_name = '& Ring~',
  sval = 33,
  color = colors.C_d,
  image = 'object/ring_placeholder.png',
  level = 90,
  extra = 0,
  cost = 150000,
  insta_art = true,
}

newEntity {
  base = 'RING_BASE',
  define_as = 'NARYA_BASE',
  name = 'NARYA_BASE',
  display_name = '& Ring~',
  sval = 34,
  color = colors.C_d,
  image = 'object/ring_placeholder.png',
  level = 80,
  extra = 0,
  cost = 100000,
  insta_art = true,
  special_gene = true,
}

newEntity {
  base = 'RING_BASE',
  define_as = 'NENYA_BASE',
  name = 'NENYA_BASE',
  display_name = '& Ring~',
  sval = 35,
  color = colors.C_d,
  image = 'object/ring_placeholder.png',
  level = 90,
  extra = 0,
  cost = 200000,
  insta_art = true,
}

newEntity {
  base = 'RING_BASE',
  define_as = 'VILYA_BASE',
  name = 'VILYA_BASE',
  display_name = '& Ring~',
  sval = 36,
  color = colors.C_d,
  image = 'object/ring_placeholder.png',
  level = 100,
  extra = 0,
  cost = 300000,
  insta_art = true,
}

newEntity {
  base = 'RING_BASE',
  define_as = 'ONE_RING_BASE',
  name = 'ONE_RING_BASE',
  display_name = '& Ring~',
  sval = 37,
  color = colors.C_y,
  image = 'object/ring_placeholder.png',
  level = 110,
  extra = 0,
  cost = 5000000,
  insta_art = true,
}

newEntity {
  base = 'RING_BASE',
  define_as = 'RING_NOTHING',
  name = 'RING_NOTHING',
  display_name = 'Nothing',
  sval = 50,
  color = colors.C_d,
  image = 'object/ring_placeholder.png',
  level = 5,
  extra = 0,
  cost = 20,
  combat = { 1, 1 },
  allocation = { { level=5, rarity=1 } },
}

newEntity {
  base = 'RING_BASE',
  define_as = 'RING_LIGHTNING',
  name = 'RING_LIGHTNING',
  display_name = 'Lightning',
  desc = 'This sparkling circlet grants you protection, makes electricity less dangerous and even allows you to call forth a ball of lightning.',
  sval = 56,
  color = colors.C_d,
  image = 'object/ring_placeholder.png',
  level = 50,
  extra = 0,
  cost = 3000,
  combat = { 0, 0 },
  to_a = 15,
  convey_resist_dam = { [DamageType.ELEC]=true },
  ignore_dam = { [DamageType.ELEC]=true },
  obvious_flags = { convey_resist_dam = { [DamageType.ELEC]=true } },
  allocation = { { level=50, rarity=1 } },
  -- Placeholder until we define this.
  use_simple = {
    use = function(self, who, inven, floor, item)
      game.log('[Sorry, not implemented (BA_ELEC_4)]')
    end,
    name = [[do something unimplemented (BA_ELEC_4)]],
  },
  cant_use_if = { not_wielded=true },
}

newEntity {
  base = 'RING_BASE',
  define_as = 'FLARE_BASE',
  name = 'FLARE_BASE',
  display_name = '& Ring~',
  sval = 52,
  color = colors.C_y,
  image = 'object/ring_placeholder.png',
  level = 50,
  extra = 25,
  cost = 75000,
  insta_art = true,
  pval = 5,
}

newEntity {
  base = 'RING_BASE',
  define_as = 'RING_INVISIBILITY',
  name = 'RING_INVISIBILITY',
  display_name = 'Invisibility',
  desc = 'This magical bauble will hide you from sight.',
  sval = 53,
  color = colors.C_d,
  image = 'object/ring_placeholder.png',
  level = 50,
  extra = 0,
  cost = 10000,
  pval_flags = { invisibility=true },
  flags = { HIDE_TYPE=true },
  obvious_flags = { pval_flags = { invisibility=true } },
  allocation = { { level=50, rarity=1 } },
  pval = 4,
}

newEntity {
  base = 'RING_BASE',
  define_as = 'RING_RING_OF_PRECOGNITION',
  name = 'RING_RING_OF_PRECOGNITION',
  display_name = '& Ring~ of Precognition',
  desc = 'This magical ring allows you to know what you will encounter in the near future.',
  sval = 51,
  color = colors.C_d,
  image = 'object/ring_placeholder.png',
  level = 90,
  extra = 0,
  cost = 300000,
  norm_art = true,
  unique = 'RING_RING_OF_PRECOGNITION',
  convey_flags = { PRECOGNITION=true },
  flags = { FULL_NAME=true },
  ignore_dam = { [DamageType.ACID]=true, [DamageType.ELEC]=true, [DamageType.FIRE]=true, [DamageType.COLD]=true },
  obvious_flags = { convey_flags = { PRECOGNITION=true } },
  allocation = { { level=90, rarity=100 } },
  artifact_info = '45:23',
}

newEntity {
  base = 'RING_BASE',
  define_as = 'RING_FLYING',
  name = 'RING_FLYING',
  display_name = 'Flying',
  desc = 'This ring is imbued with the power of eagles. It grants you the power of flight.',
  sval = 54,
  color = colors.C_d,
  image = 'object/ring_placeholder.png',
  level = 20,
  extra = 0,
  cost = 16000,
  convey_flags = { FLY=true },
  flags = { EASY_KNOW=true },
  obvious_flags = { convey_flags = { FLY=true } },
  allocation = { { level=20, rarity=3 } },
}

newEntity {
  base = 'RING_BASE',
  define_as = 'PHASING_BASE',
  name = 'PHASING_BASE',
  display_name = '& Ring~',
  sval = 55,
  color = colors.C_d,
  image = 'object/ring_placeholder.png',
  level = 110,
  extra = 0,
  cost = 300000,
  insta_art = true,
  special_gene = true,
  allocation = { { level=110, rarity=5 } },
}

newEntity {
  base = 'RING_BASE',
  define_as = 'RING_RING_OF_POWER',
  name = 'RING_RING_OF_POWER',
  display_name = 'Ring~ of Power',
  sval = 5,
  color = colors.C_d,
  image = 'object/ring_placeholder.png',
  level = 100,
  extra = 0,
  cost = 1,
  special_gene = true,
  convey_flags = { DRAIN_EXP=true },
  pval_flags = { invisibility=true },
  flags = { CURSED=true, HEAVY_CURSE=true, CURSE_NO_DROP=true, FULL_NAME=true },
  obvious_flags = { pval_flags = { invisibility=true } },
  allocation = { { level=100, rarity=100 } },
}

newEntity {
  base = 'RING_BASE',
  define_as = 'RING_CRITICAL_HITS',
  name = 'RING_CRITICAL_HITS',
  display_name = 'Critical Hits',
  desc = 'A magical ring to make it likelier for the wearer to hit exceptionally heavily.',
  sval = 59,
  color = colors.C_d,
  image = 'object/ring_placeholder.png',
  level = 50,
  extra = 0,
  cost = 10000,
  pval_flags = { extra_crit=true },
  obvious_flags = { pval_flags = { extra_crit=true } },
  allocation = { { level=50, rarity=3 } },
  -- BEGIN VERBATIM
  resolvers.generic(function(e)
    local Object = require 'mod.class.Object'
    local RF = Object.resolve_flags
    e.pval = math.max(1, obj_util.m_bonus(10, RF.level))
    obj_util.check_cursed(e, {'pval'})
    return nil	-- Delete the origin field
  end),
  -- END VERBATIM
}
-- 60 total items
-- color:  colors.C_d=58; colors.C_y=2
-- level:  10=5; 100=3; 110=2; 20=10; 22=1; 24=1; 25=1; 26=1; 30=6; 34=1; 40=1; 5=8; 50=11; 60=2; 70=1; 75=1; 80=1; 90=4
-- extra:  0=59; 25=1
-- cost:  0=4; 1=1; 1000=2; 10000=2; 100000=4; 13000=1; 14500=1; 1500=1; 15000=1; 150000=1; 16000=2; 20=1; 200=1; 200000=1; 250=5; 300=1; 3000=9; 300000=3; 340=1; 400=6; 500=7; 5000000=1; 65000=2; 7500=1; 75000=1
-- to_a:  15=4
-- pval:  4=1; 5=1
-- artifact_info:  45:23=1
