-- $Id$
-- ToME - Tales of Middle-Earth
-- Copyright © 2012-2016 Scott Bigham
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Scott Bigham "Zizzo"
-- dsb-tome@killerbbunnies.org

-- -----------------------------------------------------------------------
-- WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING
-- -----------------------------------------------------------------------
-- This file was generated automatically by the 'gen_obj' Perl script.
-- DO NOT MODIFY THIS FILE DIRECTLY, as any changes will be lost the next
-- time the file is generated (with the possible exception of lines between
-- 'BEGIN VERBATIM' and 'END VERBATIM' markers, if supported by the script).
-- -----------------------------------------------------------------------
-- WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING
-- -----------------------------------------------------------------------

-- Object entities generated from T2's k_info.txt

newEntity {
  base = 'ROD_TIP_BASE',
  define_as = 'TIP_HAVOC',
  name = 'TIP_HAVOC',
  display_name = 'Havoc',
  desc = [[This powerful rod will release great blasts of destructive energy, but there's no knowing what this effect will concentrate on.]],
  sval = 28,
  image = 'object/rod_tip_placeholder.png',
  level = 95,
  cost = 150000,
  allocation = { { level=100, rarity=16 } },
  pval = 90,
  -- BEGIN VERBATIM
  rod_power = {
    use_rod = function(self, who, inven, floor, item)
      game.log('Sorry, not yet implemented (TIP_HAVOC)')
      return { used=true, id=true }
    end,
    power = 90,
    name = [[call chaos (not implemented)]],
  },
  -- END VERBATIM
}

newEntity {
  base = 'ROD_TIP_BASE',
  define_as = 'TIP_DOOR_STAIR_LOCATION',
  name = 'TIP_DOOR_STAIR_LOCATION',
  display_name = 'Door/Stair Location',
  desc = 'When fuelled with enough ambient mana, this rod can detect nearby passages.',
  sval = 1,
  image = 'object/rod_tip_placeholder.png',
  level = 15,
  cost = 1000,
  allocation = { { level=15, rarity=1 } },
  pval = 10,
  -- BEGIN VERBATIM
  rod_power = {
    use_rod = function(self, who, inven, floor, item)
      local ret = spell.detect_doors_stairs(25, who)
      return { used=true, id=ret }
    end,
    power = 10,
    name = [[detect doors and stairs in radius 25]],
  },
  -- END VERBATIM
}

newEntity {
  base = 'ROD_TIP_BASE',
  define_as = 'TIP_TRAP_LOCATION',
  name = 'TIP_TRAP_LOCATION',
  display_name = 'Trap Location',
  desc = 'Zapping this rod will release a minor detection magic, alerting you of nearby pits and snares.',
  sval = 29,
  image = 'object/rod_tip_placeholder.png',
  level = 5,
  cost = 100,
  allocation = {
    { level=5, rarity=1 },
    { level=10, rarity=1 },
    { level=20, rarity=1 },
  },
  pval = 8,
  -- BEGIN VERBATIM
  rod_power = {
    use_rod = function(self, who, inven, floor, item)
      local ret = spell.detect_traps(25, who)
      return { used=true, id=ret }
    end,
    power = 8,
    name = [[detect traps in radius 25]],
  },
  -- END VERBATIM
}

newEntity {
  base = 'ROD_TIP_BASE',
  define_as = 'TIP_PROBING',
  name = 'TIP_PROBING',
  display_name = 'Probing',
  desc = [[A rod of knowledge which will tell you about nearby creatures' health.]],
  sval = 7,
  image = 'object/rod_tip_placeholder.png',
  level = 40,
  cost = 4000,
  allocation = { { level=40, rarity=4 } },
  pval = 50,
  -- BEGIN VERBATIM
  rod_power = {
    use_rod = function(self, who, inven, floor, item)
      game.log('Sorry, not yet implemented (TIP_PROBING)')
      return { used=true, id=true }
    end,
    power = 50,
    name = [[probe the target monster (not yet implemented)]],
  },
  -- END VERBATIM
}

newEntity {
  base = 'ROD_TIP_BASE',
  define_as = 'TIP_RECALL',
  name = 'TIP_RECALL',
  display_name = 'Recall',
  desc = 'A rod which can transport you from the depths to your home and back.',
  sval = 3,
  image = 'object/rod_tip_placeholder.png',
  level = 30,
  cost = 4500,
  allocation = { { level=30, rarity=4 } },
  pval = 80,
  -- BEGIN VERBATIM
  rod_power = {
    use_rod = function(self, who, inven, floor, item)
      local ret = spell.set_recall(who, 21, 15)
      return { used=ret, id=ret }
    end,
    power = 80,
    name = [[recall to the most recent town or dungeon level you've visited]],
  },
  -- END VERBATIM
}

newEntity {
  base = 'ROD_TIP_BASE',
  define_as = 'TIP_ILLUMINATION',
  name = 'TIP_ILLUMINATION',
  display_name = 'Illumination',
  desc = 'This rod carries a minor spell of brightness, lighting your immediate surroundings whenever activated.',
  sval = 4,
  image = 'object/rod_tip_placeholder.png',
  level = 20,
  cost = 1000,
  allocation = { { level=20, rarity=1 } },
  pval = 8,
  -- BEGIN VERBATIM
  rod_power = {
    use_rod = function(self, who, inven, floor, item)
      local DamageType = require 'engine.DamageType'
      spell.lite_room(who.x, who.y)
      spell.ball_spell(who, nil, DamageType.LITE_WEAK, rng.dice(2, 8), 2, who.x, who.y, 0)
      return { used=true, id=true }
    end,
    power = 8,
    name = [[illuminate your immediate vicinity]],
  },
  in_trap = {
    damtype=DamageType.LITE_WEAK, dam={2,15}, r=3,
    side_effect = function(self, _, x, y, _) spell.lite_room(x, y) end,
    side_effect_desc = 'illuminates the room',
  },
  -- END VERBATIM
}

newEntity {
  base = 'ROD_TIP_BASE',
  define_as = 'TIP_LIGHT',
  name = 'TIP_LIGHT',
  display_name = 'Light',
  desc = 'This rod can shoot a lance of bright light, hurting creatures which lurk in the dark.',
  sval = 15,
  image = 'object/rod_tip_placeholder.png',
  level = 10,
  cost = 500,
  allocation = { { level=10, rarity=1 } },
  pval = 15,
  -- BEGIN VERBATIM
  rod_power = {
    use_rod = function(self, who, inven, floor, item)
      local DamageType = require 'engine.DamageType'
      local ret = spell.beam_spell(self, nil, DamageType.LITE_WEAK, rng.dice(6, 8), nil, nil, 18)
      return { used=ret, id=ret }
    end,
    power = 15,
    name = function(self)
      local DamageType = require 'engine.DamageType'
      local lf = util.colorize_damtype(DamageType.LITE_WEAK)
      local ret = [[do 6d8 %s damage in a beam]]
      return ret:format(lf)
    end,
  },
  in_trap = { damtype=DamageType.LITE_WEAK, dam={6, 8}, r=0 }
  -- END VERBATIM
}

newEntity {
  base = 'ROD_TIP_BASE',
  define_as = 'TIP_LIGHTNING_BOLTS',
  name = 'TIP_LIGHTNING_BOLTS',
  display_name = 'Lightning Bolts',
  desc = 'This rod shoots a small spark of lightning, zapping the creature it hits.',
  sval = 21,
  image = 'object/rod_tip_placeholder.png',
  level = 20,
  cost = 2000,
  allocation = { { level=20, rarity=1 } },
  pval = 30,
  -- BEGIN VERBATIM
  rod_power = {
    use_rod = function(self, who, inven, floor, item)
      local DamageType = require 'engine.DamageType'
      local ret = spell.bolt_or_beam_spell(who, nil, 10, DamageType.ELEC, rng.dice(3, 8), nil, nil, 18)
      return { used=ret, id=ret }
    end,
    power = 30,
    name = function(o)
      local DamageType = require 'engine.DamageType'
      local lf = util.colorize_damtype(DamageType.ELEC)
      local ret = [[do 3d8 %s damage to a targeted monster (10%% chance of a beam)]]
      return ret:format(lf)
    end,
  },
  in_trap = { damtype=DamageType.ELEC, dam={3, 8}, r=0 }
  -- END VERBATIM
}

newEntity {
  base = 'ROD_TIP_BASE',
  define_as = 'TIP_FROST_BOLTS',
  name = 'TIP_FROST_BOLTS',
  display_name = 'Frost Bolts',
  desc = 'A small but extremely cold shard of ice will fly from this rod to your enemy.',
  sval = 23,
  image = 'object/rod_tip_placeholder.png',
  level = 25,
  cost = 2500,
  allocation = { { level=25, rarity=1 } },
  pval = 35,
  -- BEGIN VERBATIM
  rod_power = {
    use_rod = function(self, who, inven, floor, item)
      local DamageType = require 'engine.DamageType'
      local ret = spell.bolt_or_beam_spell(who, nil, 10, DamageType.COLD, rng.dice(5, 8), nil, nil, 18)
      return { used=ret, id=ret }
    end,
    power = 35,
    name = function(o)
      local DamageType = require 'engine.DamageType'
      local cf = util.colorize_damtype(DamageType.COLD)
      local ret = [[do 5d8 %s damage to a targeted monster (10%% chance of a beam)]]
      return ret:format(cf)
    end,
  },
  in_trap = { damtype=DamageType.COLD, dam={5, 8}, r=0 }
  -- END VERBATIM
}

newEntity {
  base = 'ROD_TIP_BASE',
  define_as = 'TIP_FIRE_BOLTS',
  name = 'TIP_FIRE_BOLTS',
  display_name = 'Fire Bolts',
  desc = 'This rod fires a magical flaming arrow at your foe, burning it.',
  sval = 22,
  image = 'object/rod_tip_placeholder.png',
  level = 30,
  cost = 3000,
  allocation = { { level=30, rarity=1 } },
  pval = 40,
  -- BEGIN VERBATIM
  rod_power = {
    use_rod = function(self, who, inven, floor, item)
      local DamageType = require 'engine.DamageType'
      local ret = spell.bolt_or_beam_spell(who, nil, 10, DamageType.FIRE, rng.dice(8, 8), nil, nil, 18)
      return { used=ret, id=ret }
    end,
    power = 40,
    name = function(o)
      local DamageType = require 'engine.DamageType'
      local ff = util.colorize_damtype(DamageType.FIRE)
      local ret = [[do 8d8 %s damage to a targeted monster (10%% chance of a beam)]]
      return ret:format(ff)
    end,
  },
  in_trap = { damtype=DamageType.FIRE, dam={8, 8}, r=0 }
  -- END VERBATIM
}

newEntity {
  base = 'ROD_TIP_BASE',
  define_as = 'TIP_POLYMORPH',
  name = 'TIP_POLYMORPH',
  display_name = 'Polymorph',
  desc = 'This rod of change will cause its target creature to mutate into something else.',
  sval = 19,
  image = 'object/rod_tip_placeholder.png',
  level = 35,
  cost = 1200,
  allocation = { { level=35, rarity=1 } },
  pval = 25,
  -- BEGIN VERBATIM
  rod_power = {
    use_rod = function(self, who, inven, floor, item)
      local DamageType = require 'engine.DamageType'
      local ret = spell.bolt_spell(who, nil, DamageType.OLD_POLY, (who.level or 1), nil, nil, 18)
      return { used=ret, id=ret }
    end,
    power = 25,
    name = [[attempt to polymorph a targeted monster]],
  },
  in_trap = { damtype=DamageType.OLD_POLY, dam=50, r=0 }
  -- END VERBATIM
}

newEntity {
  base = 'ROD_TIP_BASE',
  define_as = 'TIP_SLOW_MONSTER',
  name = 'TIP_SLOW_MONSTER',
  display_name = 'Slow Monster',
  desc = 'This obstructive rod emits an energy bolt which will slow the creature it hits.',
  sval = 17,
  image = 'object/rod_tip_placeholder.png',
  level = 30,
  cost = 1500,
  allocation = { { level=30, rarity=1 } },
  pval = 25,
  -- BEGIN VERBATIM
  rod_power = {
    use_rod = function(self, who, inven, floor, item)
      local DamageType = require 'engine.DamageType'
      local ret = spell.bolt_spell(who, nil, DamageType.OLD_SLOW, (who.level or 1), nil, nil, 18)
      return { used=ret, id=ret }
    end,
    power = 25,
    name = [[attempt to slow a targeted monster]],
  },
  in_trap = { damtype=DamageType.OLD_SLOW, dam=50, r=0 }
  -- END VERBATIM
}

newEntity {
  base = 'ROD_TIP_BASE',
  define_as = 'TIP_SLEEP_MONSTER',
  name = 'TIP_SLEEP_MONSTER',
  display_name = 'Sleep Monster',
  desc = 'This sorcerous rod will cause its target to stop in its tracks.',
  sval = 16,
  image = 'object/rod_tip_placeholder.png',
  level = 30,
  cost = 1500,
  allocation = { { level=30, rarity=1 } },
  pval = 25,
  -- BEGIN VERBATIM
  rod_power = {
    use_rod = function(self, who, inven, floor, item)
      local DamageType = require 'engine.DamageType'
      local ret = spell.bolt_spell(who, nil, DamageType.OLD_SLEEP, (who.level or 1), nil, nil, 18)
      return { used=ret, id=ret }
    end,
    power = 25,
    name = [[attempt to put a targeted monster to sleep]],
  },
  in_trap = { damtype=DamageType.OLD_SLEEP, dam=50, r=0 }
  -- END VERBATIM
}

newEntity {
  base = 'ROD_TIP_BASE',
  define_as = 'TIP_DRAIN_LIFE',
  name = 'TIP_DRAIN_LIFE',
  display_name = 'Drain Life',
  desc = 'This necromantic magical rod will hurt a living creature struck by its spell.',
  sval = 18,
  image = 'object/rod_tip_placeholder.png',
  level = 75,
  cost = 3600,
  allocation = { { level=75, rarity=4 } },
  pval = 30,
  -- BEGIN VERBATIM
  rod_power = {
    use_rod = function(self, who, inven, floor, item)
      local DamageType = require 'engine.DamageType'
      local ret = spell.bolt_spell(who, nil, DamageType.OLD_DRAIN, 75, nil, nil, 18)
      return { used=ret, id=ret }
    end,
    power = 30,
    name = [[attempt to drain life from a targeted monster]],
  },
  in_trap = { damtype=DamageType.OLD_DRAIN, dam=75, r=0 }
  -- END VERBATIM
}

newEntity {
  base = 'ROD_TIP_BASE',
  define_as = 'TIP_TELEPORT_OTHER',
  name = 'TIP_TELEPORT_OTHER',
  display_name = 'Teleport Other',
  desc = 'This rod of movement will displace its target to another location.',
  sval = 13,
  image = 'object/rod_tip_placeholder.png',
  level = 45,
  cost = 1400,
  allocation = { { level=45, rarity=2 } },
  pval = 60,
  -- BEGIN VERBATIM
  rod_power = {
    use_rod = function(self, who, inven, floor, item)
      local DamageType = require 'engine.DamageType'
      local ret = spell.beam_spell(who, nil, DamageType.TELEPORT, 100, nil, nil, 18)
      return { used=ret, id=ret }
    end,
    power = 60,
    name = [[teleport monsters away]],
  },
  -- END VERBATIM
}

newEntity {
  base = 'ROD_TIP_BASE',
  define_as = 'TIP_DISARMING',
  name = 'TIP_DISARMING',
  display_name = 'Disarming',
  desc = 'This rod will clear a path for you, triggering and thus rendering harmless all traps on the way.',
  sval = 14,
  image = 'object/rod_tip_placeholder.png',
  level = 35,
  cost = 2100,
  allocation = { { level=35, rarity=1 } },
  pval = 50,
  -- BEGIN VERBATIM
  rod_power = {
    use_rod = function(self, who, inven, floor, item)
      local DamageType = require 'engine.DamageType'
      local ret = spell.beam_spell(who, nil, DamageType.KILL_TRAP, {0, silent_0dam=true, grid=true, object=true}, nil, nil, 18)
      return { used=ret, id=ret }
    end,
    power = 50,
    name = [[disarm traps along a line]],
  },
  -- END VERBATIM
}

newEntity {
  base = 'ROD_TIP_BASE',
  define_as = 'TIP_LIGHTNING_BALLS',
  name = 'TIP_LIGHTNING_BALLS',
  display_name = 'Lightning Balls',
  desc = 'This rod will hurl a large ball of lightning at its target, electrifying all it engulfs.',
  sval = 25,
  image = 'object/rod_tip_placeholder.png',
  level = 55,
  cost = 4000,
  allocation = { { level=55, rarity=1 } },
  pval = 50,
  -- BEGIN VERBATIM
  rod_power = {
    use_rod = function(self, who, inven, floor, item)
      local DamageType = require 'engine.DamageType'
      local ret = spell.ball_spell(who, nil, DamageType.ELEC, 32, 2, nil, nil, 18)
      return { used=ret, id=ret }
    end,
    power = 50,
    name = function(o)
      local DamageType = require 'engine.DamageType'
      local lf = util.colorize_damtype(DamageType.ELEC)
      local ret = [[do 32 %s damage in a radius-2 targeted ball]]
      return ret:format(lf)
    end,
  },
  in_trap = { damtype=DamageType.ELEC, dam=32, r=2 }
  -- END VERBATIM
}

newEntity {
  base = 'ROD_TIP_BASE',
  define_as = 'TIP_COLD_BALLS',
  name = 'TIP_COLD_BALLS',
  display_name = 'Cold Balls',
  desc = 'This rod will call forth a minor storm of ice which freezes everything in the area of its blast.',
  sval = 27,
  image = 'object/rod_tip_placeholder.png',
  level = 60,
  cost = 4500,
  allocation = { { level=60, rarity=1 } },
  pval = 55,
  -- BEGIN VERBATIM
  rod_power = {
    use_rod = function(self, who, inven, floor, item)
      local DamageType = require 'engine.DamageType'
      local ret = spell.ball_spell(who, nil, DamageType.COLD, 48, 2, nil, nil, 18)
      return { used=ret, id=ret }
    end,
    power = 55,
    name = function(o)
      local DamageType = require 'engine.DamageType'
      local cf = util.colorize_damtype(DamageType.COLD)
      local ret = [[do 48 %s damage in a radius-2 targeted ball]]
      return ret:format(cf)
    end,
  },
  in_trap = { damtype=DamageType.COLD, dam=48, r=2 }
  -- END VERBATIM
}

newEntity {
  base = 'ROD_TIP_BASE',
  define_as = 'TIP_FIRE_BALLS',
  name = 'TIP_FIRE_BALLS',
  display_name = 'Fire Balls',
  desc = 'This rod will cause a small storm of flame to rage in a small circular area of your choice.',
  sval = 26,
  image = 'object/rod_tip_placeholder.png',
  level = 75,
  cost = 5000,
  allocation = { { level=75, rarity=1 } },
  pval = 60,
  -- BEGIN VERBATIM
  rod_power = {
    use_rod = function(self, who, inven, floor, item)
      local DamageType = require 'engine.DamageType'
      local ret = spell.ball_spell(who, nil, DamageType.FIRE, 72, 2, nil, nil, 18)
      return { used=ret, id=ret }
    end,
    power = 60,
    name = function(o)
      local DamageType = require 'engine.DamageType'
      local ff = util.colorize_damtype(DamageType.FIRE)
      local ret = [[do 72 %s damage in a radius-2 targeted ball]]
      return ret:format(ff)
    end,
  },
  in_trap = { damtype=DamageType.FIRE, dam=72, r=2 }
  -- END VERBATIM
}

newEntity {
  base = 'ROD_TIP_BASE',
  define_as = 'TIP_ACID_BALLS',
  name = 'TIP_ACID_BALLS',
  display_name = 'Acid Balls',
  desc = 'This destructive rod will drown its target and its immediate surroundings in caustic acid.',
  sval = 24,
  image = 'object/rod_tip_placeholder.png',
  level = 70,
  cost = 5500,
  allocation = { { level=70, rarity=1 } },
  pval = 60,
  -- BEGIN VERBATIM
  rod_power = {
    use_rod = function(self, who, inven, floor, item)
      local DamageType = require 'engine.DamageType'
      local ret = spell.ball_spell(who, nil, DamageType.ACID, 60, 2, nil, nil, 18)
      return { used=ret, id=ret }
    end,
    power = 60,
    name = function(o)
      local DamageType = require 'engine.DamageType'
      local af = util.colorize_damtype(DamageType.ACID)
      local ret = [[do 60 %s damage in a radius-2 targeted ball]]
      return ret:format(af)
    end,
  },
  in_trap = { damtype=DamageType.ACID, dam=60, r=2 }
  -- END VERBATIM
}

newEntity {
  base = 'ROD_TIP_BASE',
  define_as = 'TIP_ACID_BOLTS',
  name = 'TIP_ACID_BOLTS',
  display_name = 'Acid Bolts',
  desc = 'This rod will shoot a small glob of powerful acid at its target.',
  sval = 20,
  image = 'object/rod_tip_placeholder.png',
  level = 40,
  cost = 3500,
  allocation = { { level=40, rarity=1 } },
  pval = 40,
  -- BEGIN VERBATIM
  rod_power = {
    use_rod = function(self, who, inven, floor, item)
      local DamageType = require 'engine.DamageType'
      local ret = spell.bolt_or_beam_spell(who, nil, 10, DamageType.ACID, rng.dice(6, 8), nil, nil, 18)
      return { used=ret, id=ret }
    end,
    power = 40,
    name = function(o)
      local DamageType = require 'engine.DamageType'
      local af = util.colorize_damtype(DamageType.ACID)
      local ret = [[do 6d8 %s damage to a targeted monster (10%% chance of a beam)]]
      return ret:format(af)
    end,
  },
  in_trap = { damtype=DamageType.ACID, dam={6, 8}, r=0 }
  -- END VERBATIM
}

newEntity {
  base = 'ROD_TIP_BASE',
  define_as = 'TIP_ENLIGHTENMENT',
  name = 'TIP_ENLIGHTENMENT',
  display_name = 'Enlightenment',
  desc = 'This rod grants you knowledge of your surroundings.',
  sval = 5,
  image = 'object/rod_tip_placeholder.png',
  level = 65,
  cost = 10000,
  allocation = { { level=65, rarity=4 } },
  pval = 40,
  -- BEGIN VERBATIM
  rod_power = {
    use_rod = function(self, who, inven, floor, item)
      who:computeFOV(40, 'block_sense', spell.map_area_callback, true, true, true)
      return { used=true, id=true }
    end,
    power = 40,
    name = [[map your surroundings]],
  },
  -- END VERBATIM
}

newEntity {
  base = 'ROD_TIP_BASE',
  define_as = 'TIP_PERCEPTION',
  name = 'TIP_PERCEPTION',
  display_name = 'Perception',
  desc = 'This rod makes you insightful, laying open the identity of your possessions.',
  sval = 2,
  image = 'object/rod_tip_placeholder.png',
  level = 50,
  cost = 13000,
  allocation = {
    { level=50, rarity=8 },
    { level=100, rarity=8 },
  },
  pval = 20,
  -- BEGIN VERBATIM
  rod_power = {
    use_rod = function(self, who, inven, floor, item)
      local ret = spell.identify_dialog(who, true, 'Select item to identify')
      return { used=ret, id=true }
    end,
    power = 20,
    name = [[identify an item]],
  },
  -- END VERBATIM
}

newEntity {
  base = 'ROD_TIP_BASE',
  define_as = 'TIP_CURING',
  name = 'TIP_CURING',
  display_name = 'Curing',
  desc = 'This is a rod with minor healing powers, alleviating many disabling conditions.',
  sval = 8,
  image = 'object/rod_tip_placeholder.png',
  level = 65,
  cost = 15000,
  allocation = { { level=65, rarity=8 } },
  pval = 35,
  -- BEGIN VERBATIM
  rod_power = {
    use_rod = function(self, who, inven, floor, item)
      local ret = obj_util.remove_effects_and_learn(who,
						    who.EFF_BLIND,
						    who.EFF_POISON,
						    who.EFF_CONFUSED,
						    who.EFF_STUN,
						    who.EFF_CUT,
						    who.EFF_HALLUCINATION)
      return { used=true, id=ret }
    end,
    power = 35,
    name = [[cure blindness, poison, confusion, stun, cuts and hallucination]],
  },
  in_trap = { damtype=DamageType.OLD_HEAL, dam={3, 4}, r=0 }
  -- END VERBATIM
}

newEntity {
  base = 'ROD_TIP_BASE',
  define_as = 'TIP_HEALING',
  name = 'TIP_HEALING',
  display_name = 'Healing',
  desc = 'This rod has major healing powers and can restore your health if you have been wounded.',
  sval = 9,
  image = 'object/rod_tip_placeholder.png',
  level = 80,
  cost = 20000,
  allocation = { { level=80, rarity=8 } },
  pval = 120,
  -- BEGIN VERBATIM
  rod_power = {
    use_rod = function(self, who, inven, floor, item)
      local ret1 = obj_util.heal_and_learn(who, 800, self)
      local ret2 = obj_util.remove_effects_and_learn(who, who.EFF_STUN, who.EFF_CUT)
      return { used=true, id=(ret1 or ret2) }
    end,
    power = 120,
    name = [[heal 800hp and cure stun and cuts]],
  },
  in_trap = { damtype=DamageType.OLD_HEAL, dam=300, r=0 }
  -- END VERBATIM
}

newEntity {
  base = 'ROD_TIP_BASE',
  define_as = 'TIP_DETECTION',
  name = 'TIP_DETECTION',
  display_name = 'Detection',
  desc = 'This rod grants knowledge about all things worthy of notice in your vicinity.',
  sval = 6,
  image = 'object/rod_tip_placeholder.png',
  level = 30,
  cost = 5000,
  allocation = { { level=30, rarity=8 } },
  pval = 80,
  -- BEGIN VERBATIM
  rod_power = {
    use_rod = function(self, who, inven, floor, item)
      spell.detect_traps(25, who)
      spell.detect_doors_stairs(25, who)
      spell.detect_buried_treasure(25, who)
      spell.detect_gold(25, who)
      spell.detect_objects(25, who)
      spell.detect_invisible_monsters(25, who)
      spell.detect_monsters(25, who)
      return { used=true, id=true }
    end,
    power = 80,
    name = [[detect traps, doors, stairs, treasure, objects and monsters in radius 25]],
  },
  -- END VERBATIM
}

newEntity {
  base = 'ROD_TIP_BASE',
  define_as = 'TIP_RESTORATION',
  name = 'TIP_RESTORATION',
  display_name = 'Restoration',
  desc = 'This rod lets you remember your previous abilities and gain them back, should they have been reduced.',
  sval = 10,
  image = 'object/rod_tip_placeholder.png',
  level = 80,
  cost = 25000,
  allocation = { { level=80, rarity=16 } },
  pval = 140,
  -- BEGIN VERBATIM
  rod_power = {
    use_rod = function(self, who, inven, floor, item)
      local learn = who.restoreExp and who:restoreExp()
      learn = who:restoreStat('STR') or learn
      learn = who:restoreStat('INT') or learn
      learn = who:restoreStat('WIS') or learn
      learn = who:restoreStat('DEX') or learn
      learn = who:restoreStat('CON') or learn
      learn = who:restoreStat('CHA') or learn
      return { used=true, id=learn }
    end,
    power = 140,
    name = [[restore lost stats and experience]],
  },
  -- END VERBATIM
}

newEntity {
  base = 'ROD_TIP_BASE',
  define_as = 'TIP_SPEED',
  name = 'TIP_SPEED',
  display_name = 'Speed',
  desc = 'This energising rod will allow you to act a lot faster for some time.',
  sval = 11,
  image = 'object/rod_tip_placeholder.png',
  level = 95,
  cost = 50000,
  allocation = { { level=95, rarity=16 } },
  pval = 100,
  -- BEGIN VERBATIM
  rod_power = {
    use_rod = function(self, who, inven, floor, item)
      who:setEffect(who.EFF_SPEED, 15 + rng.range(1, 30), { speed=10, merge=function(c,n) return c+5 end })
      return { used=true, id=true }
    end,
    power = 100,
    name = [[temporarily increase your speed by 10]],
  },
  in_trap = { damtype=DamageType.OLD_SPEED, dam=50, r=0 }
  -- END VERBATIM
}

newEntity {
  base = 'ROD_TIP_BASE',
  define_as = 'TIP_NOTHING',
  name = 'TIP_NOTHING',
  display_name = 'Nothing',
  sval = 0,
  image = 'object/rod_tip_placeholder.png',
  level = 5,
  weight = 1,
  encumber = 1,
  cost = 50,
  allocation = { { level=5, rarity=1 } },
  pval = 1,
  -- BEGIN VERBATIM
  -- This rod tip can't be attached to anything.
  use_simple = table.NIL_MERGE,
  -- END VERBATIM
}

newEntity {
  base = 'ROD_TIP_BASE',
  define_as = 'TIP_HOME_SUMMONING',
  name = 'TIP_HOME_SUMMONING',
  display_name = 'Home Summoning',
  desc = 'This rod creates a little hatch, allowing access to your home, no matter how far away the abode is.',
  sval = 30,
  image = 'object/rod_tip_placeholder.png',
  level = 90,
  cost = 150000,
  norm_art = true,
  unique = 'TIP_HOME_SUMMONING',
  flags = { FULL_NAME=true, EASY_KNOW=table.NIL_MERGE },
  ignore_dam = { [DamageType.FIRE]=true, [DamageType.ACID]=true, [DamageType.COLD]=true, [DamageType.ELEC]=true },
  allocation = { { level=100, rarity=14 } },
  artifact_info = '66:1',
  pval = 75,
  -- BEGIN VERBATIM
  rod_power = {
    use_rod = function(self, who, inven, floor, item)
      game.log('Sorry, not yet implemented (TIP_HOME_SUMMONING)')
      return { used=true, id=true }
    end,
    power = 75,
    name = [[access your home in the most recent town you've visited (not yet implemented)]],
  },
  -- END VERBATIM
}
-- 30 total items
-- level:  10=1; 15=1; 20=2; 25=1; 30=5; 35=2; 40=2; 45=1; 5=2; 50=1; 55=1; 60=1; 65=2; 70=1; 75=2; 80=2; 90=1; 95=2
-- weight:  10=1
-- cost:  100=1; 1000=2; 10000=1; 1200=1; 13000=1; 1400=1; 1500=2; 15000=1; 150000=2; 2000=1; 20000=1; 2100=1; 2500=1; 25000=1; 3000=1; 3500=1; 3600=1; 4000=2; 4500=2; 50=1; 500=1; 5000=2; 50000=1; 5500=1
-- artifact_info:  66:1=1
-- pval:  1=1; 10=1; 100=1; 120=1; 140=1; 15=1; 20=1; 25=3; 30=2; 35=2; 40=3; 50=3; 55=1; 60=3; 75=1; 8=2; 80=2; 90=1
