-- $Id: bree.lua 1062 2014-10-03 02:55:15Z dsb $
-- ToME - Tales of Middle-Earth
-- Copyright (C) 2012 Scott Bigham
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Scott Bigham "Zizzo"
-- dsb-tome@killerbbunnies.org

defineTile('^', 'MOUNTAIN_CHAIN')
defineTile('.', 'FLOOR')
defineTile('T', 'TREE')
defineTile('W', 'DEEP_WATER')
defineTile('V', 'SHALLOW_WATER')
defineTile('C', 'DARK_PIT')
defineTile(',', 'DIRT')
defineTile('-', 'GRASS')
defineTile('#', 'PERMA_WALL')
defineTile('s', 'BRICK_ROOF')
defineTile('S', 'BRICK_ROOF_TOP')
defineTile('t', 'BRICK_ROOF_CHIMNEY')
defineTile('X', 'GRASS_ROOF')
defineTile('U', 'GRASS_ROOF_TOP')
defineTile('O', 'COBBLESTONE_ROAD')

defineTile('1', 'PERMA_WALL', nil, nil, 'GENERAL_STORE')
defineTile('2', 'PERMA_WALL', nil, nil, 'ARMOURY')
defineTile('3', 'PERMA_WALL', nil, nil, 'WEAPONSMITH')
defineTile('4', 'PERMA_WALL', nil, nil, 'TEMPLE')
defineTile('5', 'PERMA_WALL', nil, nil, 'ALCHEMY_SHOP')
defineTile('6', 'PERMA_WALL', nil, nil, 'MAGIC_SHOP')
defineTile('7', 'PERMA_WALL', nil, nil, 'BLACK_MARKET')
defineTile('8', 'PERMA_WALL', nil, nil, 'BREE_HOME')
defineTile('9', 'PERMA_WALL', nil, nil, 'BOOK_STORE')
defineTile('0', 'PERMA_WALL', nil, nil, 'PET_SHOP')
defineTile('a', 'PERMA_WALL', nil, nil, 'THE_PRANCING_PONY')
defineTile('b', 'PERMA_WALL', nil, nil, 'MAYOR_HOUSE')
defineTile('c', 'PERMA_WALL', nil, nil, 'THE_SOOTHSAYER')
defineTile('e', 'PERMA_WALL', nil, nil, 'MATHOM_HOUSE')

-- "Transparent" areas, passing through the previously generated tile from
-- PlasmaWilderness.
--defineTile(' ', { 'TREE', 'TREE', 'TREE', 'GRASS' })
-- Remember some spots for future reference.
defineTile('z', 'PERMA_WALL', nil, nil, nil, nil, { type='quest', subtype='house' })
defineTile('x', 'DIRT', nil, nil, nil, nil, { type='quest', subtype='wights' })
defineTile('y', 'TREE', nil, nil, nil, nil, { type='quest', subtype='trolls' })
defineTile('{', 'ENTER_BARROW_DOWNS', nil, nil, nil, nil, { type='zone-change', subtype='barrow-downs' })
-- This is described as "Castle: Plot Bree" in t_bree.txt.  No idea what
-- that's supposed to mean; just fill it in as perma-wall for now.
defineTile('B', 'PERMA_WALL')

startx = 101
starty = 38

-- '@' tiles, also being undefined, will also pass through PlasmaWilderness
-- tiles; we use them for the border instead of ' ' purely for cosmetic
-- reasons, as spaces would be hard to see on the borders.
return [[
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@                                                                                                                  VV              --                                                                @
@                                                                                                                    V              --                                                               @
@                                                                                                                     VV            --                                                               @
@                                                                                                                       VVV          --                                                              @
@                                                                                                                          VV        --                                                              @
@OOOO                                                                                                                       V         --                                                             @
@   OOOO                                                                                                                     V        --                                                             @
@---   OOOOO                                                                                                                  VVV      ---                             VV                            @
@------    OOOOOO                                                                                                                V      --                            VVVV                           @
@----------     OO                                                                                                               V      --                           VVWWVVV                         @
@--------------  OO                                                                                                               VVV    --                        VVVWWWWWVVV                       @
@---------------  OOO                                                                                                               VVV   --                      VVWWWWWWWWWVV                      @
@-----------------  OO                                                                                                                VVVVVVV                    VVWWWWWWWWWWWV                      @
@------------------- OOOOO                                                                                                                 --VVVV   VVVVV        VVWWWWWWWWWWWVV                     @
@##------------------    OO                                                            ,,,,,,,,,,,,,,,,,,                                   --  VVVVV   VV    VVVVVVVWWWWWWWVVV                      @
@CC####------------------ OOO                                                     ,,,,,CCCCCCCCCCCCCCCCCC,,,,,,,,,                           --          VVVVVV     VVVVWWVVV                        @
@TTCCCC###---------------,, OO                                                 ,,,CCCCCCTTTTTTTTTTTTTTTTCCCCCCCCCC,,,,                        --                       VVVV                          @
@--TTTTCCC###---------,,,--  OO                                              ,,CCCCTTTTTT--------------TTTTTTTTTTCCCCC,,,,,                  ^--                                                     @
@------TTTCCC##-----,,------  O                                            ,,CCCTTTT..................----------TTTTTCCCCCC,,              ^^^ --                                                    @
@---------TTTCC##,,,--------  OO                                          ,CCCTTT....--ssssssss-..---..........-----TTTTTTCCC,,,          ^^    --                                                   @
@------------TC,,###-    ---   OO                                        ,CCTTT...-----SSSSSSSS--.----------,,.....------TTTCCCC,,       ^^     --                                                   @
@-------------,TTCCC###    --   OOO                                    ,,CCTT...-,,,,--ssssssss-..-sssssssssss,---......---TTTTCCT,,    ^^       --                                                  @
@---------  ,,,--TTTCCC    --     OO                                 ,,CCCTT..-------,,##9#####-.--sssssssssss-,-------...----TTCCTT,  ^^^        --                                                 @
@--------  ,, ,,----TTTCC          O                                ,CCC  T..--sssSsss,,,,------.--StSStSSSStS--,------.-....--TTCCTT,^^^          --                                                @
@------   ,,   ,                   OO                              ,CCTTT...---ssstSSS---,,,----.--sssssssssss---,---...----..--TTCCT^^^^ ^^        --                                               @
@------- x,   ,,                    OO                            ,CCTT...-----sssssss--,,-,,---.--sssssssssss---,-...-------..--TTC^^^   ^         ----                                             @
@-------     {,                      OO                           ,CTT..---,,,,###6###,,,---,,--.--###########----..----------..--T^^^^   ^       ---  --                                            @
@---------                            OOO                         ,CT..,,,,----,,,,,,,,------,,-.--###b###e###-....,---sssss---.--T^^   ^         --    --                                           @
@----------                             OO                       ,CCT.,sssssss----,-----------,,.-----.-----....-,--,,-StSSS---.-T^^^   ^        --      -----                                       @
@-------------                           OO                     ,CCTT.-StStSSS---,-----ssssss--..-----.--....--,,,,,,-,sssss---.-T^^^      ^      --         --             ,,,                      @
@-----------                              OOOOO                 ,CTT-.-sssssss---,-----SSSSSS--.------.-..--,,,-ssss--,#####---.-T^^    ^         --          -----        ,,                        @
@--------                                     OO               ,CCT-..-##5####----,----ssssss-..........--XXXX,-ssss--,------...-^^^  ^ ^^  ^    ---             ----    ,,,                         @
@- ----                                        OOOOOOOO        ,C  OOOO--OOOOO----,----#c##4#-.---.,----,-UUUU,-SSSS--,-----..---^^   ^   ^     ---                 -----,             OOOOOOOOOOOOOO@
@-  ----                                              OOOOOOO  ,CT-OssOOOO---OOOOOOOOO--OOOO--.-T-.-sss--,XXXX,-ssss---,---..--T^^              --                      --           OOO             @
@-  -----                                                   OOOOOOOOSt.---------XXXX-OOOO--OOOO---.-StS--,#0##,-ssss---,---.---^^     ^  ^      --                       ---      OOOO               @
@-     ---   -----                                           ,,CT--.ss.-sssss---XXXX,---------OOOO.-sss---,,,,,-####--,---..-T^^   ^ ^          --                         ---   OO                  @
@    ----     ----                                           ,,CT--.B#.-SStSS---####,------------OO-#z#-ssssss-,,,---,----.--T^^   ^           -,-                           OOOOO                   @
@  -------      ----                                         ,,CTT-....-sssss--,,,,,,-------------OO-,--SSSSSt-ss-,-,---...-T^^  ^ ^           -,                         OOOO                       @
@    -------   ------                                        ,,CCTT---..#2###-,sssss,-SSSSSSSS-----OO,--ssssss-tS--,.....---^^ ^^     ^^^     -,                   OOOOOOOO                          @
@   -----        -----                                        ,,CCT----..,,,,,-StSSS,-ssssssss------OOO-#1##a#-ss....-----T^^        ^^      -,-               OOOOO                                 @
@      ----  --------                                         ,,CCTT----..----,sssss,-##7#####--------OO,.,,.,-##.----TTTT^^     ^  ^^       -,            OOOOO                                     @
@     ---------------                                         ,,,CCTTTT--..---,##3##-,--,,,---------...OOOOOOOOOOOTTTTTCC^^^   ^^  ^^        ,-          OOO                                         @
@        --------                                              ,,,CCCC  --..........,-,,---,--.......-------TTTTTOCCCCC,,^^^^^^^^^^^        -.-      OOOOO                                           @
@      ----------                                              ,, ,,CCCTT----------.....-......-------TTTTTTTCCCCO,,,,,     ^^^^^^^         -.-      O                                               @
@        -------                                               ,,   ,,CCTTTTTTTTTT-----...------TTTTTTTCCCCCC,,,,OOO                       -.-    OOOO                                               @
@          ----                                                ,,,    ,CCCCCCCCCCTTTTT-----TTTTTTCCCCCC,,,,,,      OOO                    OOOOOOOOO                                                  @
@      ^^   ----                                                ,,     ,,,,,,,,,,CCCCCTTTTTTCCCCC,,,,,,              OO                 OOO--                                                        @
@    ^^^^^                                                      ,,,              ,,,,,CCCCCC,,,,,                     OOOO             OOO--                                                         @
@  ^^^^^^^^^                                                     ,,                   ,,,,,,                             OOOOOOO     OOO---                                                          @
@  ^^^^^^^^^                                                     ,,                                                            OOOOOOO----                                                           @
@ ^^^^^^^^^^^^^^^                                                ,,,                                                            ..------                                                             @
@   ^^^^^^^^^^^^^^                                                ,,,                     ......                             ....-----                                                               @
@   ^^^^^^^^^^^^^^^                                                ,,,          ...........    ............       ............-------,,,,                                                            @
@^^^^^^^^^^^^^^^^^                                                  ,,        ...                         .........--------------       ,,,,,,,    ,,,,,,,,,                                         @
@    ^^^^^^^^^^^^^                                                 ,,         .                                                               ,,,,,,       ,,,,,,,,,                                 @
@  ^^^^^^^^^^^^^^                                                   ,,      ...                                                                                    ,,,,,        ------    ---        @
@    ^^^^^^^^^^^^^^^                                                 ,,     .                                                                                          ,,,,,,,,-------   -----       @
@    ^^^^^^^^^^^^^^                                                   ,    ..                                                                                                  ----------------      @
@ ^^^^^^^^^^^^^^^^                                                    ,,  ..                                                                                                ---------y--------       @
@   ^^^^^^^^^^^^^^^                                                    , ..                                                                                                 -----------------        @
@ ^^^^^^^^^^^^^^^^                                                     ,,.                                                                                                  ---    ----   ----       @
@  ^^^^^^^^^^^^^                                                        ,.                                                                                                   -      --     --        @
@  ^^^^^^^^^^^^^^                                                        .                                                                                                                           @
@    ^^^^^^^^^^^^^^                                                      .                                                                                                                           @
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@]]
