-- $Id: lothlorien.lua 1099 2014-11-12 04:41:38Z dsb $
-- ToME - Tales of Middle-Earth
-- Copyright © 2012-2014 Scott Bigham
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Scott Bigham "Zizzo"
-- dsb-tome@killerbbunnies.org

defineTile('.', 'FLOOR')
defineTile('W', 'DEEP_WATER')
defineTile('V', 'SHALLOW_WATER')
defineTile(',', 'DIRT')
defineTile('-', 'GRASS')
defineTile('#', 'PERMA_WALL')
defineTile('k', 'ALTAR_OF_BEING')
defineTile('l', 'ALTAR_OF_WINDS')
defineTile('m', 'ALTAR_OF_FORCE')
defineTile('n', 'ALTAR_OF_NATURE')

-- "Transparent" areas, passing through the previously generated tile from
-- PlasmaWilderness.
--defineTile(' ')

-- Remember some spots for future reference.
defineTile('z', 'TREE', nil, nil, nil, nil, { type='quest', subtype='mage' })
defineTile('y', 'TREE', nil, nil, nil, nil, { type='quest', subtype='spiders' })
defineTile('x', 'TREE', nil, nil, nil, nil, { type='quest', subtype='poison-water' })
defineTile('w', 'PERMA_WALL', nil, nil, nil, nil, { type='quest', subtype='house' })
defineTile('v', 'DIRT', nil, nil, nil, nil, { type='quest', subtype='void' })

-- This is described as "Castle: Plot Lorien" in t_lorien.txt.  No idea
-- what that's supposed to mean; just fill it in as perma-wall for now.
defineTile('B', 'PERMA_WALL')

defineTile('1', 'PERMA_WALL', nil, nil, 'GENERAL_STORE')
defineTile('2', 'PERMA_WALL', nil, nil, 'ARMOURY')
defineTile('3', 'PERMA_WALL', nil, nil, 'WEAPONSMITH')
defineTile('4', 'PERMA_WALL', nil, nil, 'TEMPLE')
defineTile('5', 'PERMA_WALL', nil, nil, 'ALCHEMY_SHOP')
defineTile('6', 'PERMA_WALL', nil, nil, 'MAGIC_SHOP')
defineTile('7', 'PERMA_WALL', nil, nil, 'BLACK_MARKET')
defineTile('9', 'PERMA_WALL', nil, nil, 'BOOK_STORE')
defineTile('0', 'PERMA_WALL', nil, nil, 'PET_SHOP')
defineTile('a', 'PERMA_WALL', nil, nil, 'THE_MIRROR')
defineTile('b', 'PERMA_WALL', nil, nil, 'SEAT_OF_RULING')
defineTile('c', 'PERMA_WALL', nil, nil, 'INN')
defineTile('d', 'PERMA_WALL', nil, nil, 'BEASTMASTER_SHANTY')
defineTile('g', 'PERMA_WALL', nil, nil, 'WIZARDS_SPIRE')
defineTile('h', 'PERMA_WALL', nil, nil, 'PRIESTS_CIRCLE')
defineTile('i', 'PERMA_WALL', nil, nil, 'RANGERS_GUILD')
defineTile('j', 'PERMA_WALL', nil, nil, 'THUNDERLORDS_NEST')

startx=109
starty=26

-- '@' tiles, also being undefined, will also pass through PlasmaWilderness
-- tiles; we use them for the border instead of ' ' purely for cosmetic
-- reasons, as spaces would be hard to see on the borders.
return [[
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@                         ,  ,                                       ,                             .              ,    ,                ,,                         , ,             ,                 @
@                      ,                          ,                                                .                                                                                               , @
@               ,              ,                                                                   .                                                                                                 @
@                           ,                            ,                          ,,           , .                                        ,      ,                                               , @
@                   ,,     ,                                                                       ,               ,                ,,          ,              ,               , ,              ,    @
@           ,                            ,    ,                          ,     ,                   ,        ,                                     ,                                                  @
@           ,                  ,                                   ,                               ,x                                          ,                                 ,                   @
@                                                                                                  ,                                           ,                ,        ,                           @
@               ,,     ,                                                                           ,     ,    ,,                            ,                              ,                ,        @
@          ,            ,                                                                          ,                       ,                                                                         @
@                         ,  ,                                       ,                             ,              ,    ,                ,,                         , ,             ,                 @
@                      ,                          ,                                                ,                                                                                               , @
@               ,              ,                                         z,,,,                ##   ,   ##                                                                                            @
@                      ,                          ,                          ,               ####  ,  ####                                                                                         , @
@               ,              ,                                             ,   ###         ###1,,,,,h###                                                                                           @
@                           ,                            ,              ###  ,  #####,       ####, ,  ####                                  ,      ,                                               , @
@                   ,,     ,                                           ##### ,  #####         ##   ,   ##          ,                ,,          ,              ,               , ,              ,    @
@           ,                            ,    ,                        ##### , ,##.##    ###  ##   ,   ##   ,                                     ,                                                  @
@           ,                  ,                   #              #,   ##### ,  ##.##   #########  ,  ####                                     ,                                 ,                   @
@               ,,     ,                          ###            ###    #g#  ,    .     ########c,,,,,4###    ,,                            ,                              ,                ,        @
@                           ,                      ####  ,     ####      ,   ,    , ,,  #########  ,  ####                                  ,      ,                                               , @
@                   ,,     ,                        ##############       ,,,,,    ,      #9#  ##   ,   ##          ,                ,,          ,              ,               , ,              ,    @
@           ,                            ,    ,     ##############       ,     ,  ,       ,        ,   ##   ,                                     ,                                                  @
@           ,                  ,                     ###########j,,,,,,,,,,,,,,   ,       ,        ,  ####                                     ,                                 ,                   @
@          ,            ,                           #####B########       ,    ,,,,,,,,,,,,,,,,,,,,,,,,d###    y            ,                                                                         @
@                         ,  ,                      ##############   ,   ,                         ,  ####  ,,    ,    ,                ,,                         , ,             ,                 @
@                      ,                          ,####        ####      ,                         ,   ##  ,                                                                                       , @
@               ,              ,                  ###            ###    #6#       ###    ###       ,      ,   ###  ###                                                                               @
@           ,                  ,                   #              #,   #####      ###    ###       ,   ,,,   ##########                        ,                                 ,                   @
@                                                                      #####      #7#    #i#    ,,,,,,,,     ##########                        ,                ,        ,                           @
@               ,,     ,                                                ###        ,      ,     ,  ,   , ,    #3#  ###                      ,                              ,                ,        @
@          ,            ,                                                          ,      ,    ,,  ,   ,       ,    ,   ## ,                                                                         @
@                         ,  ,                                                ,,,  ,,,,,,,,,,,,,  ,,,  ,       ,  , ,  ####             ,,                         , ,             ,                 @
@                      ,                          ,                           , ,,,,           ,,,,b,,,,,,,,,,,,,,,,,,,w###                                                                        , @
@               ,              ,                                             v,                   ,,,             ,    ####                                                                          @
@                           ,                            ,                 --,--    ,,             ,   VVV        ,     ##                  ,      ,                                               , @
@                   ,,     ,                                            l----,----m                , VWWWV       #2#                ,,          ,              ,               , ,              ,    @
@           ,                            ,    ,                         ---VV,VV---                , VWWVV  ,   #####                             ,                                                  @
@          ,            ,                                              ---VVW,WVV---               , VVVV       #####      ,                                                                         @
@                         ,  ,                                       , ---VWWaWVV---               ,,            ###   ,                ,,                         , ,             ,                 @
@                                                                      ---VVWWWVV---                ,,,                                        ,                ,        ,                           @
@               ,,     ,                                                ---VVVVV---   ,,,,,,,,,,,,,,, ,       ,,                            ,                              ,                ,        @
@                                                                       n---------k   ,               ,                                        ,                ,        ,                           @
@                      ,                          ,                         ---       ,              #5#                                                                                           , @
@               ,              ,                                                      ,              ###                                                                                             @
@                           ,                            ,                            ,          ,   ###                                    ,      ,                                               , @
@                   ,,     ,                                                         #0#                           ,                ,,          ,              ,               , ,              ,    @
@           ,                            ,    ,                          ,     ,    #####                   ,                                     ,                                                  @
@           ,                  ,                                   ,                #####                                                      ,                                 ,                   @
@                                                                                    ###                                                       ,                ,        ,                           @
@               ,,     ,                                                                                 ,    ,,                            ,                              ,                ,        @
@          ,            ,                                                                                                  ,                                                                         @
@                         ,  ,                                       ,                                            ,    ,                ,,                         , ,             ,                 @
@                           ,                            ,                          ,,           ,                                          ,      ,                                               , @
@                   ,,     ,                                                                                       ,                ,,          ,              ,               , ,              ,    @
@           ,                            ,    ,                          ,     ,                            ,                                     ,                                                  @
@           ,                  ,                                   ,                                                                           ,                                 ,                   @
@                                                                                                                                              ,                ,        ,                           @
@               ,,     ,                                                                                 ,    ,,                            ,                              ,                ,        @
@                      ,                          ,                                                                                                                                                , @
@               ,              ,                                                                                                                                                                     @
@                           ,                            ,                          ,,           ,                                          ,      ,                                               , @
@                   ,,     ,                                                                                       ,                ,,          ,              ,               , ,              ,    @
@                                                                                                                                                                                                    @
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@]]
