-- $Id: minas-anor.lua 1103 2014-11-12 05:21:36Z dsb $
-- ToME - Tales of Middle-Earth
-- Copyright © 2012-2014 Scott Bigham
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Scott Bigham "Zizzo"
-- dsb-tome@killerbbunnies.org

defineTile('^', 'MOUNTAIN_CHAIN')
defineTile('T', 'TREE')
defineTile('V', 'SHALLOW_WATER')
defineTile(',', 'DIRT')
defineTile('@', 'MUD')
defineTile('-', 'GRASS')
defineTile('#', 'PERMA_WALL')
defineTile('s', 'BRICK_ROOF')
defineTile('S', 'BRICK_ROOF_TOP')
defineTile('t', 'BRICK_ROOF_CHIMNEY')
defineTile('X', 'GRASS_ROOF')
defineTile('O', 'COBBLESTONE_ROAD')
defineTile('I', 'UNDERGROUND_TUNNEL')
defineTile('M', 'UNDERGROUND_TUNNEL_END')

-- "Transparent" areas, passing through the previously generated tile from
-- PlasmaWilderness.
--defineTile(' ')

-- Remember some spots for future reference.
defineTile('Z', 'PERMA_WALL', nil, nil, nil, nil, { type='quest', subtype='between-gate' })
defineTile('w', 'PERMA_WALL', nil, nil, nil, nil, { type='quest', subtype='house' })
defineTile('x', 'PERMA_WALL', nil, nil, nil, nil, { type='quest', subtype='library' })

-- This is described as "Castle: Plot Minas Anor" in minas.txt.  No idea
-- what that's supposed to mean; just fill it in as perma-wall for now.
defineTile('B', 'PERMA_WALL')

defineTile('1', 'PERMA_WALL', nil, nil, 'GENERAL_STORE')
defineTile('2', 'PERMA_WALL', nil, nil, 'ARMOURY')
defineTile('3', 'PERMA_WALL', nil, nil, 'WEAPONSMITH')
defineTile('4', 'PERMA_WALL', nil, nil, 'TEMPLE')
defineTile('5', 'PERMA_WALL', nil, nil, 'ALCHEMY_SHOP')
defineTile('6', 'PERMA_WALL', nil, nil, 'MAGIC_SHOP')
defineTile('7', 'PERMA_WALL', nil, nil, 'BLACK_MARKET')
defineTile('9', 'PERMA_WALL', nil, nil, 'BOOK_STORE')
defineTile('0', 'PERMA_WALL', nil, nil, 'PET_SHOP')
defineTile('f', 'PERMA_WALL', nil, nil, 'BEASTMASTER_SHANTY')
defineTile('g', 'PERMA_WALL', nil, nil, 'FIGHTERS_HALL')
defineTile('h', 'PERMA_WALL', nil, nil, 'TOWER_OF_MAGERY')
defineTile('i', 'PERMA_WALL', nil, nil, 'INNER_TEMPLE')
defineTile('j', 'PERMA_WALL', nil, nil, 'PALADINS_GUILD')
defineTile('k', 'PERMA_WALL', nil, nil, 'RANGERS_GUILD')
defineTile('l', 'PERMA_WALL', nil, nil, 'THUNDERLORDS_NEST')
defineTile('a', 'PERMA_WALL', nil, nil, 'MINAS_ANOR_LIBRARY')
defineTile('b', 'PERMA_WALL', nil, nil, 'CASTLE')
defineTile('d', 'PERMA_WALL', nil, nil, 'CASINO')
defineTile('e', 'PERMA_WALL', nil, nil, 'INN')
defineTile('m', 'PERMA_WALL', nil, nil, 'MERCHANTS_GUILD')

-- '%' tiles, also being undefined, will also pass through PlasmaWilderness
-- tiles; we use them for the border instead of ' ' purely for cosmetic
-- reasons, as spaces would be hard to see on the borders.
return [[
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%^^########------------------                                                                     @@@@@@@                   @@@@@@@@@                                                                %
%^^^------############----------             ^                                                   @@VVVVV@@                 @@VVVVVVV@@@@@@@                                       ,,,                %
%^^^----------###----#######-------         ^^^^^                                                @VVVVVVV@@@@@            @@VV@@@@@@VVVVVV@@@@                                   ,,                  %
%^^----ssss-----###--------####------        ^^^^^^                                              @VVVVVV@@VVV@@@          @VV@@    @@@@@@VVVV@@                                 ,,                   %
%^^^---StSS-------###--#ssss--###-------      ^^^^^^^^                                           @@VVVVVVVV@VVV@@@@@@@@ @@@V@@          @@@@VV@@@@                              ,                    %
%^^----ssss----OO---##--#StSS---####------     ^^^^^^^^                                           @@V@V,@@@@@@VVVVVVVV@@@VVV@              @@VVVV@@                            ,,                    %
%^^----x#a#-----OOO--##--#sssss----###------    ^^^^^^^^                                           @@@@@     @@@@@@@@VVVVV@@@               @@@@VV@@@                        ,,,                     %
%^ ---------------OO--###-#m#7#------###-----   ^^^^^^^^^^                                                           @VVV@@                    @@VVV@@                       ,O,                     %
%^ StSSSS-----ss---OO---##-----OOOOO---###----   ^^^^^^^^^^^                                                          @@@                       @@VVV@@                      OO                      %
%^^ssssss----Ssss---OOO--##---OOOOOOOO---##----   ^l^^^^^^^                                                                                     @@VVV@                      OO                       %
%^ ####9#---sstSss---OOO--##-OOOOOOOOOOO--##----    ^^^^^                                                                                      @@VVV@@                     OO                        %
%^^^-------##sssSss---OOO--#OOO--s--OOOOO--###---                                                                              @@@@@@@@@@     @@VVV@@                     OO                         %
%^^^######---##ssh--s--OOO-OOO--StS--OOOOO---##---                                                                            @@VVVVVVVV@@@@@@@V@@@@                     OO                          %
%^^^^----###---##--ssS--OOOOO#--ssss--OOOOOO--##---                                                                           @VVVVVVVVVVVV@@VV@@      OOO              OO                           %
%^^--------###----ssSs#--OOO-##-#####--OOOOOO--##---            ----                                                          @VVVV@@@@VVVVVVV@@      OOOOO         OOOOO                            %
%^ ----------##--#stsi--OOOO--#---------OOOOOO--#------       --------                                                       @@VVV@@  @@VVV@@@@       OO  OO       OO                                %
%^^-----------###-#s#--OOOOOO-##-#sssss--OOOOOO,#####---     -----------                                                    @@VVV@@    @@@@@         OO-   OOOOOOOOO                                 %
%^^-------------##-#--OOO-OOO--#--ssssss--OOOOO,,,,,#----  ---ssssssss---                                                   @VVV@@                 -OO                                               %
%^^--------------#---OOO-t-OOO-##-#SStSS--OOOOOO,##,#---------ssssssss----                                                  @VV@@                --OO-                                               %
%^^^--#----------##-OOO-sssOOO--#--ssssss-OOOOOO--#,#####-----SStSSSSS-----                                                @@VV@                --OO-                                                %
%^^^--#-----------#OOO-##4##OOO-##-ssssss--OOOOOO-#,,######---ssssssss--O---                                              @@VVV@                -OO--                                                %
%^^--###----------OOO-------OOO--#-####2#--OOOOOO-##,#k#,,##--ssssssss--O----                                             @VVV@@               --O--                                                 %
%^^^-###---------OOO#--SSStS-OOO-#---------OOOOO---#,,,,,,,#--ssssssss--O-----                                           @@VV@@               --OO-                                                  %
%^^-#####-------OOO-#--sssss-OOO-#--ssss--OOOOO--T-#,-----,#--#####d##--O------                                          @VVV@               --OO--                                                  %
%^^#######------OOO-##-###j#-OOO-##-ssss--OOOOO-TT-#------,#-------,,,,,O------                                         @@VV@@              --OO--                                                   %
%^^^########----OOO--#-------OOO--#-StSS--OOOOO-TT-#-----,,#------------O-------                                        @VVV@@             --OO--                                                    %
%^^############-OOO--##-StSSS-OOO-#-ssss--OOOOO--T-#----,,##---ssssssss-O--------                                      @@VV@@             --OOO--                                                    %
%^^^#########---OOO---#-sssss-OOO-#-ssss--OOOOOO---#,,,,,##----SSSSStSS-O---------                                   @@@VVV@             --OOO--                                                     %
%^^#####B###----OOO---#-###6#-OOO-#-##g#---OOOOOO--#######-----ssssssss-O----------                                  @VVVV@@           ---OOO--                                                      %
%^^^#######-----OOO---#-------OOO-#---------OOOOOOOOOOOOOOOOO--###e####-O-----------                                @@VVV@@         ------OO--                                                       %
%^^#######bOOOOOOOO-^^^^^^^^^^MMM^^^^^^^^^^^^OOOOOOOOOOOOOOOOOOOOOOOOOOOO-----------                              @@@VVV@@         ---OOOOOO--                                                       %
%^^#######bOOOOOOO############III############^OOOOOOOOOOOOOOOOOOOOOOOOOOOOO---------                             @@VVVV@@         ---OOOOOO--                                                        %
%^ #######bOOOOOOO############III############^OOOOOOOOOOOOOOOOOOOOOOOOOOOOOO---------                            @VVVV@@        ----OOOOOO----                                                       %
%^ #######bOOOOOOOO-^^^^^^^^^^MMM^^^^^^^^^^^^OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO-------                            @VVV@@      ------OOOO------                                                        %
%^^^######Z-----OOO---#-sSss--OOO-#---------OOOOOOOOOOOOOOOOO-----------OOOOOOO------                 ---------##@VVV@## --------OOOOO-----                                                          %
%^^#########----OOO---#-sSss--OOO-#-sssss--OOOOOO--#######--------sssss-O-OOOOO-----                 --OOOO-----#######--------OOOOOO-----                                                           %
%^^##########---OOO---#-stss--OOO-#-SStSS-OOOOOO---####,,##-------SStSS-O-OOOOO----                 --OOOOOOOOOOOOOOOOOOOOOOOOOOOOOO-----                                                            %
%^^############-OOO--##-sSss--OOO-#-sssss-OOOOO--T-##k#,,,##------sssss-O--OOOOO---                --OOOOOOOOOOOOOOOOOOOOOOOOOOOOOO-----                                                             %
%^^#########----OOO--#--####-OOO--#-sssss-OOOOO-TT-#,,,,-,,#------sssss-O---OOOO---               --OOOOO-OOOOOOOOOOOOOOOOOOOOOOO-------                                                             %
%^^#######------OOO-##-------OOO-##-###3#-OOOOO-TT-#,-----,#------###0#-O---OOOOO---             --OOOO---------#######---------------                                                               %
%^^-#####-------OOO-#--Ssss--OOO-#--------OOOOO--T-#,-----,#------------O----OOOO----           --OOOO---------##@VVV@##-----------                                                                  %
%^^^-###---------OOO#-#stss--OOO-#-ssssss--OOOOO---#,----,,#----ssssss--O-----OOOO----        ---OOOO---         @VVV@@                                                                              %
%^^--###----------OOO--#sSs-OOO--#-StSSSS--OOOOOO-##,-,,,,##----SStSSS--O------OOOO----      --OOOOO----         @VVV@@                                                                              %
%^^---#-----------#OOO--###-OOO-##-ssssss--OOOOOO-#,,,,####-----ssssss--O-------OOOO----    --OOOOO----          @VVVV@                                                                              %
%^^^--#----------##-OOO----OOO--#--###5##-OOOOOO--#,#####-------ssssss-OO--------OOOO--------OOOOO----           @@VVV@@@                                                 @@@@                       %
%^^^-------------#---OOO---OOO-##---------OOOOOO,##,#-----------####1#-O----------OOOO----OOOOOO-----             @@VVVV@@@                                             @@@@@@                       %
%^^-------------##----OOO-OOO--#--ss------OOOOO,,,,,#------------------O-----------OOOOOOOOOOO-----                @@@VVVV@@                                      @@@@@@@@@V@@@                      %
%^^^----------###--ss--OOOOOO-##-ssSs----OOOOOO,#####------------------O-------- ---OOOOOOOOO---                     @@VVVV@@                    @@@@@          @@@@@@@@@@@@@                        %
%^^^---------##---ssSs--OOOO--#--ssts#--OOOOOO--#------ ------ssssss--OO------    ---OOOOO-----                       @@VVVV@@@                @@@VVV@@@        @@@V@@@@@@@@                         %
%^^--------###---sstss#--OOO-##-ssSs#--OOOOOO--##-----    ----StSSSS--O------      -----------                         @@@VVVV@@@@@         @@@@VVVVVVV@@   @@@@@V@@V@@@V@@                          %
%^^------###-----#Sss#--OOOOO#--sSsf--OOOOOO--##-----      ---ssssss--O-----        -------                              @@@VVVVVV@@@@@@@@@@@VVVVV@@@VVV@@@@@VVVV@@@@ @@@@                           %
%^^^######---ss---#s#--OOO-OOO--Ss#--OOOOO---##-----        --###w##-OO-----                                               @@VVVVVVVVVVVVVVVVV@@@@@ @@@VVVVVVV@@@@                                   %
%^^^-------ssssS---#--OOO--#OOO--#--OOOOO--###-----          --------O-----                                                 @@@@@@@@@@@@@@@@@@@       @@@@@@@@@                                      %
%^^-sssss-#ssstss----OOO--##-OOO---OOOOO--##------            ------OO----                                                                                                                           %
%^^-SSStS--#sSsss#--OOO--##---OOOOOOOO---##------               ----O----                                                                                                                            %
%^^-sssss---#ss##--OO---##--X--OOOOO---###------                ---O---                                                                                                                              %
%^^^#####----##---OO--###--XXX-OOO---###------                    ---                                                                                                                                %
%^^^------------OOO--##---XXX#-----###-----                                                                                                                                                          %
%^^--SStSS-----OO---##--XX###---####-----                                                                                                                                                            %
%^^^-sssss--------###--###----###------                                                                                                                                                              %
%^^--#####------###--------####------                                                                                                                                                                %
%^^^----------###----#######------                                                                                                                                                                   %
%^^^------############----------                                                                                                                                                                     %
%^^########-----------------                                                                                                                                                                         %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%]]
