-- $Id: mount-doom.lua 2592 2016-10-18 03:08:09Z dsb $
-- ToME - Tales of Middle-Earth
-- Copyright © 2012-2016 Scott Bigham
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Scott Bigham "Zizzo"
-- dsb-tome@killerbbunnies.org

-- -----------------------------------------------------------------------
-- WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING
-- -----------------------------------------------------------------------
-- This file was generated automatically by the 'convert-map' Perl script.
-- DO NOT MODIFY THIS FILE DIRECTLY, as any changes will be lost the next
-- time the file is generated (with the possible exception of lines between
-- 'BEGIN VERBATIM' and 'END VERBATIM' markers, if supported by the script).
-- -----------------------------------------------------------------------
-- WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING
-- -----------------------------------------------------------------------

-- Mount Doom map generated from s_doom.map with the following args:
--   -l 99
--   --secret-door 'LAVA_WALL'
--   --startxy-hack
--   -S $='on_drop=drop_ring'

-- BEGIN VERBATIM
local function drop_ring(who, x, y, idx, o)
  if o.define_as == 'OF_POWER_THE_ONE_RING' then
    -- Remove the Ring we just dropped.  We do *not* called :removed() on
    -- it, as that would put it back into play.
    game.level.map:removeObject(x, y, idx)

    local Dialog = require 'engine.ui.Dialog'
    local text = [[You throw the One Ring into the #C_R#Great Fire#LAST#, and it is rapidly consumed by the searing flames.  You can feel its power dissipating and fading away.  Now you can take the hunt to Sauron.]]
    local function cb()
      game.player:abandonVala('Melkor')
      game.player:grantQuest('sauron')
      world:gainAchievement('ONE_RING', game.player)
    end
    game.player:setQuestStatus('one-ring', engine.Quest.DONE)
    Dialog:simpleLongPopup('The One Ring', text, 600, cb)
  end
end
-- END VERBATIM

defineTile('X', 'LAVA_WALL')
defineTile('#', 'LAVA_WALL')
defineTile(' ', 'LAVA_WALL')
defineTile('$', 'GREAT_FIRE', nil, nil, nil, { on_drop=drop_ring })
defineTile('%', 'A_BLAZING_FIRE')
defineTile('+', 'SECRET_DOOR', nil, nil, nil, { secret_door='LAVA_WALL' })
defineTile('D', 'DOOR')
defineTile('.', 'SHALLOW_LAVA')
defineTile('L', 'DEEP_LAVA')
defineTile('^', 'DEEP_LAVA', nil, nil, util.ood_filter(0, trap_util.default_filter))
defineTile('t', 'SHALLOW_LAVA', nil, nil, util.ood_filter(0, trap_util.default_filter))
defineTile('<', 'UP')
defineTile('A', 'DEEP_LAVA', nil, 'GREATER_BALROG')
defineTile('B', 'DEEP_LAVA', nil, 'LESSER_BALROG')
defineTile('b', 'SHALLOW_LAVA', nil, 'LESSER_BALROG')
defineTile('C', 'DEEP_LAVA', nil, 'PIT_FIEND')
defineTile('c', 'SHALLOW_LAVA', nil, 'PIT_FIEND')
defineTile('E', 'DEEP_LAVA', nil, 'GREAT_WYRM_OF_POWER')
defineTile('e', 'SHALLOW_LAVA', nil, 'GREAT_WYRM_OF_POWER')
defineTile('F', 'DEEP_LAVA', nil, 'BONE_GOLEM')
defineTile('G', 'DEEP_LAVA', nil, 'DRACOLISK')
defineTile('H', 'DEEP_LAVA', nil, 'NYCADAEMON')
defineTile('h', 'SHALLOW_LAVA', nil, 'NYCADAEMON')
defineTile('I', 'DEEP_LAVA', nil, 'BARBAZU')
defineTile('i', 'SHALLOW_LAVA', nil, 'BARBAZU')
defineTile('J', 'DEEP_LAVA', nil, 'PLASMA_HOUND')
defineTile('j', 'SHALLOW_LAVA', nil, 'PLASMA_HOUND')
defineTile('K', 'DEEP_LAVA', nil, 'HELL_KNIGHT')
defineTile('k', 'SHALLOW_LAVA', nil, 'HELL_KNIGHT')
defineTile('M', 'DEEP_LAVA', nil, 'NIGHTCRAWLER')
defineTile('m', 'SHALLOW_LAVA', nil, 'NIGHTCRAWLER')
defineTile('N', 'DEEP_LAVA', nil, 'AETHER_HOUND')
defineTile('n', 'SHALLOW_LAVA', nil, 'AETHER_HOUND')
defineTile('o', 'SHALLOW_LAVA', nil, 'EYE_DRUJ')
defineTile('P', 'DEEP_LAVA', nil, 'SKULL_DRUJ')
defineTile('p', 'SHALLOW_LAVA', nil, 'SKULL_DRUJ')
defineTile('Q', 'DEEP_LAVA', nil, 'GREAT_HELL_WYRM')
defineTile('q', 'SHALLOW_LAVA', nil, 'GREAT_HELL_WYRM')
defineTile('R', 'DEEP_LAVA', nil, 'NIGHTWALKER')
defineTile('r', 'SHALLOW_LAVA', nil, 'NIGHTWALKER')
defineTile('S', 'DEEP_LAVA', nil, 'OSYLUTH')
defineTile('s', 'SHALLOW_LAVA', nil, 'OSYLUTH')
defineTile('U', 'DEEP_LAVA', nil, 'GREAT_WYRM_OF_MANY_COLOURS')
defineTile('u', 'SHALLOW_LAVA', nil, 'GREAT_WYRM_OF_MANY_COLOURS')
defineTile('V', 'DEEP_LAVA', nil, 'AETHER_HOUND')
defineTile('v', 'SHALLOW_LAVA', nil, 'AETHER_HOUND')
defineTile('W', 'DEEP_LAVA', nil, 'BRONZE_GOLEM')
defineTile('w', 'SHALLOW_LAVA', nil, 'BRONZE_GOLEM')
defineTile('!', 'DEEP_LAVA', nil, util.ood_filter(0))
defineTile('1', 'SHALLOW_LAVA', nil, util.ood_filter(0))
defineTile('@', 'DEEP_LAVA', nil, util.ood_filter(10))
defineTile('2', 'SHALLOW_LAVA', nil, util.ood_filter(10))
defineTile('&', 'DEEP_LAVA', util.ood_filter(0), util.ood_filter(0))
defineTile('7', 'SHALLOW_LAVA', util.ood_filter(0), util.ood_filter(0))
defineTile('(', 'DEEP_LAVA', util.ood_filter(5), util.ood_filter(10))
defineTile('9', 'SHALLOW_LAVA', util.ood_filter(5), util.ood_filter(10))

startx=4
starty=4
return [[
XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
X          #%%NNLL...JJJ....LL#                                               ##############   X
X #####    #NNNN...Ljjjjj..LLL#   #############################################..1!!!!...L###  X
X##.LL##   #nNNN...LLJJj.LLLLL#   #L....&!&!&....L%%%%%%%L..mRR%R%%M%MML%LL...DL...!1&..@L%%#  X
X#LL<..#   #nn.LL.LLLL...%%%LL#   #..##########################################LLL....LLL%%%#  X
X##%LL##   #....LLL%%LLL..^LLL#   #.L#                                        #LL2.t..q.LLL##  X
X ###+#    #D##############+#######.L#                                       ##%%.LLLL&L...#   X
X   #!#    #.#            #.......L%%#                                      ##%%LL..2...t.##   X
X   #^#    #.############ ##########+#             XXXXXXXXXX                ##.9.t.LLLLL##    X
X   #.#    #LL%%%%LL...p#      #11111#             X########X     ###############.2..LQ#+#     X
X  ##.#    ############D##     #11211#             X#9....9#X     #o.....t...#  ###^L..#(#     X
X  #L##             ##%%V##    #12221#        XXXXXX#..$$..#XXXXXX#LLLLKkk...#    ###D####     X
X  ##!#            ##.VH^%##   #12221#        X######t....m######X#LLLLkkk.LL#      #.#        X
X   #.#           ##.iH%%hv##  #11211###      X#sSSSrrt%.mVVVLLe#X#.LL.kkk...#     ##.#        X
X ###D#########   #tiI%HHhvL#  #11111+9#      X#rRssRr.%.mVvvm..#X#%...LLL...#    ##Lo######   X
X #.^t^LLL...L##  #.LIH%Hc..#  #########      X#.MmmM..%..MMLLL.#X#%%......L&#   ##.L##EBBB#   X
X #.jJ%%%L....L#  ##..ICCL.##                 X#.L..L..%ttL.....#X########D###   #.####LAAB##  X
X #JJJJL%LLL&..#   ##..L.L##                  X#9LLL...%..LL(LLq#X   #..L..#     #.LL..LB%%L#  X
X #J%J..LLL%%LL##   ##.t.##                   X######......######X   #L.####     ###..LL%%%L## X
X #jJJ^..bL%LL..##   ##D#################     XXXXXX#.LUUL.#XXXXXX   #.L#          #.PL%%%@(L# X
X ##....BABLL..L.##   #.uLL^L..L%^^..L%%#          X#.L%%LL#X        #L.####       ###.L%LL..##X
X  ##....B%%L.....##  #################L#          X#LLL..t#X        #..twW#        #L..LL...+pX
X  ###....LLL...LLL####################.#          X#%L..7.#X        #####L#      ###LL...1###oX
X  #9+L%%L...LLL....D.+..%%oF.%%^..%%LL.#          X#LLLLt.#X            #p#      #%%%!@..## #tX
X  ##################L###.L###..###.L####          X#7tt.LL#X            #.#      #########  #EX
X  ##################.# ##############             X#.LLLL.#X       ######D###################LX
X      ##11!!!&LL.+(#L#                            X#LL%%LL#X       #G..LLL.LL...D..LL....^LLL%X
X     ##1!!!%%%%Lp###L#                            X#L%%%%Q#X       #..LF....K...##############X
X     ##!!%%%%%LLL..#.#                            XXXXDDXXXX########.LLLL..KKK..####          X
X      ##.LLLLLLL...+.#                               #%%%%%%%%%%%%%+LL7..LL.k..L+o7#          X
X       ###############                               ###############################          X
XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX]]
