-- $Id: object_fields.lua 2550 2016-09-28 00:49:11Z dsb $
-- ToME - Tales of Middle-Earth
-- Copyright (C) 2012 Scott Bigham
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Scott Bigham "Zizzo"
-- dsb-tome@killerbbunnies.org

-- Descriptions for various flags, used by Object:getDesc().

newFieldDesc('pval', 'STR', 'STR')
newFieldDesc('pval', 'INT', 'INT')
newFieldDesc('pval', 'WIS', 'WIS')
newFieldDesc('pval', 'DEX', 'DEX')
newFieldDesc('pval', 'CON', 'CON')
newFieldDesc('pval', 'CHA', 'CHA')
newFieldDesc('pval', 'skill_stealth', 'stealth')
newFieldDesc('pval', 'skill_searching', 'searching')
newFieldDesc('pval', 'infravision', 'infravision')
newFieldDesc('pval', 'adj_digging', 'tunneling')
newFieldDesc('pval', 'speed', 'speed')
newFieldDesc('pval', 'extra_blows', 'attacks')
newFieldDesc('pval', 'adj_luck', 'luck')
newFieldDesc('pval', 'spellpower', 'spell power')
newFieldDesc('pval', 'invisibility', 'invisibility')
newFieldDesc('pval%', 'extra_crit', 'critical hit chance')
newFieldDesc('pval%20', 'mana_mult', 'mana')
newFieldDesc('pval%20', 'hp_mult', 'hit points')

newFieldDesc('slay', 'X_DRAGON', '*dragon*')
newFieldDesc('slay', 'DRAGON', 'dragon')
newFieldDesc('slay', 'ORC', 'orc')
newFieldDesc('slay', 'TROLL', 'troll')
newFieldDesc('slay', 'GIANT', 'giant')
newFieldDesc('slay', 'X_DEMON', '*demon*')
newFieldDesc('slay', 'DEMON', 'demon')
newFieldDesc('slay', 'X_UNDEAD', '*undead*')
newFieldDesc('slay', 'UNDEAD', 'undead')
newFieldDesc('slay', 'EVIL', 'evil')
newFieldDesc('slay', 'ANIMAL', 'animal')

newFieldDesc('on_hit', 'CHAOTIC', 'chaotic effects')
newFieldDesc('on_hit', 'VAMPIRIC', 'drains life from target')
newFieldDesc('on_hit', 'VORPAL', 'vorpal effects')
newFieldDesc('on_hit', 'WOUNDING', 'causes bleeding')

newFieldDesc('sustain', 'SUST_STR', 'STR')
newFieldDesc('sustain', 'SUST_INT', 'INT')
newFieldDesc('sustain', 'SUST_WIS', 'WIS')
newFieldDesc('sustain', 'SUST_DEX', 'DEX')
newFieldDesc('sustain', 'SUST_CON', 'CON')
newFieldDesc('sustain', 'SUST_CHA', 'CHA')

newFieldDesc('esp', 'ORC', 'orcs')
newFieldDesc('esp', 'TROLL', 'trolls')
newFieldDesc('esp', 'DRAGON', 'dragons')
newFieldDesc('esp', 'GIANT', 'giants')
newFieldDesc('esp', 'DEMON', 'demons')
newFieldDesc('esp', 'UNDEAD', 'undead')
newFieldDesc('esp', 'EVIL', 'evil beings')
newFieldDesc('esp', 'ANIMAL', 'animals')
newFieldDesc('esp', 'THUNDERLORD', 'thunderlords')
newFieldDesc('esp', 'GOOD', 'good beings')
newFieldDesc('esp', 'NONLIVING', 'non-living things')
newFieldDesc('esp', 'UNIQUE', 'uniquebeings')
newFieldDesc('esp', 'SPIDER', 'spiders')
newFieldDesc('esp', 'ALL', 'all beings')

newFieldDesc('drain', 'drain_mana', '#C_b#mana#LAST#')
newFieldDesc('drain', 'drain_hp', '#C_r#life#LAST#')
newFieldDesc('drain', 'DRAIN_EXP', '#DARK_GREY#experience#LAST#')

newFieldDesc('breath', 'WATER_BREATH', 'water')
newFieldDesc('breath', 'MAGIC_BREATH', 'all environments')

newFieldDesc('bow_mult', 'extra_might', 'ammo multiplier')
newFieldDesc('bow_shot', 'extra_shots', 'shots/turn')

newFieldDesc('confer', 'FREE_ACT', 'immunity to paralysis')
newFieldDesc('confer', 'HOLD_LIFE', 'resistance to experience loss')
newFieldDesc('confer', 'WRAITH', 'wraith form')
newFieldDesc('confer', 'FEATHER', 'levitation')
newFieldDesc('confer', 'FLY', 'flight')
newFieldDesc('confer', 'CLIMB', 'ability to climb mountains')
newFieldDesc('confer', 'SEE_INVIS', 'see invisible')
newFieldDesc('confer', 'SLOW_DIGEST', 'slow digestion')
newFieldDesc('confer', 'REGENERATE', 'regeneration')
newFieldDesc('confer', 'REFLECT', 'reflection of bolts/arrows')
newFieldDesc('confer', 'NO_MAGIC', 'anti-magic shell')
newFieldDesc('confer', 'AUTO_ID', 'auto-ID all items')
newFieldDesc('confer', 'PRECOGNITION', 'precognition')
newFieldDesc('confer', 'TELEPORT', 'random teleportation')
newFieldDesc('confer', 'AGGRAVATE', 'aggravation')
newFieldDesc('confer', 'BLACK_BREATH', '#RED#Black Breath#LAST#')
newFieldDesc('prevent', 'NO_TELE', 'teleportation')
newFieldDesc('prevent', 'IMMOVABLE', 'movement')

newFieldDesc('trap', 'AUTOMATIC_5', 'automatically re-arms (80% chance)')
newFieldDesc('trap', 'AUTOMATIC_99', 'automatically re-arms')
newFieldDesc('trap', 'KILL_GHOST', 'effective against ghosts')
newFieldDesc('trap', 'TELEPORT_TO', 'teleports target to trap setter')
newFieldDesc('trap_pval', 'MULTI_SHOT', 'shots per trigger')
newFieldDesc('trap_pval_x10', 'CONCEAL', 'difficulty to detect/disarm')
newFieldDesc('trap_trigger', 'DRAGON', 'dragons')
newFieldDesc('trap_trigger', 'DEMON', 'demons')
newFieldDesc('trap_trigger', 'UNDEAD', 'undead')
newFieldDesc('trap_trigger', 'ANIMAL', 'animals')
newFieldDesc('trap_trigger', 'EVIL', 'evil beings')

newFieldDesc('rod', 'CAPACITY', '#LIGHT_GREEN#+100%#LAST# capacity')
newFieldDesc('rod', 'CHARGING', '#LIGHT_GREEN#+1#LAST# recharge/turn')
newFieldDesc('rod', 'CHEAPNESS', '#LIGHT_GREEN#-50%#LAST# power cost')
newFieldDesc('rod', 'FAST_CAST', '#LIGHT_GREEN#+100%#LAST# use speed')
newFieldDesc('rod', 'EASY_USE', 'easy use')

-- CURSED and HEAVY_CURSE are not included here; they're covered by the
-- object's 'cursed' field.
newFieldDesc('curse', 'PERMA_CURSE', 'permanently cursed')
newFieldDesc('curse', 'AUTO_CURSE', 'can re-curse itself')
newFieldDesc('curse', 'TY_CURSE', 'ancient foul curse')
newFieldDesc('curse', 'DG_CURSE', 'ancient Morgothian curse')
newFieldDesc('curse', 'CURSE_NO_DROP', 'cannot be dropped while cursed')
newFieldDesc('curse', 'CLONE', 'may clone monsters on hit')

newFieldDesc('one_liners', 'IMPACT', '#{bold}#On attack while worn:#{normal}#  earthquakes (1/7 chance)')
newFieldDesc('one_liners', 'BLESSED', 'Can be wielded by Eru followers without penalty')
newFieldDesc('one_liners', 'NEVER_BLOW', 'Cannot attack with this weapon')
newFieldDesc('one_liners', 'RES_MORGUL', 'Resists shattering when striking Morgul creatures')
newFieldDesc('one_liners', 'KILL_GHOST', 'Can be triggered by immaterial creatures')
