-- $Id: bree-house.lua 1900 2015-11-20 00:30:52Z dsb $
-- ToME - Tales of Middle-Earth
-- Copyright (C) 2012 Scott Bigham
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Scott Bigham "Zizzo"
-- dsb-tome@killerbbunnies.org

id = 'bree-house'
name = 'Thieves!'
danger_level = 5	-- cf. src.tables.c line 3707
desc = function(self, who)
  if self:isEnded() then
    return [[You have slain the thieves terrorizing Bree, and as a reward the Mayor has given you their abandoned hideout to use as a house.]]
  elseif self:isCompleted() then
    return [[You have slain the thieves terrorizing Bree.  You should probably go back to the Mayor's office and tell them.]]
  else
    return [[Thieves are terrorizing Bree!  You must break into their lair and slay them.]]
  end
end

on_status_change = function(self, who, status, sub)
  if self:isEnded() then
    -- Decide the next quest:  Trolls or Wights.  10% probability of a coin
    -- flip between the two, otherwise give the Trolls quest if Combat is
    -- higher or Wights if not.
    if rng.chance(10) then
      self.next_quest = rng.chance(2) and 'jump_troll' or 'jump_wight'
    elseif who:getSkillLevel('COMBAT') > who:getSkillLevel('MAGIC') then
      self.next_quest = 'jump_troll'
    else
      self.next_quest = 'jump_wight'
    end
  end
end

kill_quest_mon = function(self)
  for _, e in pairs(game.level.entities) do
    -- If any of the badguys are still alive, punt.
    if e.quest_mon and not e.dead then return end
  end
  -- Yay!
  game.log("#YELLOW#The magic hiding the stairs is now gone.#LAST#")
  local spot = game.level:pickSpot{ type='quest', subtype='exit' }
  local Map = require 'mod.class.Map'
  game.level.map(spot.x, spot.y, Map.TERRAIN, game.zone.grid_list.EXIT_BREE_HOUSE_QUEST)
  game.player:setQuestStatus('bree-house', engine.Quest.COMPLETED)
end
