-- $Id: bree-wights.lua 2379 2016-05-01 23:30:38Z dsb $
-- ToME - Tales of Middle-Earth
-- Copyright (C) 2016 Scott Bigham
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Scott Bigham "Zizzo"
-- dsb-tome@killerbbunnies.org

id = 'bree-wights'
name = 'The Wight Grave'
danger_level = 30	-- cf. src/tables.c line 3846
desc = function(self, who)
  if self:isEnded() then
    return [[You have slain the Wight-King of the Barrow-downs and taken the rag that it wore.  Mayor Will Whitfoot thanks you and has asked you to take the rag somewhere other than his office.]]
  elseif self:isCompleted() then
    return [[You have slain the Wight-King of the Barrow-downs and taken the rag that it wore.  You should go back to the Mayor's office and tell the mayor.]]
  else
    return [[You must slay the undead lurking near Bree.  Reports say the are coming from somewhere near the entrance to the Barrow-downs.]]
  end
end

kill_quest_mon = function(self)
  -- Killed the Wight King.
  game.log("#YELLOW#WIthout their king, the wights won't be able to do much.#LAST#")
  local spot = game.level:pickSpot{ type='wight-quest', subtype='exit' }
  local Map = require 'mod.class.Map'
  game.level.map(spot.x, spot.y, Map.TERRAIN, game.zone.grid_list.EXIT_BREE_WIGHT_QUEST)
  game.player:setQuestStatus('bree-wights', engine.Quest.COMPLETED)
end
