-- $Id: morgoth.lua 1841 2015-10-31 20:37:01Z dsb $
-- ToME - Tales of Middle-Earth
-- Copyright (C) 2012 Scott Bigham
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Scott Bigham "Zizzo"
-- dsb-tome@killerbbunnies.org

add_hooks = function()
  class:bindHook('CharacterSheet:dumpLine', function(self, data)
    local line = nil
    if game.player:isQuestStatus('morgoth', engine.Quest.DONE) then
      if game.player:isQuestStatus('one-ring', engine.Quest.FAILED) then
	line = 'You became a new force of darkness and enslaved all free people.'
      elseif game.player:isQuestStatus('one-ring', engine.Quest.DONE) then
	local Birther = require 'engine.Birther'
	local d = Birther:getBirthdescriptor('sex', game.player.descriptor.sex)
	line = ('You saved Arta and became a famed %s'):format(d.winner_title)
      end
    end
    if line then table.insert(data.lines, line) end
  end)
end

id = 'morgoth'
name = 'Morgoth'
danger_level = 100	-- cf. src/tables.c line 3695
desc = function(self, who)
  if self:isEnded() then
    if who:isQuestStatus('sauron', engine.Quest.FAILED) then
      return [[You have slain Morgoth, Lord of Darkness.  Corrupted by Sauron's One Ring, you absorbed the nether mists of Morgoth's power and became the new tyrant of Arda.]]
    else
      return [[You have slain Morgoth, Lord of Darkness, freeing Arda from his fell rule.]]
    end
  else
    return [[Your final quest is the ultimate quest that has always been required of you:  you must descend into the depths of Angband and defeat Morgoth, Lord of Darkness.]]
  end
end
