-- $Id: cave_vault.lua 2452 2016-08-07 23:30:36Z dsb $
-- ToME - Tales of Middle-Earth
-- Copyright (C) 2016 Scott Bigham
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Scott Bigham "Zizzo"
-- dsb-tome@killerbbunnies.org

-- Roughly mimics build_cave_vault() in src/generate.c, to build a fractal
-- cave vault as a subtype of the 'random_vault' room type (q.v.).
newRoom {
  id = 'cave_vault',
  no_random_gen = true,
  build_special = function(self, gen, ctr, xsize, ysize)
    -- ROund to make sizes even.
    local xhsize, yhsize = math.floor(xsize/2), math.floor(ysize/2)
    xsize, ysize = xhsize*2, yhsize*2

    while not done do
      -- *sigh* I wish Lua had a << operator...
      local grd = util.lshift(1, rng.range(0, 3))
      -- Want an average of about 16.
      local roug = rng.range(1, 8) * rng.range(1, 4)
      -- About size/2
      local cutoff = rng.range(1, math.floor(xsize/4)) +
		     rng.range(1, math.floor(ysize/4)) +
		     rng.range(1, math.floor(xsize/4)) +
		     rng.range(1, math.floor(ysize/4))

      local hmap = gen.generate_hmap(ctr.x, ctr.y, xsize, ysize, grd, roug, cutoff)
      done = gen:generate_fracave(ctr.x, ctr.y, xsize, ysize, hmap, cutoff, false, true)
    end

    -- Set vault flag
    for x = ctr.x - xhsize, ctr.x + xhsize do
      for y = ctr.y - yhsize, ctr.y + yhsize do
	gen.map.attrs(x, y, 'vault', true)
      end
    end

    -- Fill with monsters and treasure, low difficulty
    gen:fill_treasure(ctr.x - xhsize + 1, ctr.y - yhsize + 1, ctr.x - xhsize + xsize - 1, ctr.y - yhsize + ysize - 1, rng.range(1, 5))
    return true
  end,
}

