-- $Id: combat.lua 2709 2017-01-22 02:31:27Z dsb $
-- ToME - Tales of Middle-Earth
-- Copyright © 2012-2017 Scott Bigham
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Scott Bigham "Zizzo"
-- dsb-tome@killerbbunnies.org

-- -----------------------------------------------------------------------
-- WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING
-- -----------------------------------------------------------------------
-- This file was generated automatically by the 'gen_skill' Perl script.
-- DO NOT MODIFY THIS FILE DIRECTLY, as any changes will be lost the next
-- time the file is generated (with the possible exception of lines between
-- 'BEGIN VERBATIM' and 'END VERBATIM' markers, if supported by the script).
-- -----------------------------------------------------------------------
-- WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING
-- -----------------------------------------------------------------------

-- Player skills generated from s_info.txt.

-- BEGIN VERBATIM
local function wpn_skill(p, skill, sub)
  local wpns = p:getInven('MAIN_HAND')
  if #wpns == 0 then return end
  for _, wpn in ipairs(wpns) do
    if wpn.subtype ~= sub then return end
  end
  -- All wielded weapons are of the appropriate type; apply bonuses.
  local sk = p:getSkillLevel(skill)
  local orig_to_h_melee = p.to_h_melee
  p.to_h_melee = p.to_h_melee + sk
  p.to_d_melee = p.to_d_melee + math.floor(sk/2)
  print(('[SKILL] %s(%d):  to_h_melee %d -> %d'):format(skill, sk, orig_to_h_melee, p.to_h_melee))
end

local function archery_skill(p, skill, shooter_sub, ammo_sub)
  local shooters = p:getInven('LAUNCHER')
  if #shooters == 0 then return end
  if shooters[1].subtype ~= shooter_sub then return end
  local sk = p:getSkillLevel(skill)
  local orig_to_h_ranged = p.to_h_ranged
  p.to_h_ranged = p.to_h_ranged + p:getSkillLevel(skill, 25)
  print(('[SKILL] %s(%d):  to_h_ranged %d -> %d'):format(skill, sk, orig_to_h_ranged, p.to_h_ranged))
  if skill ~= 'BOOMERANG_MASTERY' then
    local ammo = p:getInven('QUIVER')
    p.extra_shots = p.extra_shots + math.floor(sk/16)
    p.extra_might = p.extra_might + math.floor(sk/25)
    if #ammo > 0 and ammo[1].subtype == ammo_sub and sk >= 30 then
      p.extra_might = p.extra_might + 1
    end
  end
end
-- END VERBATIM

newSkill {
  name = 'Combat',
  short_name = 'COMBAT',
  desc = [[General ability to fight and to pseudo-id armour and weapons.  It also allows the use of heavier armour without penalties.]],
  rate = 1000,
  depth = 0,
  achievement = 'COMBAT_50',
  random_gain = 100,
  -- BEGIN VERBATIM
  player_calc = function(p, init)
    if init then
      p.to_h, p.to_h_melee, p.to_d, p.to_d_melee = 0, 0, 0, 0
      p.dis_to_h, p.dis_to_d = 0, 0
      p.skill_fighting = 0
      return
    end
    local sk_c = p:getSkillLevel('COMBAT')
    local sk_m = p:getSkillLevel(p:getSkillForMeleeStyle())
    local orig_skill_fighting = p.skill_fighting
    p.skill_fighting = 5*math.floor((7*sk_m + 3*sk_c)/10)
    print(('[SKILL] Combat.player_calc:  %d Combat, %d %s -> skill_fighting 5*(7*%d+3*%d) = %d'):format(sk_c, sk_m, p:getSkillForMeleeStyle(), sk_m, sk_c, p.skill_fighting))
    p:adjustDis('to_d', p:getSkillLevel('COMBAT', 10), true)
  end,
  -- END VERBATIM
}

newSkill {
  name = 'Weaponmastery',
  short_name = 'WEAPONMASTERY',
  desc = [[General ability to use melee weapons.]],
  rate = 1000,
  depth = 1,
  achievement = 'WEAPONMASTERY_50',
  parent = 'COMBAT',
  ripple_to = {
    COMBAT = 50,
  },
  random_gain = 100,
}

newSkill {
  name = 'Sword-mastery',
  short_name = 'SWORD_MASTERY',
  desc = [[Ability to use swords.]],
  rate = 1000,
  depth = 2,
  achievement = 'SWORD_MASTERY_50',
  parent = 'WEAPONMASTERY',
  ripple_to = {
    WEAPONMASTERY = 25,
    COMBAT = 7,
  },
  -- BEGIN VERBATIM
  player_calc = function(p, init)
    if not init then wpn_skill(p, 'SWORD_MASTERY', 'sword') end
  end,
  -- END VERBATIM
}

newSkill {
  name = 'Critical-hits',
  short_name = 'CRITICAL_HITS',
  desc = [[Ability to deal critical hits with swords < 5lb.]],
  rate = 1000,
  depth = 3,
  achievement = 'CRITICAL_HITS_50',
  parent = 'SWORD_MASTERY',
  ripple_to = {
    SWORD_MASTERY = 5,
  },
}

newSkill {
  name = 'Axe-mastery',
  short_name = 'AXE_MASTERY',
  desc = [[Ability to use axes.]],
  rate = 1000,
  depth = 2,
  achievement = 'AXE_MASTERY_50',
  parent = 'WEAPONMASTERY',
  ripple_to = {
    WEAPONMASTERY = 25,
    COMBAT = 7,
  },
  -- BEGIN VERBATIM
  player_calc = function(p, init)
    if not init then wpn_skill(p, 'AXE_MASTERY', 'axe') end
  end,
  -- END VERBATIM
}

newSkill {
  name = 'Hafted-mastery',
  short_name = 'HAFTED_MASTERY',
  desc = [[Ability to use hafted weapons.]],
  rate = 1000,
  depth = 2,
  achievement = 'HAFTED_MASTERY_50',
  parent = 'WEAPONMASTERY',
  ripple_to = {
    WEAPONMASTERY = 25,
    COMBAT = 7,
  },
  -- BEGIN VERBATIM
  player_calc = function(p, init)
    if not init then wpn_skill(p, 'HAFTED_MASTERY', 'hafted') end
  end,
  -- END VERBATIM
}

newSkill {
  name = 'Stunning-blows',
  short_name = 'STUNNING_BLOWS',
  desc = [[Ability to stun opponents when doing critical hits with hafted weapons > 5 lb.]],
  rate = 1000,
  depth = 3,
  achievement = 'STUNNING_BLOWS_50',
  parent = 'HAFTED_MASTERY',
  ripple_to = {
    HAFTED_MASTERY = 5,
  },
}

newSkill {
  name = 'Polearm-mastery',
  short_name = 'POLEARM_MASTERY',
  desc = [[Ability to use polearms.]],
  rate = 1000,
  depth = 2,
  achievement = 'POLEARM_MASTERY_50',
  parent = 'WEAPONMASTERY',
  ripple_to = {
    WEAPONMASTERY = 25,
    COMBAT = 7,
  },
  -- BEGIN VERBATIM
  player_calc = function(p, init)
    if not init then wpn_skill(p, 'POLEARM_MASTERY', 'polearm') end
  end,
  -- END VERBATIM
}

newSkill {
  name = 'Archery',
  short_name = 'ARCHERY',
  desc = [[General ability to use ranged weapons.]],
  rate = 1000,
  depth = 1,
  achievement = 'ARCHERY_50',
  parent = 'COMBAT',
  ripple_to = {
    COMBAT = 50,
  },
  random_gain = 100,
  -- BEGIN VERBATIM
  talents = {
    [ActorTalents.T_FORGE_SHOTS] = { level = 1, ability = 'AMMO_CREATION' },
    [ActorTalents.T_FORGE_ARROWS] = { level = 10, ability = 'AMMO_CREATION' },
    [ActorTalents.T_FORGE_BOLTS] = { level = 20, ability = 'AMMO_CREATION' },
    ActorTalents.T_FORGE_SHOTS, ActorTalents.T_FORGE_ARROWS, ActorTalents.T_FORGE_BOLTS,
  },
  player_calc = function(p, init)
    if init then
      p.to_h_ranged, p.to_d_ranged = 0, 0
      p.skill_archery = 0
      return
    end
    local sk_a = p:getSkillLevel('ARCHERY')
    local sk_c = p:getSkillLevel('COMBAT')
    local orig_skill_archery = p.skill_archery
    p.skill_archery = math.floor(5*(7*sk_a + 3*sk_c)/10)
    print(('[SKILL] ARCHERY(%d):  [+%d COMBAT] skill_archery %d -> %d'):format(sk_a, sk_c, orig_skill_archery, p.skill_archery))
  end,
  -- END VERBATIM
}

newSkill {
  name = 'Sling-mastery',
  short_name = 'SLING_MASTERY',
  desc = [[Ability to use slings.]],
  rate = 1000,
  depth = 2,
  achievement = 'SLING_MASTERY_50',
  parent = 'ARCHERY',
  talents = {
    [ActorTalents.T_PIERCING_SHOTS] = 26,
    ActorTalents.T_PIERCING_SHOTS,
  },
  ripple_to = {
    ARCHERY = 25,
    COMBAT = 7,
  },
  -- BEGIN VERBATIM
  player_calc = function(p, init)
    if not init then archery_skill(p, 'SLING_MASTERY', 'sling', 'shots') end
  end,
  -- END VERBATIM
}

newSkill {
  name = 'Bow-mastery',
  short_name = 'BOW_MASTERY',
  desc = [[Ability to use bows.]],
  rate = 1000,
  depth = 2,
  achievement = 'BOW_MASTERY_50',
  parent = 'ARCHERY',
  talents = {
    [ActorTalents.T_PIERCING_SHOTS] = 26,
    ActorTalents.T_PIERCING_SHOTS,
  },
  ripple_to = {
    ARCHERY = 25,
    COMBAT = 7,
  },
  -- BEGIN VERBATIM
  player_calc = function(p, init)
    if not init then archery_skill(p, 'BOW_MASTERY', 'bow', 'arrows') end
  end,
  -- END VERBATIM
}

newSkill {
  name = 'Crossbow-mastery',
  short_name = 'CROSSBOW_MASTERY',
  desc = [[Ability to use crossbows.]],
  rate = 1000,
  depth = 2,
  achievement = 'CROSSBOW_MASTERY_50',
  parent = 'ARCHERY',
  talents = {
    [ActorTalents.T_PIERCING_SHOTS] = 26,
    ActorTalents.T_PIERCING_SHOTS,
  },
  ripple_to = {
    ARCHERY = 25,
    COMBAT = 7,
  },
  -- BEGIN VERBATIM
  player_calc = function(p, init)
    if not init then archery_skill(p, 'CROSSBOW_MASTERY', 'crossbow', 'bolts') end
  end,
  -- END VERBATIM
}

newSkill {
  name = 'Boomerang-mastery',
  short_name = 'BOOMERANG_MASTERY',
  desc = [[Ability to use boomerangs.]],
  rate = 1000,
  depth = 2,
  achievement = 'BOOMERANG_MASTERY_50',
  parent = 'ARCHERY',
  ripple_to = {
    ARCHERY = 25,
    COMBAT = 7,
  },
  -- BEGIN VERBATIM
  player_calc = function(p, init)
    if not init then archery_skill(p, 'BOOMERANG_MASTERY', 'boomerang') end
  end,
  -- END VERBATIM
}

newSkill {
  name = 'Barehand-combat',
  short_name = 'BAREHAND_COMBAT',
  desc = [[Ability to fight barehanded.]],
  rate = 1000,
  depth = 1,
  achievement = 'BAREHAND_COMBAT_50',
  parent = 'COMBAT',
  talents = {
    [ActorTalents.T_MELEE_STYLE] = true,
    ActorTalents.T_MELEE_STYLE,
  },
  ripple_to = {
    COMBAT = 50,
  },
  random_gain = 70,
}

newSkill {
  name = 'Bearform-combat',
  short_name = 'BEARFORM_COMBAT',
  desc = [[Ability to fight in bear form.]],
  rate = 1000,
  depth = 1,
  achievement = 'BEARFORM_COMBAT_50',
  parent = 'COMBAT',
  talents = {
    [ActorTalents.T_MELEE_STYLE] = true,
    ActorTalents.T_MELEE_STYLE,
  },
  -- BEGIN VERBATIM
  visible = function()
    local p = game.player
    return p and p.inBearForm and p:inBearForm()
  end,
  -- END VERBATIM
}

newSkill {
  name = 'Boulder-throwing',
  short_name = 'BOULDER_THROWING',
  desc = [[Ability to make and throw boulders.]],
  rate = 1000,
  depth = 1,
  achievement = 'BOULDER_THROWING_50',
  parent = 'COMBAT',
  talents = {
    [ActorTalents.T_CREATE_BOULDERS] = true,
    ActorTalents.T_CREATE_BOULDERS,
  },
  ripple_to = {
    COMBAT = 40,
  },
}

newSkill {
  name = 'Antimagic',
  short_name = 'ANTIMAGIC',
  desc = [[Ability to generate an antimagic field.]],
  rate = 1000,
  depth = 1,
  achievement = 'ANTIMAGIC_50',
  parent = 'COMBAT',
  talents = {
    [ActorTalents.T_ANTI_TELE_JAM] = 20,
    [ActorTalents.T_ANTI_DET_TRAP] = 25,
    ActorTalents.T_ANTI_TELE_JAM, ActorTalents.T_ANTI_DET_TRAP,
  },
  random_gain = 80,
  exclude = { 'MAGIC_DEVICE', 'MANA', 'GEOMANCY', 'FIRE', 'AIR', 'WATER', 'EARTH', 'CONVEYANCE', 'DIVINATION', 'TEMPORAL', 'META', 'MIND', 'NATURE', 'UDUN', 'SORCERY', 'DEMONOLOGY', 'RUNECRAFT', 'NECROMANCY', 'MINDCRAFT', 'MUSIC', 'PRAYER', 'DRUIDISTIC', 'THAUMATURGY' },
  -- BEGIN VERBATIM
  player_calc = function(p, init)
    if not init then
      p.antimagic = p.antimagic + p:getSkillLevel('ANTIMAGIC')
      p.antimagic_rad = p.antimagic_rad + p:getSkillLevel('ANTIMAGIC', 10) + 1
    end
  end
  -- END VERBATIM
}
