-- $Id: spirituality.lua 2379 2016-05-01 23:30:38Z dsb $
-- ToME - Tales of Middle-Earth
-- Copyright © 2012-2016 Scott Bigham
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Scott Bigham "Zizzo"
-- dsb-tome@killerbbunnies.org

-- -----------------------------------------------------------------------
-- WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING
-- -----------------------------------------------------------------------
-- This file was generated automatically by the 'gen_skill' Perl script.
-- DO NOT MODIFY THIS FILE DIRECTLY, as any changes will be lost the next
-- time the file is generated (with the possible exception of lines between
-- 'BEGIN VERBATIM' and 'END VERBATIM' markers, if supported by the script).
-- -----------------------------------------------------------------------
-- WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING
-- -----------------------------------------------------------------------

-- Player skills generated from s_info.txt.

newSkill {
  name = 'Spirituality',
  short_name = 'SPIRITUALITY',
  desc = [[General ability to use spiritual skills and also influence your Saving Throw.]],
  rate = 1000,
  depth = 0,
  achievement = 'SPIRITUALITY_50',
  random_gain = 100,
  -- BEGIN VERBATIM
  player_calc = function(p, init)
    if init then
      p.saving_throw = 0
      return
    end
    p.saving_throw = p.saving_throw + p:getSkillLevel('SPIRITUALITY', 75) +
				      p:getStatRelated('wis_save')
  end,
  -- END VERBATIM
}

newSkill {
  name = 'Prayer',
  short_name = 'PRAYER',
  desc = [[Ability to learn and use spells from the gods' schools.  Spells use the wisdom stat and cost piety instead of mana.]],
  rate = 1000,
  depth = 1,
  achievement = 'PRAYER_50',
  parent = 'SPIRITUALITY',
  ripple_to = {
    SPIRITUALITY = 10,
    MAGIC = 10,
  },
}

newSkill {
  name = 'Mindcraft',
  short_name = 'MINDCRAFT',
  desc = [[Ability to focus the powers of the mind.  Mindpowers use the wisdom stat.]],
  rate = 1000,
  depth = 1,
  achievement = 'MINDCRAFT_50',
  parent = 'SPIRITUALITY',
  talents = {
    [ActorTalents.T_MIND_PRECOG] = 1,
    [ActorTalents.T_MIND_NEURAL] = 2,
    [ActorTalents.T_MIND_MINOR_TELE] = 3,
    [ActorTalents.T_MIND_MAJOR_TELE] = 7,
    [ActorTalents.T_MIND_DOMINATE] = 9,
    [ActorTalents.T_MIND_PULVERIZE] = 11,
    [ActorTalents.T_MIND_ARMOR] = 13,
    [ActorTalents.T_MIND_IDENTIFY] = 15,
    [ActorTalents.T_MIND_WAVE] = 18,
    [ActorTalents.T_MIND_SPEED] = 23,
    [ActorTalents.T_MIND_DRAIN] = 25,
    [ActorTalents.T_MIND_TK_WAVE] = 28,
    ActorTalents.T_MIND_PRECOG, ActorTalents.T_MIND_NEURAL, ActorTalents.T_MIND_MINOR_TELE, ActorTalents.T_MIND_MAJOR_TELE, ActorTalents.T_MIND_DOMINATE, ActorTalents.T_MIND_PULVERIZE, ActorTalents.T_MIND_ARMOR, ActorTalents.T_MIND_IDENTIFY, ActorTalents.T_MIND_WAVE, ActorTalents.T_MIND_SPEED, ActorTalents.T_MIND_DRAIN, ActorTalents.T_MIND_TK_WAVE,
  },
  ripple_to = {
    SPIRITUALITY = 10,
    MAGIC = 10,
  },
  random_gain = 50,
  -- BEGIN VERBATIM
  convey_at_level = {
    [40] = { esp_flags = { ALL=true } },
  },
  -- END VERBATIM
}

newSkill {
  name = 'Music',
  short_name = 'MUSIC',
  desc = [[Ability to learn and sing songs.  Songs use the charisma stat.]],
  rate = 1000,
  depth = 1,
  achievement = 'MUSIC_50',
  parent = 'SPIRITUALITY',
  ripple_to = {
    SPIRITUALITY = 10,
    MAGIC = 10,
  },
}
