-- $Id: breaths.lua 2379 2016-05-01 23:30:38Z dsb $
-- ToME - Tales of Middle-Earth
-- Copyright (C) 2012 Scott Bigham
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Scott Bigham "Zizzo"
-- dsb-tome@killerbbunnies.org

local Entity = require 'engine.Entity'

newTalentType {
  name = 'NPC breaths',
  type = 'npc/breath',
  description = 'Monster breath weapons',
}

newTalent {
  name = 'Breathe Acid',
  short_name = 'NPC_BR_ACID',
  display_entity = Entity.new { image = 'talents/npc_breathe.png' },
  type = 'npc/breath',
  mode = 'activated',
  points = 0,
  player = { mana=10 },
  range = 18,
  requires_target = true,
  direct_hit = true,
  innate = true,	-- cf. spell.fail_prob()
  action = spell.npc.breathe,
  info = spell.npc.breath_info,
  message = "@Source@ breathes acid.",
  params = { type = DamageType.ACID, div = 3, max = 1600 },
}

newTalent {
  name = 'Breathe Lightning',
  short_name = 'NPC_BR_ELEC',
  display_entity = Entity.new { image = 'talents/npc_breathe.png' },
  type = 'npc/breath',
  mode = 'activated',
  points = 0,
  player = { mana=10 },
  range = 18,
  requires_target = true,
  direct_hit = true,
  innate = true,	-- cf. spell.fail_prob()
  action = spell.npc.breathe,
  info = spell.npc.breath_info,
  message = "@Source@ breathes lightning.",
  params = { type = DamageType.ELEC, div = 3, max = 1600 },
}

newTalent {
  name = 'Breathe Fire',
  short_name = 'NPC_BR_FIRE',
  display_entity = Entity.new { image = 'talents/npc_breathe.png' },
  type = 'npc/breath',
  mode = 'activated',
  points = 0,
  player = { mana=10 },
  range = 18,
  requires_target = true,
  direct_hit = true,
  innate = true,	-- cf. spell.fail_prob()
  action = spell.npc.breathe,
  info = spell.npc.breath_info,
  message = "@Source@ breathes fire.",
  params = { type = DamageType.FIRE, div = 3, max = 1600 },
}

newTalent {
  name = 'Breathe Cold',
  short_name = 'NPC_BR_COLD',
  display_entity = Entity.new { image = 'talents/npc_breathe.png' },
  type = 'npc/breath',
  mode = 'activated',
  points = 0,
  player = { mana=10 },
  range = 18,
  requires_target = true,
  direct_hit = true,
  innate = true,	-- cf. spell.fail_prob()
  action = spell.npc.breathe,
  info = spell.npc.breath_info,
  message = "@Source@ breathes frost.",
  params = { type = DamageType.COLD, desc = 'frost', div = 3, max = 1600 },
}

newTalent {
  name = 'Breathe Poison',
  short_name = 'NPC_BR_POIS',
  display_entity = Entity.new { image = 'talents/npc_breathe.png' },
  type = 'npc/breath',
  mode = 'activated',
  points = 0,
  player = { mana=15, major=true },
  range = 18,
  requires_target = true,
  direct_hit = true,
  innate = true,	-- cf. spell.fail_prob()
  action = spell.npc.breathe,
  info = spell.npc.breath_info,
  message = "@Source@ breathes gas.",
  params = { type = DamageType.POISON, desc = 'gas', div = 3, max = 800 },
}

newTalent {
  name = 'Breathe Nether',
  short_name = 'NPC_BR_NETH',
  display_entity = Entity.new { image = 'talents/npc_breathe.png' },
  type = 'npc/breath',
  mode = 'activated',
  points = 0,
  player = { mana=30, major=true },
  range = 18,
  requires_target = true,
  direct_hit = true,
  innate = true,	-- cf. spell.fail_prob()
  action = spell.npc.breathe,
  info = spell.npc.breath_info,
  message = "@Source@ breathes nether.",
  params = { type = DamageType.NETHER, div = 6, max = 550 },
}

newTalent {
  name = 'Breathe Light',
  short_name = 'NPC_BR_LITE',
  display_entity = Entity.new { image = 'talents/npc_breathe.png' },
  type = 'npc/breath',
  mode = 'activated',
  points = 0,
  player = { mana=20, major=true },
  range = 18,
  requires_target = true,
  direct_hit = true,
  innate = true,	-- cf. spell.fail_prob()
  action = spell.npc.breathe,
  info = spell.npc.breath_info,
  message = "@Source@ breathes light.",
  params = { type = DamageType.LITE, div = 6, max = 400 },
}

newTalent {
  name = 'Breathe Dark',
  short_name = 'NPC_BR_DARK',
  display_entity = Entity.new { image = 'talents/npc_breathe.png' },
  type = 'npc/breath',
  mode = 'activated',
  points = 0,
  player = { mana=20, major=true },
  range = 18,
  requires_target = true,
  direct_hit = true,
  innate = true,	-- cf. spell.fail_prob()
  action = spell.npc.breathe,
  info = spell.npc.breath_info,
  message = "@Source@ breathes darkness.",
  params = { type = DamageType.DARK, desc = 'darkness', div = 6, max = 400 },
}

newTalent {
  name = 'Breathe Confusion',
  short_name = 'NPC_BR_CONF',
  display_entity = Entity.new { image = 'talents/npc_breathe.png' },
  type = 'npc/breath',
  mode = 'activated',
  points = 0,
  player = { mana=15, major=true },
  range = 18,
  requires_target = true,
  direct_hit = true,
  innate = true,	-- cf. spell.fail_prob()
  action = spell.npc.breathe,
  info = spell.npc.breath_info,
  message = "@Source@ breathes confusion.",
  params = { type = DamageType.CONFUSION, div = 6, max = 400 },
}

newTalent {
  name = 'Breathe Sound',
  short_name = 'NPC_BR_SOUN',
  display_entity = Entity.new { image = 'talents/npc_breathe.png' },
  type = 'npc/breath',
  mode = 'activated',
  points = 0,
  player = { mana=30, major=true },
  range = 18,
  requires_target = true,
  direct_hit = true,
  innate = true,	-- cf. spell.fail_prob()
  action = spell.npc.breathe,
  info = spell.npc.breath_info,
  message = "@Source@ breathes sound.",
  params = { type = DamageType.SOUND, div = 6, max = 400 },
}

newTalent {
  name = 'Breathe Chaos',
  short_name = 'NPC_BR_CHAO',
  display_entity = Entity.new { image = 'talents/npc_breathe.png' },
  type = 'npc/breath',
  mode = 'activated',
  points = 0,
  player = { mana=30, major=true },
  range = 18,
  requires_target = true,
  direct_hit = true,
  innate = true,	-- cf. spell.fail_prob()
  action = spell.npc.breathe,
  info = spell.npc.breath_info,
  message = "@Source@ breathes chaos.",
  params = { type = DamageType.CHAOS, div = 6, max = 600 },
}

newTalent {
  name = 'Breathe Disenchantment',
  short_name = 'NPC_BR_DISE',
  display_entity = Entity.new { image = 'talents/npc_breathe.png' },
  type = 'npc/breath',
  mode = 'activated',
  points = 0,
  player = { mana=30, major=true },
  range = 18,
  requires_target = true,
  direct_hit = true,
  innate = true,	-- cf. spell.fail_prob()
  action = spell.npc.breathe,
  info = spell.npc.breath_info,
  message = "@Source@ breathes disenchantment.",
  params = { type = DamageType.DISENCHANT, desc = 'disenchantment', div = 6, max = 500 },
}

newTalent {
  name = 'Breathe Nexus',
  short_name = 'NPC_BR_NEXU',
  display_entity = Entity.new { image = 'talents/npc_breathe.png' },
  type = 'npc/breath',
  mode = 'activated',
  points = 0,
  player = { mana=30, major=true },
  range = 18,
  requires_target = true,
  direct_hit = true,
  innate = true,	-- cf. spell.fail_prob()
  action = spell.npc.breathe,
  info = spell.npc.breath_info,
  message = "@Source@ breathes nexus.",
  params = { type = DamageType.NEXUS, div = 3, max = 250 },
}

newTalent {
  name = 'Breathe Time',
  short_name = 'NPC_BR_TIME',
  display_entity = Entity.new { image = 'talents/npc_breathe.png' },
  type = 'npc/breath',
  mode = 'activated',
  points = 0,
  player = { mana=30, major=true },
  range = 18,
  requires_target = true,
  direct_hit = true,
  innate = true,	-- cf. spell.fail_prob()
  action = spell.npc.breathe,
  info = spell.npc.breath_info,
  message = "@Source@ breathes time.",
  params = { type = DamageType.TIME, div = 3, max = 150 },
}

newTalent {
  name = 'Breathe Inertia',
  short_name = 'NPC_BR_INER',
  display_entity = Entity.new { image = 'talents/npc_breathe.png' },
  type = 'npc/breath',
  mode = 'activated',
  points = 0,
  player = { mana=30, major=true },
  range = 18,
  requires_target = true,
  direct_hit = true,
  innate = true,	-- cf. spell.fail_prob()
  action = spell.npc.breathe,
  info = spell.npc.breath_info,
  message = "@Source@ breathes inertia.",
  params = { type = DamageType.INERTIA, div = 6, max = 200 },
}

newTalent {
  name = 'Breathe Gravity',
  short_name = 'NPC_BR_GRAV',
  display_entity = Entity.new { image = 'talents/npc_breathe.png' },
  type = 'npc/breath',
  mode = 'activated',
  points = 0,
  player = { mana=30, major=true },
  range = 18,
  requires_target = true,
  direct_hit = true,
  innate = true,	-- cf. spell.fail_prob()
  action = spell.npc.breathe,
  info = spell.npc.breath_info,
  message = "@Source@ breathes gravity.",
  params = { type = DamageType.GRAVITY, div = 3, max = 200 },
}

newTalent {
  name = 'Breathe Shards',
  short_name = 'NPC_BR_SHAR',
  display_entity = Entity.new { image = 'talents/npc_breathe.png' },
  type = 'npc/breath',
  mode = 'activated',
  points = 0,
  player = { mana=30, major=true },
  range = 18,
  requires_target = true,
  direct_hit = true,
  innate = true,	-- cf. spell.fail_prob()
  action = spell.npc.breathe,
  info = spell.npc.breath_info,
  message = "@Source@ breathes shards.",
  params = { type = DamageType.SHARDS, div = 6, max = 400 },
}

newTalent {
  name = 'Breathe Plasma',
  short_name = 'NPC_BR_PLAS',
  display_entity = Entity.new { image = 'talents/npc_breathe.png' },
  type = 'npc/breath',
  mode = 'activated',
  points = 0,
  player = { mana=30, major=true },
  range = 18,
  requires_target = true,
  direct_hit = true,
  innate = true,	-- cf. spell.fail_prob()
  action = spell.npc.breathe,
  info = spell.npc.breath_info,
  message = "@Source@ breathes plasma.",
  params = { type = DamageType.PLASMA, div = 6, max = 150 },
}

newTalent {
  name = 'Breathe Force',
  short_name = 'NPC_BR_WALL',
  display_entity = Entity.new { image = 'talents/npc_breathe.png' },
  type = 'npc/breath',
  mode = 'activated',
  points = 0,
  player = { mana=30, major=true },
  range = 18,
  requires_target = true,
  direct_hit = true,
  innate = true,	-- cf. spell.fail_prob()
  action = spell.npc.breathe,
  info = spell.npc.breath_info,
  message = "@Source@ breathes force.",
  params = { type = DamageType.FORCE, div = 6, max = 200 },
}

newTalent {
  name = 'Breathe Mana',
  short_name = 'NPC_BR_MANA',
  display_entity = Entity.new { image = 'talents/npc_breathe.png' },
  type = 'npc/breath',
  mode = 'activated',
  points = 0,
  player = { mana=40, major=true },
  range = 18,
  requires_target = true,
  direct_hit = true,
  innate = true,	-- cf. spell.fail_prob()
  action = spell.npc.breathe,
  info = spell.npc.breath_info,
  message = "@Source@ breathes magical energy.",
  params = { type = DamageType.MANA, desc = 'magical energy', div = 3, max = 250 },
}

newTalent {
  name = 'Breathe Nuke',
  short_name = 'NPC_BR_NUKE',
  display_entity = Entity.new { image = 'talents/npc_breathe.png' },
  type = 'npc/breath',
  mode = 'activated',
  points = 0,
  player = { mana=40, major=true },
  range = 18,
  requires_target = true,
  direct_hit = true,
  innate = true,	-- cf. spell.fail_prob()
  action = spell.npc.breathe,
  info = spell.npc.breath_info,
  message = "@Source@ breathes toxic waste.",
  params = { type = DamageType.NUKE, desc = 'toxic waste', div = 3, max = 800 },
}

newTalent {
  name = 'Breathe Disintegration',
  short_name = 'NPC_BR_DISI',
  display_entity = Entity.new { image = 'talents/npc_breathe.png' },
  type = 'npc/breath',
  mode = 'activated',
  points = 0,
  player = { mana=40, major=true },
  range = 18,
  requires_target = true,
  direct_hit = true,
  innate = true,	-- cf. spell.fail_prob()
  action = spell.npc.breathe,
  info = spell.npc.breath_info,
  message = "@Source@ breathes disintegration.",
  params = { type = DamageType.DISINTEGRATE, desc='disintegration', div = 3, max = 300 },
}
