-- $Id: alchemy.lua 2134 2016-01-26 02:16:32Z dsb $
-- ToME - Tales of Middle-Earth
-- Copyright (C) 2012 Scott Bigham
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Scott Bigham "Zizzo"
-- dsb-tome@killerbbunnies.org

local Entity = require 'engine.Entity'

newTalentType {
  name = 'Alchemy powers',
  type = 'skill/alchemy',
  description = 'Talents conferred by the Alchemy skill',
}

newTalent {
  name = [[Forge Item]],
  short_name = 'ALCH_FORGE',
  display_entity = Entity.new { image='talents/forge_item.png' },
  type = 'skill/alchemy',
  mode = 'activated',
  points = 0,
  action = function(self, t)
    game.log('Sorry, not implemented (ALCH_FORGE)')
  end,
  info = [[Watch this space]],
}

newTalent {
  name = [[Recharge Item]],
  short_name = 'ALCH_RECHARGE',
  display_entity = Entity.new { image='talents/recharge_item.png' },
  type = 'skill/alchemy',
  mode = 'activated',
  points = 0,
  action = function(self, t)
    game.log('Sorry, not implemented (ALCH_RECHARGE)')
  end,
  info = [[Watch this space]],
}

newTalent {
  name = [[Extract Essences]],
  short_name = 'ALCH_EXTRACT',
  display_entity = Entity.new { image='talents/extract_essences.png' },
  type = 'skill/alchemy',
  mode = 'activated',
  points = 0,
  action = function(self, t)
    game.log('Sorry, not implemented (ALCH_EXTRACT)')
  end,
  info = [[Watch this space]],
}

newTalent {
  name = [[Forge Artifact]],
  short_name = 'ALCH_ARTIFACT',
  display_entity = Entity.new { image='talents/forge_artifact.png' },
  type = 'skill/alchemy',
  mode = 'activated',
  points = 0,
  action = function(self, t)
    game.log('Sorry, not implemented (ALCH_ARTIFACT)')
  end,
  info = [[Watch this space]],
}
