-- $Id: necromancy.lua 2688 2016-12-27 18:04:45Z dsb $
-- ToME - Tales of Middle-Earth
-- Copyright (C) 2012 Scott Bigham
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Scott Bigham "Zizzo"
-- dsb-tome@killerbbunnies.org

local Entity = require 'engine.Entity'

newTalentType {
  name = 'Necromancy powers',
  type = 'skill/necromancy',
  description = 'Talents conferred by the Necromancy skill',
}

newTalent {
  name = [[Horrify]],
  short_name = 'HORRIFY',
  display_entity = Entity.new { image='talents/horrify.png' },
  type = 'skill/necromancy',
  mode = 'activated',
  is_spell = true,
  skill = 'NECROMANCY',
  skill_level = 1, -- TODO fill in later
  mana = 2,
  base_fail = 10,
  stat = 'CON',
  points = 0,
  action = function(self, t)
    game.log('Sorry, not implemented (HORRIFY)')
  end,
  info = [[Watch this space]],
}

newTalent {
  name = [[Raise Dead]],
  short_name = 'RAISE_DEAD',
  display_entity = Entity.new { image='talents/raise_dead.png' },
  type = 'skill/necromancy',
  mode = 'activated',
  is_spell = true,
  skill = 'NECROMANCY',
  skill_level = 5,
  mana = 6,
  base_fail = 20,
  stat = 'CON',
  points = 0,
  action = function(self, t)
    game.log('Sorry, not implemented (RAISE_DEAD)')
  end,
  info = [[Watch this space]],
}

newTalent {
  name = [[Necromantic Teeth]],
  short_name = 'NECRO_TEETH',
  display_entity = Entity.new { image='talents/necromantic_teeth.png' },
  type = 'skill/necromancy',
  mode = 'activated',
  is_spell = true,
  skill = 'NECROMANCY',
  skill_level = 12,
  mana = 20,
  base_fail = 25,
  stat = 'CON',
  points = 0,
  action = function(self, t)
    game.log('Sorry, not implemented (NECRO_TEETH)')
  end,
  info = [[Watch this space]],
}

newTalent {
  name = [[Absorb Soul]],
  short_name = 'ABSORB_SOUL',
  display_entity = Entity.new { image='talents/absorb_soul.png' },
  type = 'skill/necromancy',
  mode = 'activated',
  is_spell = true,
  skill = 'NECROMANCY',
  skill_level = 20,
  mana = 10,
  base_fail = 25,
  stat = 'CON',
  points = 0,
  action = function(self, t)
    game.log('Sorry, not implemented (ABSORB_SOUL)')
  end,
  info = [[Watch this space]],
}

newTalent {
  name = [[Vampirism]],
  short_name = 'VAMPIRISM',
  display_entity = Entity.new { image='talents/vampirism.png' },
  type = 'skill/necromancy',
  mode = 'activated',
  is_spell = true,
  skill = 'NECROMANCY',
  skill_level = 30,
  mana = 15,
  base_fail = 20,
  stat = 'CON',
  points = 0,
  action = function(self, t)
    game.log('Sorry, not implemented (VAMPIRISM)')
  end,
  info = [[Watch this space]],
}

newTalent {
  name = [[Death]],
  short_name = 'NECRO_DEATH',
  display_entity = Entity.new { image='talents/death.png' },
  type = 'skill/necromancy',
  mode = 'activated',
  is_spell = true,
  skill = 'NECROMANCY',
  skill_level = 35,
  mana = 100,
  base_fail = 25,
  stat = 'CON',
  points = 0,
  action = function(self, t)
    game.log('Sorry, not implemented (NECRO_DEATH)')
  end,
  info = [[Watch this space]],
}
