-- $Id: summoning.lua 2688 2016-12-27 18:04:45Z dsb $
-- ToME - Tales of Middle-Earth
-- Copyright (C) 2012 Scott Bigham
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Scott Bigham "Zizzo"
-- dsb-tome@killerbbunnies.org

local Entity = require 'engine.Entity'

newTalentType {
  name = 'Summoning powers',
  type = 'skill/summoning',
  description = 'Talents conferred by the Summoning skill',
}

newTalent {
  name = [[Create Totem]],
  short_name = 'MAKE_TOTEM',
  display_entity = Entity.new { image='talents/create_totem.png' },
  type = 'skill/summoning',
  mode = 'activated',
  is_spell = true,
  points = 0,
  action = function(self, t)
    game.log('Sorry, not implemented (MAKE_TOTEM)')
  end,
  info = [[Watch this space]],
}

newTalent {
  name = [[Summon from Totem]],
  short_name = 'TOTEM_SUMMON',
  display_entity = Entity.new { image='talents/summon_from_totem.png' },
  type = 'skill/summoning',
  mode = 'activated',
  is_spell = true,
  points = 0,
  action = function(self, t)
    game.log('Sorry, not implemented (TOTEM_SUMMON)')
  end,
  info = [[Watch this space]],
}
