-- $Id: conveyance.lua 2662 2016-11-29 05:35:59Z dsb $
-- ToME - Tales of Middle-Earth
-- Copyright © 2012-2015 Scott Bigham
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Scott Bigham "Zizzo"
-- dsb-tome@killerbbunnies.org

-- -----------------------------------------------------------------------
-- WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING
-- -----------------------------------------------------------------------
-- This file was generated automatically by the 'gen_spells' Perl script.
-- DO NOT MODIFY THIS FILE DIRECTLY, as any changes will be lost the next
-- time the file is generated (with the possible exception of lines between
-- 'BEGIN VERBATIM' and 'END VERBATIM' markers, if supported by the script).
-- -----------------------------------------------------------------------
-- WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING
-- -----------------------------------------------------------------------

-- Spell talents generated from T2's s_convey.lua

local Entity = require 'engine.Entity'

newTalentType {
  name = 'Conveyance spells',
  type = 'spell/conveyance',
  description = 'Spells from the Conveyance school',
}

newTalent {
  name = [[Phase Door]],
  short_name = 'PHASE_DOOR',
  display_entity = Entity.new { image='talents/phase_door.png' },
  type = 'spell/conveyance',
  mode = 'activated',
  is_spell = true,
  skill = 'CONVEYANCE',
  skill_level = 1,
  mana = spell.mana_cost,
  min_mana = 1,
  max_mana = 3,
  base_fail = 10,
  stat = 'INT',
  random_book = 'MAGIC',
  inertia = { 1, 5 },
  points = 0,
  range = 18,
  direct_hit = true,
  action = function(self, t)
    local lev = spell.get_spell_level(self, t)
    local dist = 10 + spell.get_spell_level(self, t, 8)
    local ox, oy = self.x, self.y
    spell.teleport(self, dist)
    if lev >= 30 and (ox ~= self.x or oy ~= self.y) then
      local Map = require('mod.class..Map')
      local ok1 = not game.level.map:checkEntity(ox, oy, Map.TERRAIN, 'hasFlags', 'PERMANENT')
      local ok2 = not game.level.map:checkEntity(self.x, self.y, Map.TERRAIN, 'hasFlags', 'PERMANENT')
      if ok1 and ok2 then
	local g = game.zone.grid_list.VOID_JUMPGATE
	game.level.map(ox, oy, Map.TERRAIN, g)
	game.level.map(self.x, self.y, Map.TERRAIN, g)
	game.level.map.attrs(ox, oy, 'pair_gate', { x=self.x, y=self.y })
	game.level.map.attrs(self.x, self.y, 'pair_gate', { x=ox, y=oy })
      end
    end
    return true
  end,
  info = function(self, t)
    local dist = 10 + spell.get_spell_level(self, t, 8)
    local sfx = spell.spell_skill_desc(self, t)
    local ret = [[Teleports you on a small scale range (distance %d).  At level 30, it creates void jumpgates between your starting and ending locations.  Range will increase%s]]
    return ret:format(dist, sfx)
  end,
}

newTalent {
  name = [[Disarm]],
  short_name = 'DISARM',
  display_entity = Entity.new { image='talents/disarm.png' },
  type = 'spell/conveyance',
  mode = 'activated',
  is_spell = true,
  skill = 'CONVEYANCE',
  skill_level = 3,
  mana = spell.mana_cost,
  min_mana = 2,
  max_mana = 4,
  base_fail = 15,
  stat = 'INT',
  random_book = 'MAGIC',
  stick = {
    type = 'utility/staff',
    charge = { 10, 15 },
    rarity = 4,
    base_level = { 1, 10 },
    max_level = { 10, 50 },
  },
  points = 0,
  range = 18,
  direct_hit = true,
  action = function(self, t)
    local lev = spell.get_spell_level(self, t)
    local dam = { 0, silent_0dam=true }
    spell.ball_spell(self, t, DamageType.KILL_DOOR, dam, 1, self.x, self.y)
    if lev >= 10 then
      spell.ball_spell(self, t, DamageType.KILL_TRAP, dam, 1, self.x, self.y)
    end
    return true
  end,
  info = function(self, t)
    return [[Destroys adjacent doors and traps.  At level 10 it destroys adjacent doors and traps, then reveals and unlocks any adjacent secret doors]]
  end,
}

newTalent {
  name = [[Teleportation]],
  short_name = 'TELEPORT',
  display_entity = Entity.new { image='talents/teleportation.png' },
  type = 'spell/conveyance',
  mode = 'activated',
  is_spell = true,
  skill = 'CONVEYANCE',
  skill_level = 10,
  mana = spell.mana_cost,
  min_mana = 8,
  max_mana = 14,
  base_fail = 30,
  stat = 'INT',
  random_book = 'MAGIC',
  inertia = { 1, 10 },
  stick = {
    type = 'utility/staff',
    charge = { 7, 7 },
    rarity = 50,
    base_level = { 1, 20 },
    max_level = { 20, 50 },
  },
  points = 0,
  range = 18,
  direct_hit = true,
  action = function(self, t)
    local dist = 100 + spell.get_spell_level(self, t, 100)
    spell.teleport(self, dist)
    return true
  end,
  info = function(self, t)
    local dist = 100 + spell.get_spell_level(self, t, 100)
    local speed = t.use_speed(self, t)*100
    local sfx = spell.spell_skill_desc(self, t)
    local ret = [[Teleports you around the level (range %d).

#{bold}#NOTE:#{normal}#  This spell takes longer than a normal turn to cast at low levels (124%% at level 1), becoming faster at higher levels (75%% at level 50; currently %d%%).  Casting time will decrease%s]]
    return ret:format(dist, speed, sfx)
  end,
  -- BEGIN VERBATIM
  use_speed = function(self, t)
    return (125 - spell.get_spell_level(self, t, 50))/100
  end,
  -- END VERBATIM
}

newTalent {
  name = [[Teleport Away]],
  short_name = 'TELEPORT_AWAY',
  display_entity = Entity.new { image='talents/teleport_away.png' },
  type = 'spell/conveyance',
  mode = 'activated',
  is_spell = true,
  skill = 'CONVEYANCE',
  skill_level = 23,
  mana = spell.mana_cost,
  min_mana = 15,
  max_mana = 40,
  base_fail = 60,
  stat = 'INT',
  random_book = 'MAGIC',
  stick = {
    type = 'utility/wand',
    charge = { 3, 5 },
    rarity = 75,
    base_level = { 1, 20 },
    max_level = { 20, 50 },
  },
  requires_target = true,
  points = 0,
  range = 18,
  direct_hit = true,
  action = function(self, t)
    local lev = spell.get_spell_level(self, t)
    if lev >= 20 then
      spell.los_spell(self, t, DamageType.TELEPORT, 100)
      return true
    elseif lev >= 10 then
      local r = 3 + spell.get_spell_level(self, t, 4)
      return spell.ball_spell(self, t, DamageType.TELEPORT, 100, r)
    else
      return spell.beam_spell(self, t, DamageType.TELEPORT, 100)
    end
  end,
  info = function(self, t)
    local r = 3 + spell.get_spell_level(self, t, 4)
    local sfx = spell.spell_skill_desc(self, t)
    local ret = [[Teleports away monsters along a beam (power 100).  At level 10, it affects monsters in a radius-%d area around the selected target.  At level 20, it affects all monsters in line of sight.  Radius will increase%s]]
    return ret:format(r, sfx)
  end,
}

newTalent {
  name = [[Recall]],
  short_name = 'RECALL',
  display_entity = Entity.new { image='talents/recall.png' },
  type = 'spell/conveyance',
  mode = 'activated',
  is_spell = true,
  skill = 'CONVEYANCE',
  skill_level = 30,
  mana = spell.mana_cost,
  min_mana = 25,
  max_mana = 25,
  base_fail = 60,
  stat = 'INT',
  random_book = 'MAGIC',
  points = 0,
  range = 18,
  direct_hit = true,
  action = function(self, t)
    local tg = {
      type = 'hit',
      range = self:getTalentRange(t),
      nowarning = true,
      nolock = true,
      pass_terrain = true,
      requires_knowledge = false,
    }
    local tx, ty, target = self:getTarget(tg)
    if not tx or not ty then return false end
    if tx == self.x and ty == self.y then
      -- Target self; set recall
      local d = math.min(0, 21 - spell.get_spell_level(self, t, 15))
      local f = math.min(1, 15 - spell.get_spell_level(self, t, 10))
      return spell.set_recall(self, d, f)
    elseif target then
      -- Target monster; swap position
      -- TODO teleport jamming prevents
      if not self:canMove(tx, ty, true) or not target:canMove(self.x, self.y, true) then
	game.logPlayer(self, 'Terrain prevents %s from switching places with %s.', self.name, target.name)
	return false
      end
      local sx, sy = self.x, self.y
      self.x, self.y = nil, nil
      self:move(tx, ty, true)
      target.x, target.y = nil, nil
      target:move(sx, sy, true)
      return true
    else
      local need_los = spell.get_spell_level(self, t, 50) < 15
      local wgt = 1 + spell.get_spell_level(self, t, 150)/10
      return spell.fetch_object(self, tx, ty, wgt, need_los)
    end
  end,
  info = function(self, t)
    local d = math.min(0, 21 - spell.get_spell_level(self, t, 15))
    local f = math.min(1, 15 - spell.get_spell_level(self, t, 10))
    local wgt = 1 + spell.get_spell_level(self, t, 150)/10
    local sfx = spell.spell_skill_desc(self, t)
    local ret = [[· If targeted on yourself, recalls you to the surface or dungeon as per a Scroll of Word of Recall, with a delay of %d+1d%d turns (delay decreases%s).
· If targeted on a monster, swaps your position with the target monster's.
· If targeted on an object, fetches the object to your feet.  The object cannot weigh more than %.1flb (increases%s) and, at level 14 or lower, must be in line of sight.]]
    return ret:format(d, f, sfx, wgt, sfx)
  end,
}

newTalent {
  name = [[Probability Travel]],
  short_name = 'PROB_TRAVEL',
  display_entity = Entity.new { image='talents/probability_travel.png' },
  type = 'spell/conveyance',
  mode = 'activated',
  is_spell = true,
  skill = 'CONVEYANCE',
  skill_level = 35,
  mana = spell.mana_cost,
  min_mana = 30,
  max_mana = 50,
  base_fail = 90,
  stat = 'INT',
  random_book = 'MAGIC',
  inertia = { 6, 40 },
  stick = {
    type = 'utility/staff',
    charge = { 1, 2 },
    rarity = 97,
    base_level = { 1, 5 },
    max_level = { 8, 25 },
  },
  points = 0,
  range = 18,
  direct_hit = true,
  action = function(self, t)
    local base_dur = spell.get_spell_level(self, t, 50)
    self:setEffect(self.EFF_PROBABILITY_TRAVEL, base_dur+rng.range(1, 20), {})
    return true
  end,
  info = function(self, t)
    local base_dur = spell.get_spell_level(self, t, 50)
    local sfx = spell.spell_skill_desc(self, t)
    local ret = [[Renders you immaterial for %d+1d20 turns.  When you hit a wall, you will travel through it and instantly appear on the other side of it.  You can also float up and down between dungeon levels at will.  Duration will increase%s]]
    return ret:format(base_dur, sfx)
  end,
}
