-- $Id: geomancy.lua 2585 2016-10-12 00:22:45Z dsb $
-- ToME - Tales of Middle-Earth
-- Copyright © 2012-2015 Scott Bigham
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Scott Bigham "Zizzo"
-- dsb-tome@killerbbunnies.org

-- -----------------------------------------------------------------------
-- WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING
-- -----------------------------------------------------------------------
-- This file was generated automatically by the 'gen_spells' Perl script.
-- DO NOT MODIFY THIS FILE DIRECTLY, as any changes will be lost the next
-- time the file is generated (with the possible exception of lines between
-- 'BEGIN VERBATIM' and 'END VERBATIM' markers, if supported by the script).
-- -----------------------------------------------------------------------
-- WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING
-- -----------------------------------------------------------------------

-- Spell talents generated from T2's s_geom.lua

local Entity = require 'engine.Entity'

newTalentType {
  name = 'Geomancy spells',
  type = 'spell/geomancy',
  description = 'Spells from the Geomancy school',
}

newTalent {
  name = [[Call the Elements]],
  short_name = 'GEO_CALL_ELEM',
  display_entity = Entity.new { image='talents/call_the_elements.png' },
  type = 'spell/geomancy',
  mode = 'activated',
  is_spell = true,
  skill = 'GEOMANCY',
  skill_level = 1,
  mana = spell.mana_cost,
  min_mana = 2,
  max_mana = 20,
  base_fail = 10,
  blind_cast = true,
  stat = 'INT',
  requires_target = function(self, t)
    return spell.get_spell_level(self, t) >= 17
  end,
  points = 0,
  range = 18,
  direct_hit = true,
  action = function(self, t)
    local r = 1 + spell.get_spell_level(self, t, 5, 0)
    local tx, ty = nil, nil
    if not t.requires_target(self, t) then tx, ty = self.x, self.y end
    spell.ball_spell(self, t, DamageType.ELEMENTAL_GROWTH,
		     { 1, silent_0dam=true }, r, tx, ty)
    return true
  end,
  info = function(self, t)
    local r = 1 + spell.get_spell_level(self, t, 5, 0)
    local sfx = spell.spell_skill_desc(self, t)
    local ret = [[Transforms the ground around you in a radius of %d, creating random terrain tied to the four elements (except Air, of course).  The probabilities of various types of terrain are determined by your skill in the Fire, Earth and Water schools.  At level 17 the area of effect can be targeted.  Radius will increase%s.]]
    return ret:format(r, sfx)
  end,
}

newTalent {
  name = [[Channel Elements]],
  short_name = 'GEO_CHANNEL_ELEM',
  display_entity = Entity.new { image='talents/channel_elements.png' },
  type = 'spell/geomancy',
  mode = 'activated',
  is_spell = true,
  skill = 'GEOMANCY',
  skill_level = 3,
  mana = spell.mana_cost,
  min_mana = 3,
  max_mana = 30,
  base_fail = 20,
  blind_cast = true,
  stat = 'INT',
  points = 0,
  range = 18,
  direct_hit = true,
  action = function(self, t)
    local g = game.level.map(self.x, self.y, Map.TERRAIN)
    local eff = t.effects[g.define_as]
    -- Should have been caught by on_pre_use().
    if not eff then return false end

    game.level.map(self.x, self.y, Map.TERRAIN, game.zone.grid_list.FLOOR)
    eff(self, t)
    return true
  end,
  info = function(self, t)
    local ret = [[Draws on your immediate environment to form an attack or other effect:
  • Grass and grass with flowers heal for %d%% resp. %d%% of your max hit points, increasing with your Earth skill.
  • Water fires a bolt (or beam at Water level 8) doing 3d%d %s damage for shallow water or 5d%d for deep water, increasing with your Water skill.  At Water level 18, the damage type becomes %s, knocking the target back.
  • Ice fires a bolt doing 3d%d %s damage, increasing with your Water skill; at Water level 12; it becomes a radius-3 ball, doing %d damage at the center.
  • Sand forms a swirling barrier of burning sand around you for %d+1d20 turns (increasing with your Air skill), doing %dd%d %s damage to attackers (increasing with your Fire skill, and becoming %s at Fire level 27), but blinding you for the same duration.
  • Lava fires a bolt doing %dd15 %s damage (for shallow lava) or a radius-3 ball doing %dd15 damage (for deep lava), increasing with your Fire skill; at Fire level 15, damage becomes %s.
  • Dark pits fire a bolt doing 10d%d %s damage, increasing with Earth skill; at Earth level 18 the damage becomes %s.
Your current grid will be reduced to bare floor in the process.]]
    return ret:format(
      -- Grass/grass with flowers
      self:getSkillLevel('EARTH', 20),
      self:getSkillLevel('EARTH', 30),
      -- Shallow water/deep water
      self:getSkillLevel('WATER'),
      util.colorize_damtype(DamageType.WATER),
      self:getSkillLevel('WATER'),
      util.colorize_damtype(DamageType.WAVE),
      -- Ice
      self:getSkillLevel('WATER'),
      util.colorize_damtype(DamageType.ICE),
      self:getSkillLevel('WATER', 340),
      -- Sand
      spell.get_spell_level(self, t) + self:getSkillLevel('AIR'),
      5 + self:getSkillLevel('FIRE', 20),
      5 + self:getSkillLevel('FIRE', 14),
      util.colorize_damtype(DamageType.FIRE),
      util.colorize_damtype(DamageType.PHYSICAL),
      -- Shallow lava/deep lava
      self:getSkillLevel('FIRE', 30),
      util.colorize_damtype(DamageType.FIRE),
      self:getSkillLevel('FIRE', 30),
      util.colorize_damtype(DamageType.HELL_FIRE),
      -- Dark pit
      self:getSkillLevel('EARTH'),
      util.colorize_damtype(DamageType.DARK),
      util.colorize_damtype(DamageType.NETHER)
    )
  end,
  -- BEGIN VERBATIM
  effects = {
    GRASS = function(self, t)
      self:heal(self.max_life * (5 + self:getSkillLevel('EARTH', 20))/100)
    end,
    GRASS_WITH_FLOWERS = function(self, t)
      self:heal(self.max_life * (5 + self:getSkillLevel('EARTH', 30))/100)
    end,
    DARK_PIT = function(self, t)
      local lev = self:getSkillLevel('EARTH')
      local dt = lev >= 18 and DamageType.NETHER or DamageType.DARK
      spell.bolt_spell(self, t, dt, rng.dice(10, lev))
    end,
    SHALLOW_WATER = function(self, t)
      local lev = self:getSkillLevel('WATER')
      local dt = lev >= 18 and DamageType.WAVE or DamageType.WATER
      if lev >= 8 then
	spell.beam_spell(self, t, dt, rng.dice(3, lev))
      else
	spell.bolt_spell(self, t, dt, rng.dice(3, lev))
      end
    end,
    DEEP_WATER = function(self, t)
      local lev = self:getSkillLevel('WATER')
      local dt = lev >= 18 and DamageType.WAVE or DamageType.WATER
      if lev >= 8 then
	spell.beam_spell(self, t, dt, rng.dice(5, lev))
      else
	spell.bolt_spell(self, t, dt, rng.dice(5, lev))
      end
    end,
    ICE = function(self, t)
      local lev = self:getSkillLevel('WATER')
      if lev >= 12 then
	spell.ball_spell(self, t, DamageType.ICE, self:getSkillLevel('WATER', 340), 3)
      else
	spell.bolt_spell(self, t, DamageType.ICE, rng.dice(3, lev))
      end
    end,
    SAND = function(self, t)
      local sh_lvl = spell.get_spell_level(self, self:getTalentFromId(self.T_FIRE_SHIELD))
      local dt = sh_lvl >= 8 and DamageType.PHYSICAL or DamageType.FIRE
      local p = {
	power = 0,
	on_melee_hit = {
	  type=dt,
	  dice={
	    5 + self:getSkillLevel('FIRE', 20),
	    5 + self:getSkillLevel('FIRE', 14),
	  }
	},
	shield_name = 'sand shield',
      }
      self:setEffect(self.EFF_SHIELD, rng.range(1, 20) + spell.get_spell_level(self, t) + self:getSkillLevel('AIR'), p)
    end,
    SHALLOW_LAVA = function(self, t)
      local dt = self:getSkillLevel('FIRE') >= 15 and DamageType.HELL_FIRE or DamageType.FIRE
      spell.bolt_spell(self, t, dt, rng.dice(self:getSkillLevel('FIRE', 30), 15))
    end,
    DEEP_LAVA = function(self, t)
      local dt = self:getSkillLevel('FIRE') >= 15 and DamageType.HELL_FIRE or DamageType.FIRE
      spell.ball_spell(self, t, dt, rng.dice(self:getSkillLevel('FIRE', 30), 15), 3)
    end,
  },
  on_pre_use = function(who, t, silent, dry_run)
    local g = game.level.map(who.x, who.y, Map.TERRAIN)
    if not t.effects[g.define_as] then
      if not silent then
	game.logPlayer(who, 'You cannot channel this area.')
      end
      return false
    end
    return true
  end
  -- END VERBATIM
}

newTalent {
  name = [[Vaporize]],
  short_name = 'GEO_VAPORIZE',
  display_entity = Entity.new { image='talents/vaporize.png' },
  type = 'spell/geomancy',
  mode = 'activated',
  is_spell = true,
  skill = 'GEOMANCY',
  skill_level = 4,
  mana = spell.mana_cost,
  min_mana = 3,
  max_mana = 30,
  base_fail = 15,
  blind_cast = true,
  stat = 'INT',
  skill_req = { AIR = 4 },
  points = 0,
  range = 18,
  direct_hit = true,
  action = function(self, t)
    local g = game.level.map(self.x, self.y, Map.TERRAIN)
    local eff = t.effects[g.define_as]
    -- Should have been caught by on_pre_use().
    if not eff then return false end

    local lev = spell.get_spell_level(self, t)
    local type = lev >= 20 and eff[2] or eff[1]
    local dam = 5 + game.player:getSkillLevel(eff[3], eff[4])
    local r = 1 + spell.get_spell_level(self, t, 4)
    local dur = 10 + spell.get_spell_level(self, t, 20)

    game.level.map(self.x, self.y, Map.TERRAIN, game.zone.grid_list.FLOOR)
    spell.cloud_spell(self, t, type, dam, r, dur, nil, nil, self.x, self.y)
    return true
  end,
  info = function(self, t)
    local r = 1 + spell.get_spell_level(self, t, 4)
    local dur = 10 + spell.get_spell_level(self, t, 20)
    local sfx = spell.spell_skill_desc(self, t)
    local ret = [[Draws upon your immediate environs to form a cloud of damaging vapors, reducing your current grid to bare floor in the process.  The cloud will have radius %d and last %d turns, and will do a type and amount of damage that depends on the terrain type and on your Fire, Earth or Water skill (again depending on the terrain type); radius and duration will increase%s]]
    ret = ret:format(r, dur, sfx)

    local g = game.level.map(self.x, self.y, Map.TERRAIN)
    local eff = t.effects[g.define_as]
    if not eff then
      local r2 = [[Your current terrain (%s) cannot be channeled by this spell.]]
      ret = ret .. '\n\n' .. r2:format(g.name)
    else
      local lev = spell.get_spell_level(self, t)
      local type = lev >= 20 and eff[2] or eff[1]
      local dtf = util.colorize_damtype(type)
      local dam = 5 + game.player:getSkillLevel(eff[3], eff[4])
      local sk = game.player.skills_def[eff[3]]
      local r2 = [[On your current terrain (%s), the spell will create a cloud of %s doing %d damage per turn; damage will increase with your %s skill.]]
      ret = ret .. '\n\n' .. r2:format(g.name, dtf, dam, sk.name)
    end
    return ret
  end,
  -- BEGIN VERBATIM
  effects = {
    -- Earth stuff
    GRASS 		= { DamageType.POISON, DamageType.POISON, 'EARTH', 100 },
    GRASS_WITH_FLOWERS 	= { DamageType.POISON, DamageType.POISON, 'EARTH', 150 },
    DARK_PIT 		= { DamageType.DARK, DamageType.DARK, 'EARTH', 200 },

    -- Water stuff
    SHALLOW_WATER 	= { DamageType.WATER, DamageType.WATER, 'WATER', 100 },
    DEEP_WATER 		= { DamageType.WATER, DamageType.WATER, 'WATER', 150 },
    ICE 		= { DamageType.ICE, DamageType.ICE, 'WATER', 100 },

    -- Fire stuff
    SAND 		= { DamageType.LITE, DamageType.LITE, 'FIRE', 200 },
    SHALLOW_LAVA 	= { DamageType.FIRE, DamageType.HOLY_FIRE, 'FIRE', 100 },
    DEEP_LAVA 		= { DamageType.FIRE, DamageType.HOLY_FIRE, 'FIRE', 150 },
  },
  on_pre_use = function(who, t, silent, dry_run)
    local g = game.level.map(who.x, who.y, Map.TERRAIN)
    if not t.effects[g.define_as] then
      if not silent then
	game.logPlayer(who, 'You cannot channel this area.')
      end
      return false
    end
    return true
  end,
  -- END VERBATIM
}

newTalent {
  name = [[Geolysis]],
  short_name = 'GEO_GEOLYSIS',
  display_entity = Entity.new { image='talents/geolysis.png' },
  type = 'spell/geomancy',
  mode = 'activated',
  is_spell = true,
  skill = 'GEOMANCY',
  skill_level = 7,
  mana = spell.mana_cost,
  min_mana = 15,
  max_mana = 40,
  base_fail = 15,
  blind_cast = true,
  stat = 'INT',
  skill_req = { EARTH = 7 },
  points = 0,
  range = 18,
  direct_hit = true,
  action = function(self, t)
			local ret, dir = get_rep_dir()
			if ret == FALSE then return end

			msg_print("Elements recombine before you, laying down an open path.")
			geomancy_dig(player.py, player.px, dir, 5 + get_level(GEOLYSIS, 12))

			return TRUE
	end,
  info = [[Burrows deeply and slightly at random into a wall, leaving behind tailings of various different sorts of walls in the passage. player.dripping_tread You stop dripping raw elemental energies.]],
  info_aux = function(self, t)
			return "length "..(5 + get_level(GEOLYSIS, 12))
	end,
}

newTalent {
  name = [[Dripping Tread]],
  short_name = 'GEO_DRIP_TREAD',
  display_entity = Entity.new { image='talents/dripping_tread.png' },
  type = 'spell/geomancy',
  mode = 'activated',
  is_spell = true,
  skill = 'GEOMANCY',
  skill_level = 10,
  mana = spell.mana_cost,
  min_mana = 15,
  max_mana = 25,
  base_fail = 15,
  blind_cast = true,
  stat = 'INT',
  skill_req = { WATER = 10 },
  points = 0,
  range = 18,
  direct_hit = true,
  action = function(self, t)
    if self:hasEffect(self.T_DRIP_TREAD) then
      -- Cancel the effect.
      self:removeEffect(self.T_DRIP_TREAD)
    else
      local dur = rng.range(11, 25) + spell.get_spell_level(self, t)
      self:setEffect(self.T_DRIP_TREAD, dur, {})
    end
    return true
  end,
  info = function(self, t)
    local dur_base = 10 + spell.get_spell_level(self, t)
    local sfx = spell.spell_skill_desc(self, t)
    local ret = [[For %d+1d15 turns, you will drip raw elemental energies as you walk, transforming the ground behind you into random terrain tied to the four elements (except Air, of course).  The probabilities of various types of terrain are determined by your skill in the Fire, Earth and Water schools.  Duration will increase%s]]
    return ret:format(dur_base, sfx)
  end,
}

newTalent {
  name = [[Grow Barrier]],
  short_name = 'GEO_GROW_BARRIER',
  display_entity = Entity.new { image='talents/grow_barrier.png' },
  type = 'spell/geomancy',
  mode = 'activated',
  is_spell = true,
  skill = 'GEOMANCY',
  skill_level = 12,
  mana = spell.mana_cost,
  min_mana = 30,
  max_mana = 40,
  base_fail = 15,
  blind_cast = true,
  stat = 'INT',
  skill_req = { EARTH = 12 },
  requires_target = true,
  points = 0,
  range = 18,
  direct_hit = true,
  action = function(self, t)
    local x, y = nil, nil
    if spell.get_spell_level(self, t) < 20 then x, y = self.x, self.y end
    local ret = spell.ball_spell(self, t, DamageType.ELEMENTAL_WALL,
				 { 1, silent_0dam=true }, 1, x, y, 10)
    if ret then spell.clobber_FOVs(x, y) end
    return ret
  end,
  info = function(self, t)
    return [[Grows a barrier of impassable terrain around the caster.  At level 20, the effect can be targeted.]]
  end,
}

newTalent {
  name = [[Elemental Wave]],
  short_name = 'GEO_ELEM_WAVE',
  display_entity = Entity.new { image='talents/elemental_wave.png' },
  type = 'spell/geomancy',
  mode = 'activated',
  is_spell = true,
  skill = 'GEOMANCY',
  skill_level = 15,
  mana = spell.mana_cost,
  min_mana = 15,
  max_mana = 50,
  base_fail = 20,
  blind_cast = true,
  stat = 'INT',
  points = 0,
  range = 18,
  direct_hit = true,
  action = function(self, t)
    local r = 6 + spell.get_spell_level(self, t, 20)
    local tg = { type='cone', range=0, radius=r, cone_angle=90, talent=t }
    local x, y = self:getTarget(tg)
    if not x or not y then return false end
    if x == self.x and y == self.y then return false end

    -- Sneaky Hack(TM):  Since the cone can now be angle, we choose which
    -- adjacent grid to consume by walking the line from the caster's
    -- location to the target point.
    local l = core.fov.line(self.x, self.y, x, y)
    local gx, gy = l:step()
    if not gx or not gy then return nil end

    local g = game.level.map(gx, gy, Map.TERRAIN)
    local eff = t.effects[g.define_as]
    if not eff then
      game.logPlayer(who, 'You cannot channel this area.')
      return false
    end

    local lev = spell.get_spell_level(self, t)
    local dt = lev >= 20 and eff[2] or eff[1]
    local dam = eff[4] + game.player:getSkillLevel(eff[3], eff[5])

    local dir = {
      source_x = self.x,
      source_y = self.y,
      delta_x = x - self.x,
      delta_y = y - self.y,
    }
    local function rad_cb(e, update_shape_only)
      if not update_shape_only then e.radius = e.radius + 1 end
      return true
    end
    game.level.map(gx, gy, Map.TERRAIN, game.zone.grid_list.FLOOR)
    local e = game.level.map:addEffect(self, self.x, self.y, r, dt,
				       { dam, x=self.x, y=self.y },
				       0, dir, 90, spell.cloud_overlay(dt),
				       rad_cb, true, false)
    e.name = t.name
    return true
  end,
  info = function(who, t)
    local order = {
      'GRASS', 'GRASS_WITH_FLOWERS', 'SHALLOW_WATER', 'DEEP_WATER',
      'ICE', 'SAND', 'SHALLOW_LAVA', 'DEEP_LAVA',
    }
    local lines = {}
    for _, tag in ipairs(order) do
      local eff = t.effects[tag]
      local dam = eff[4] + game.player:getSkillLevel(eff[3], eff[5])
      local df1 = util.colorize_damtype(eff[1])
      local df2 = util.colorize_damtype(eff[2])
      local sk = game.player.skills_def[eff[3]]
      local gg = game.zone.grid_list[tag]
      local g_name = game.zone.grid_list[tag].name:capitalize()
      if g_name:find('^Stream of ') then
	g_name = g_name:sub(11):capitalize()
      end
      local line = [[• %s will do %d %s or %s damage, increasing with %s skill]]
      lines[#lines+1] = line:format(g_name, dam, df1, df2, sk.name)
    end
    lines = table.concat(lines, '\n  ')
    local r = 6 + spell.get_spell_level(who, t, 20)
    local sfx = spell.spell_skill_desc(who, t)
    local ret1 = [[Draws upon your adjacent environment to project a slow-moving wave of damage in a particular direction, with final radius %d.  Damage type changes at spell levl 20, and damage depends on the terrain:
  ]]
    local ret2 = '\nRadius will increase%s'
    return ret1:format(r) .. lines .. ret2:format(sfx)
  end,
  -- BEGIN VERBATIM
  effects = {
    -- Earth stuff
    GRASS 		= { DamageType.POISON, DamageType.POISON, 'EARTH', 10, 200 },
    GRASS_WITH_FLOWERS 	= { DamageType.POISON, DamageType.POISON, 'EARTH', 10, 300 },

    -- Water stuff
    SHALLOW_WATER 	= { DamageType.WATER, DamageType.WATER, 'WATER', 10, 200 },
    DEEP_WATER	 	= { DamageType.WATER, DamageType.WATER, 'WATER', 10, 300 },
    ICE 		= { DamageType.ICE, DamageType.ICE, 'WATER', 10, 200 },

    -- Fire stuff
    SAND 		= { DamageType.LITE, DamageType.LITE, 'FIRE', 10, 400 },
    SHALLOW_LAVA 	= { DamageType.FIRE, DamageType.HOLY_FIRE, 'FIRE', 10, 200 },
    DEEP_LAVA	 	= { DamageType.FIRE, DamageType.HOLY_FIRE, 'FIRE', 10, 300 },
  }
  -- END VERBATIM
}

newTalent {
  name = [[Elemental Minion]],
  short_name = 'GEO_ELEM_MINION',
  display_entity = Entity.new { image='talents/elemental_minion.png' },
  type = 'spell/geomancy',
  mode = 'activated',
  is_spell = true,
  skill = 'GEOMANCY',
  skill_level = 20,
  mana = spell.mana_cost,
  min_mana = 40,
  max_mana = 80,
  base_fail = 25,
  stat = 'INT',
  points = 0,
  range = 1,
  direct_hit = true,
  action = function(self, t)
    local function ok_summon(x, y)
      local g = game.level.map(x, y, Map.TERRAIN)
      return g and t.feats[g.define_as]
    end
    local tx, ty = util.select_adjacent(self, ok_summon, 'There is nothing nearby you can summon from.', 'You cannot summon from this terrain.')
    if not tx or not ty then return false end
    local g = game.level.map(tx, ty, Map.TERRAIN)
    local spec = t.feats[g.define_as]
    local sk, cands = spec[1], spec[2]
    local max_cand = math.max(1, self:getSkillLevel(sk, #cands))
    local cand = cands[rng.range(1, max_cand)]
    local m_lev = 10 + spell.get_spell_level(self, t, 120)
    -- Slight Hack(TM):  The T2 code places the summon nearby and then
    -- removes the terrain; we remove the terrain first and place the
    -- summon where the terrain was.
    game.level.map(tx, ty, Map.TERRAIN, game.zone.grid_list.FLOOR)
    spell.summon(self, tx, ty, cand, 1, m_lev)
    return true
  end,
  info = function(who, t)
    local m_lev = 10 + spell.get_spell_level(self, t, 120)
    local sfx = spell.spell_skill_desc(who, t)
    local ret = [[Cannibalize an adjacent terrain feature to summon a minion, leveled to level %d.  The type of minion will depend on the terrain type and your skill level in a related skill:

· Walls and quartz/magma veins can summon Earth elementals, Xorn or Xaren, depending on your Earth skill level.
· Dark pits can summon Air elementals, Ancient blue dragons, Great Storm Wyrms or Sky Drakes, depending on your Air skill level.
· Sandwalls and lava can summon Fire elements or Ancient red dragons, depending on your Fire skill level.
· Water and ice walls can summon Water elements, Water trolls or Water demons, depending on your Water skill level.

Minion level will increase%s]]
    return ret:format(m_lev, sfx)
  end,
  -- BEGIN VERBATIM
  feats = {
    WALL = { 'EARTH', { 'EARTH_ELEMENTAL', 'XORN', 'XAREN' } },
    WALL_XTRA = { 'EARTH', { 'EARTH_ELEMENTAL', 'XORN', 'XAREN' } },
    MAGMA_VEIN = { 'EARTH', { 'EARTH_ELEMENTAL', 'XORN', 'XAREN' } },
    QUARTZ_VEIN = { 'EARTH', { 'EARTH_ELEMENTAL', 'XORN', 'XAREN' } },
    MAGMA_VEIN_WITH_TREASURE = { 'EARTH', { 'EARTH_ELEMENTAL', 'XORN', 'XAREN' } },
    QUARTZ_VEIN_WITH_TREASURE = { 'EARTH', { 'EARTH_ELEMENTAL', 'XORN', 'XAREN' } },

    DARK_PIT = { 'AIR', { "AIR_ELEMENTAL", "ANCIENT_BLUE_DRAGON", "GREAT_STORM_WYRM", "SKY_DRAKE" } },
    SANDWALL = { 'FIRE', { 'FIRE_ELEMENTAL', 'ANCIENT_RED_DRAGON' } },
    SANDWALL_WITH_TREASURE = { 'FIRE', { 'FIRE_ELEMENTAL', 'ANCIENT_RED_DRAGON' } },
    SHALLOW_LAVA = { 'FIRE', { 'FIRE_ELEMENTAL', 'ANCIENT_RED_DRAGON' } },
    DEEP_LAVA = { 'FIRE', { 'FIRE_ELEMENTAL', 'ANCIENT_RED_DRAGON' } },

    ICE_WALL = { 'WATER', { 'WATER_ELEMENTAL', 'WATER_TROLL', 'WATER_DEMON' } },
    SHALLOW_WATER = { 'WATER', { 'WATER_ELEMENTAL', 'WATER_TROLL', 'WATER_DEMON' } },
    DEEP_WATER = { 'WATER', { 'WATER_ELEMENTAL', 'WATER_TROLL', 'WATER_DEMON' } },
  },
  -- END VERBATIM
}
