-- $Id: zone.lua 2508 2016-09-14 02:02:13Z dsb $
-- ToME - Tales of Middle-Earth
-- Copyright © 2012-2016 Scott Bigham
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Scott Bigham "Zizzo"
-- dsb-tome@killerbbunnies.org

-- Zone file for Maze.

return {
  name = 'Maze',
  display_abbr = 'Maz',
  level_scheme = 'fixed',
  max_level = 13,
  level_range = { 25, 37 },
  width = 198,
  height = 66,

  generator = {
    map = {
      class = 'mod.class.generator.map.T2MazeLevel',
      floor = { 'FLOOR' },
      fill = { weighted = { WALL=98, SECRET_DOOR=2 } },
      outer_wall = 'WALL',
      inner_wall = 'WALL',
      up = 'UP',
      down = 'DOWN',
      flags = {
	SMALLEST = true,
	FORGET = true,
      },
    },
    actor = {
      class = 'mod.class.generator.actor.T2LevelFilteredActors',
      init_npc = 20,
      respawn_in = 160,
      filters = {
	{ prob=80, mode='any' },
	{ prob=20, mode='or', syms={ 'p' } },
      },
      guardian = 'THE_MINOTAUR_OF_THE_LABYRINTH',
    },
    object = {
      class = 'mod.class.generator.object.T2LevelFilteredObjects',
      weights = { treasure=2, combat=40, magic=10, tools=40, junk=8 },
    },
    trap = {
      class = 'mod.class.generator.trap.T2LevelFilteredTraps',
    },
  },
  alter_level_data = util.adjust_level,
  levels = {
    [1] = {
      generator = {
	map = {
	  up = 'UP_TO_WILDERNESS',
	  -- up_lev = 1
	},
      },
    },
  },
}
