-- $Id: zone.lua 2508 2016-09-14 02:02:13Z dsb $
-- ToME - Tales of Middle-Earth
-- Copyright © 2012-2016 Scott Bigham
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Scott Bigham "Zizzo"
-- dsb-tome@killerbbunnies.org

-- Zone file for The Old Forest.

return {
  name = 'The Old Forest',
  display_abbr = 'OFr',
  level_scheme = 'fixed',
  max_level = 13,
  level_range = { 13, 25 },
  width = 198,
  height = 66,

  generator = {
    map = {
      class = 'mod.class.generator.map.T2DungeonLevel',
      floor = { weighted = { DIRT={76,68}, SHALLOW_WATER=16, GRASS_WITH_FLOWERS={8,16} } },
      fill = { 'TREE' },
      outer_wall = 'SMALL_TREE',
      inner_wall = 'TREE',
      fill_step = 4,
      up = 'PATH_TO_THE_PREVIOUS_AREA',
      down = 'PATH_TO_THE_NEXT_AREA',
      flags = {
	WATER_RIVERS = true,
	NO_DOORS = true,
	NO_DESTROY = true,
	FLAT = true,
	NO_STREAMERS = true,
	RANDOM_TOWNS = true,
      },
    },
    actor = {
      class = 'mod.class.generator.actor.T2LevelFilteredActors',
      init_npc = 15,
      respawn_in = 100,
      filters = {
	{ prob=30, mode='any' },
	{ prob=40, mode='or', flags={ 'ANIMAL' } },
	{ prob=30, mode='or', syms={ 'h' }, flags={ 'UNDEAD' } },
      },
      guardian = 'OLD_MAN_WILLOW',
    },
    object = {
      class = 'mod.class.generator.object.T2LevelFilteredObjects',
      weights = { treasure=20, combat=5, magic=15, tools=30, junk=30 },
    },
    trap = {
      class = 'mod.class.generator.trap.T2LevelFilteredTraps',
    },
  },
  alter_level_data = util.adjust_level,
  levels = {
    [1] = {
      generator = {
	map = {
	  up = 'PATH_TO_WILDERNESS',
	  -- up_lev = 1
	},
      },
    },
  },
}
