-- $Id: zone.lua 2508 2016-09-14 02:02:13Z dsb $
-- ToME - Tales of Middle-Earth
-- Copyright © 2012-2016 Scott Bigham
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Scott Bigham "Zizzo"
-- dsb-tome@killerbbunnies.org

-- Zone file for Paths of the Dead.

local DamageType = require('engine.DamageType')

return {
  name = 'Paths of the Dead',
  display_abbr = 'PoD',
  level_scheme = 'fixed',
  max_level = 31,
  level_range = { 40, 70 },
  width = 198,
  height = 66,
  ambient_damage = {
    damage = { 1, 1 },
    frequency = 20,
    damtype = DamageType.RAISE,
    kill_text = [[being raised from the dead (?)]],
  },

  generator = {
    map = {
      class = 'mod.class.generator.map.T2DungeonLevel',
      floor = { weighted = { DIRT=85, SHALLOW_WATER=15 } },
      fill = { weighted = { WALL=75, DARK_PIT=25 } },
      outer_wall = 'WALL',
      inner_wall = 'WALL',
      fill_step = 4,
      up = 'UP',
      down = 'DOWN',
      flags = {
      },
    },
    actor = {
      class = 'mod.class.generator.actor.T2LevelFilteredActors',
      init_npc = 24,
      respawn_in = 100,
      filters = {
	{ prob=5, mode='any' },
	{ prob=10, mode='or', syms={ 'p' } },
	{ prob=85, mode='or', flags={ 'UNDEAD', 'NONLIVING' } },
      },
      guardian = 'FEAGWATH_THE_UNDEAD_SORCERER',
    },
    object = {
      class = 'mod.class.generator.object.T2LevelFilteredObjects',
      weights = { treasure=30, combat=30, magic=30, tools=2, junk=8 },
    },
    trap = {
      class = 'mod.class.generator.trap.T2LevelFilteredTraps',
    },
  },
  alter_level_data = util.adjust_level,
  levels = {
    [1] = {
      generator = {
	map = {
	  up = 'UP_TO_WILDERNESS',
	  -- up_lev = 1
	},
      },
    },
  },
}
