-- $Id: grids.lua 2048 2016-01-02 21:32:21Z dsb $
-- ToME - Tales of Middle-Earth
-- Copyright (C) 2012 Scott Bigham
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Scott Bigham "Zizzo"
-- dsb-tome@killerbbunnies.org

load('/data/general/grids/all.lua')

newEntity {
  base = 'UP',
  define_as = 'EXIT_BREE_HOUSE_QUEST',
  name = 'stairs back to the outside',
  change_zone = 'town-bree',
  change_level = 1,
}

newEntity {
  base = 'LOCKED_DOOR',
  define_as = 'ALARM_DOOR',
  on_door_open = function(self, e)
    game.log("#FF0000#An alarm rings!#LAST#");
    spell.aggravate_near(e)
    local Map = require 'mod.class.Map'
    while true do
      local spot = game.level:pickSpotRemove{ type='quest', subtype='rigged-door' }
      if not spot then break end
      game.level.map(spot.x, spot.y, Map.TERRAIN, game.zone.grid_list.OPEN_DOOR)
    end
    game.log("#FF0000#The door explodes!#LAST#");
    game.level.map(self.x, self.y, Map.TERRAIN, game.zone.grid_list.FLOOR)
  end
}
