-- $Id: zone.lua 2508 2016-09-14 02:02:13Z dsb $
-- ToME - Tales of Middle-Earth
-- Copyright © 2012-2016 Scott Bigham
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Scott Bigham "Zizzo"
-- dsb-tome@killerbbunnies.org

-- Zone file for The Sacred Land Of Mountains.

return {
  name = 'The Sacred Land Of Mountains',
  display_abbr = 'LoM',
  level_scheme = 'fixed',
  max_level = 26,
  level_range = { 45, 70 },
  width = 198,
  height = 66,

  generator = {
    map = {
      class = 'mod.class.generator.map.T2DungeonLevel',
      floor = { 'GRASS' },
      fill = { 'MOUNTAIN_CHAIN' },
      outer_wall = 'MOUNTAIN_CHAIN',
      inner_wall = 'MOUNTAIN_CHAIN',
      fill_step = 0,
      up = 'PATH_TO_THE_PREVIOUS_AREA',
      down = 'PATH_TO_THE_NEXT_AREA',
      flags = {
	RANDOM_TOWNS = true,
	FLAT = true,
	NO_STREAMERS = true,
      },
    },
    actor = {
      class = 'mod.class.generator.actor.T2LevelFilteredActors',
      init_npc = 14,
      respawn_in = 160,
      filters = {
	{ prob=60, mode='or', flags={ 'CAN_FLY' } },
	{ prob=40, mode='any' },
      },
      guardian = 'TRONE_THE_REBEL_THUNDERLORD',
    },
    object = {
      class = 'mod.class.generator.object.T2LevelFilteredObjects',
      weights = { treasure=20, combat=20, magic=20, tools=20, junk=20 },
    },
    trap = {
      class = 'mod.class.generator.trap.T2LevelFilteredTraps',
    },
  },
  alter_level_data = util.adjust_level,
  levels = {
    [1] = {
      generator = {
	map = {
	  up = 'PATH_TO_WILDERNESS',
	  -- up_lev = 1
	},
      },
    },
  },
}
