-- $Id: GameEnergyBasedEvilHack.lua 1566 2015-08-05 04:21:12Z dsb $
-- ToME - Tales of Middle-Earth
-- Copyright (C) 2012 Scott Bigham
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Scott Bigham "Zizzo"
-- dsb-tome@killerbbunnies.org

local GameEnergyBased = require 'engine.GameEnergyBased'

-- Spectacularly Evil and Annoying Hack(TM):  Override GameEnergyBased:tick()
-- to run :actBase() on entities in game.entities, as it does for on-level
-- entities in :tickLevel().  We tried to do this by defining a :tick()
-- method in mod.class.Game, but the engine wouldn't use it.
GameEnergyBased.tick = function(self)
  engine.Game.tick(self)

  -- Give some energy to entities
  if self.level then
    self:tickLevel(self.level)
    local mainlev = self.level

    for name, level in pairs(self.level.sublevels) do
      self.level = level
      self:tickLevel(level)
      if self.level ~= level then mainlev = self.level end
    end
    self.level = mainlev
  end

  local arr = self.entities
  for i, e in pairs(arr) do
    e = arr[i]
    if e and e.act and e.energy then
      -- Hack(TM):  This is the bit we've added.
      if e.actBase and e.energyBase then
	if e.energyBase < self.energy_to_act then
	  e.energyBase = e.energyBase + self.energy_per_tick
	end
	if e.energyBase >= self.energy_to_act then
	  e:actBase(self)
	end
      end

      if e.energy.value < self.energy_to_act then
	e.energy.value = (e.energy.value or 0) + self.energy_per_tick * (e.energy.mod or 1) * (e.global_speed or 1)
      end
      if e.energy.value >= self.energy_to_act then
	e.energy.used = false
	e:act(self)
      end
    end
  end

  self.turn = self.turn + 1
  self:onTurn()
end
