-- $Id: TimedEffectSource.lua 2644 2016-11-26 00:37:58Z dsb $
-- ToME - Tales of Middle-Earth
-- Copyright (C) 2012 Scott Bigham
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Scott Bigham "Zizzo"
-- dsb-tome@killerbbunnies.org

require "engine.class"

module(..., package.seeall, class.make)

function _M:init(eff, src, no_src)
  assert(eff, 'no effect def')
  assert(src or no_src, 'no effect source')
  self.eff = eff
  self.src = src
  self.is_effect_source = true
end

function _M:getName(t)
  local eff_name = self.eff.src_desc or self.eff.desc
  if self.src then
    local src_name = self.src.getName and self.src:getName(t) or self.src.name or 'something'
    eff_name = eff_name .. ' from ' .. src_name
  end
  return eff_name
end

function _M:resolveSource()
  return self.src
end
