-- $Id: NPCFields.lua 1610 2015-08-19 23:19:07Z dsb $
-- ToME - Tales of Middle-Earth
-- Copyright (C) 2012 Scott Bigham
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Scott Bigham "Zizzo"
-- dsb-tome@killerbbunnies.org

require 'engine.class'

-- Handles field definitions for NPC tooltips.
module(..., package.seeall, class.make)

_M.field_desc = {}

-- Load definitions of field descriptions for NPC tooltips.
function _M:loadFieldDescriptions(file)
  local env = {
    newFieldDesc = function(grp, f, desc) self:newFieldDesc(grp, f, desc) end,
  }
  local f, err = util.loadfilemods(file, setmetatable(env, {__index = _G}))
  if not f and err then error(err) end
  f()
end

-- Define a single NPC field description.
function _M:newFieldDesc(grp, f, desc)
  self.field_desc[grp] = self.field_desc[grp] or {}
  self.field_desc[grp][f] = desc
  table.insert(self.field_desc[grp], f)
end
