-- $Id: init.lua 2720 2017-01-27 03:47:27Z dsb $
-- ToME - Tales of Middle-Earth
-- Copyright (C) 2012 Scott Bigham
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Scott Bigham "Zizzo"
-- dsb-tome@killerbbunnies.org

name = "T.o.M.E Classic"
long_name = "Tales of Middle Earth (T2) for T-Engine4"
short_name = "tome2"
author = { "Scott Bigham", "dsb-tome@killerbunnies.org" }
homepage = "http://www.killerbunnies.org/angband/"
version = { 0, 2, 5 }
engine = { 1,4,9,"te4" }
description = [[
The original Tales of Middle Earth v2.3.9 (or a reasonable approximation thereof) ported to the TE4 engine.

See the "#LIGHT_BLUE#Credits#LAST#" entry on the game menu for credits for the module.
]]
starter = "mod.load"

no_get_name = true	-- Handle name juggling ourself.
allow_userchat = true	-- Let's be social, why not? ;)

-- Honor the censor_boot setting.
background_name = config.settings.censor_boot and {"tome3"} or {"tome","tome2","tome3"}

-- [Note to self:  search log for "Wait finished, counted NNN, MMM ticks"
--  after a "done loading module" for our module; NNN is the number we want
--  here.]
loading_wait_ticks = 134

load_tips = {
  { text = [[This is a test.  This is only a test.]] },
  { text = '[WATCH THIS SPACE]' },
  { text = '[Sorry, not implemented (random tip)]' },
  { text = 'Congratulations!  You found the secret easter egg!' },
  { text = 'Error:  Random tip not found, file RandomTips.lua line 4269' },
  { text = 'The quickest way to safely kill Great Wyrms of Power is to' },
  { text = 'Dungeon construction in progress.  Hard hats required beyond this point.' },
  { text = [[Accepted quest 'Beta tester'! (Press 'Ctrl-Q' to see the quest log)]] },
  { text = [[You identify:  the Long Sword 'Excalibur' (+15,+15) (+3) {yeah, no...}]] },
  { text = [[You can see exactly how close you are to starving by setting the "Food display" game option.]] },
  { text = [[You can deliberately walk onto and trigger a trap by typing Ctrl-Shift-D while standing next to it.]] },
  { text = [[The 'Show antimagic field' option will let you see how close you need to get to those filthy spellcasters to stop them casting their spells at you.]] },
}
